/*初始化Canvas*/
var lastTime = 0;
initCanvas = function (e) {
    canvas = document.getElementById("chess");
    images = images || {};
    ss = ss || {};
    ss.chess_slim_ = chessList;
    ss.f_atlas_ = effectList;
    if (window.stage && typeof wrapperFunc != 'undefined') {
        stage.off("stagemousedown", wrapperFunc);
    }
    stage = new createjs.Stage(canvas);
    // stage.enableMouseOver(10);
    createjs.Touch.enable(stage);
    wrapperFunc = stage.on("stagemousedown", comm.stageClick);
    chessLayer = new createjs.Container;
    chessLayer.mouseEnabled = !1;
    chessLayer.mouseChildren = !1;
    chessTopLayer = new createjs.Container;
    chessTopLayer.mouseEnabled = !1;
    chessTopLayer.mouseChildren = !1;
    chessBottomLayer = new createjs.Container;
    chessBottomLayer.mouseEnabled = !1;
    chessBottomLayer.mouseChildren = !1;
    chessTopLayer.x = chessLayer.x = 0;
    chessTopLayer.y = chessLayer.y = 0;
    stage.addChild(chessBottomLayer);//放置棋盘、白色大光圈
    stage.addChild(chessLayer);//放置棋子
    stage.addChild(chessTopLayer);//放置绿色提示点
    // createjs.Ticker.setFPS(60)
    createjs.Ticker.framerate = 65;
    createjs.Ticker.timingMode = createjs.Ticker.RAF_SYNCHED;
    createjs.Ticker.addEventListener("tick", (e) => {
        let measuredFPS = createjs.Ticker.getMeasuredFPS();
       // console.log(measuredFPS,"weiwei")
        !e.paused && stage.update();
    });
}
enterFrame = function () {
    var e = new Date,
        a = e.getTime(),
        m = a - lastTime;
    Math.round(1e3 / m);
    lastTime = a
}
initCanvasById = function (e, id) {
    canvas2 = document.getElementById(id);
    images = images || {};
    ss = ss || {};
    ss.chess_slim_ = chessList;
    ss.f_atlas_ = effectList;
    stage2 = new createjs.Stage(canvas2);
}
initSounds = function (type) {
    createjs.Sound.removeAllSounds();
    createjs.Sound.registerSound("../../assets/audio/select.mp3", "select");
    createjs.Sound.registerSound("../../assets/audio/drop.mp3", "drop");
    if (type == 1) {
        createjs.Sound.registerSound("../../assets/audio/chess_man/gameLose.mp3", "gameLose");
        createjs.Sound.registerSound("../../assets/audio/chess_man/gameWin.mp3", "gameWin");
        createjs.Sound.registerSound("../../assets/audio/chess_man/gameEat.mp3", "gameEat");
        createjs.Sound.registerSound("../../assets/audio/chess_man/gameError.mp3", "gameError");
        createjs.Sound.registerSound("../../assets/audio/chess_man/gameChecked.mp3", "gameChecked");
        createjs.Sound.registerSound("../../assets/audio/chess_man/gameStalemate.mp3", "gameStalemate");
        createjs.Sound.registerSound("../../assets/audio/chess_man/gameCheckmate.mp3", "gameCheckmate");
        for (var i = 0; i < default_message.length; i++) {
            createjs.Sound.registerSound("../../assets/audio/message_man/" + default_message[i].name + ".mp3", default_message[i].name);
        }
        for (var j = 0; j < default_count.length; j++) {
            createjs.Sound.registerSound("../../assets/audio/count_man/" + default_count[j] + ".mp3", 'count' + default_count[j])
        }
    } else {
        createjs.Sound.registerSound("../../assets/audio/chess_woman/gameLose.mp3", "gameLose");
        createjs.Sound.registerSound("../../assets/audio/chess_woman/gameWin.mp3", "gameWin");
        createjs.Sound.registerSound("../../assets/audio/chess_woman/gameEat.mp3", "gameEat");
        createjs.Sound.registerSound("../../assets/audio/chess_woman/gameError.mp3", "gameError");
        createjs.Sound.registerSound("../../assets/audio/chess_woman/gameChecked.mp3", "gameChecked");
        createjs.Sound.registerSound("../../assets/audio/chess_woman/gameStalemate.mp3", "gameStalemate");
        createjs.Sound.registerSound("../../assets/audio/chess_woman/gameCheckmate.mp3", "gameCheckmate");
        for (var i = 0; i < default_message.length; i++) {
            createjs.Sound.registerSound("../../assets/audio/message_woman/" + default_message[i].name + ".mp3", default_message[i].name);
        }
        for (var j = 0; j < default_count.length; j++) {
            createjs.Sound.registerSound("../../assets/audio/count_woman/" + default_count[j] + ".mp3", 'count' + default_count[j])
        }
    }
}
initSounds2 = function () {
    createjs.Sound.removeAllSounds();
    // createjs.Sound.alternateExtensions = ["mp3"];
    // createjs.Sound.registerPlugins([createjs.WebAudioPlugin, createjs.HTMLAudioPlugin]);
    createjs.Sound.registerSound("../../assets/audio/select.mp3", "select");
    createjs.Sound.registerSound("../../assets/audio/drop.mp3", "drop");
    createjs.Sound.registerSound("../../assets/audio/chess_man/gameLose.mp3", "gameLose");
    createjs.Sound.registerSound("../../assets/audio/chess_man/gameWin.mp3", "gameWin");
    createjs.Sound.registerSound("../../assets/audio/chess_man/gameEat.mp3", "gameEat");
    createjs.Sound.registerSound("../../assets/audio/chess_man/gameError.mp3", "gameError");
    createjs.Sound.registerSound("../../assets/audio/chess_man/gameChecked.mp3", "gameChecked");
    createjs.Sound.registerSound("../../assets/audio/chess_man/gameStalemate.mp3", "gameStalemate");
    createjs.Sound.registerSound("../../assets/audio/chess_man/gameCheckmate.mp3", "gameCheckmate");
}
/*棋盘参数初始化*/
initChess = function (e) {
    var e = e || InitMap;
    initBoard();
    comm.init(e);
    initDPLB();
}
/*编辑中的棋盘参数初始化*/
initChessEx = function (e) {
    var e = e || InitMap;
    initBoard();
    comm.init(e, !0);
    initDPLB();
}
/*棋盘初始化*/
initBoard = function (type) {
    if (type) {
        board2 = new lib.Board;
        verticalReverseboard2 = new lib.VerticalReverseBoard;
    } else {
        board = new lib.Board;
        verticalReverseboard = new lib.VerticalReverseBoard;
        if (mode == playmode.EDITBOARD) {
            board.y = BOARD_EDIT_CHANGE;
            verticalReverseboard.y = BOARD_EDIT_CHANGE;
            comm.pointStartX = (CANVAS_W - SPACE_W * 9) / 2;
            comm.pointStartY = (CANVAS_H - SPACE_H * 10 - 10) / 2 + BOARD_EDIT_CHANGE;
        }
    }
    if (isVerticalReverse == 1) {
        type ? stage2.addChildAt(verticalReverseboard2, 0) : chessBottomLayer.addChild(verticalReverseboard);
    } else {
        type ? stage2.addChildAt(board2, 0) : chessBottomLayer.addChild(board);
    }
    type ? stage2.update() : stage.update();
}
initBoardByVertical = function (vertical) {
    if (vertical) {
        verticalReverseboard2 = new lib.VerticalReverseBoard;
        stage2.addChildAt(verticalReverseboard2, 0)
    } else {
        board2 = new lib.Board;
        stage2.addChildAt(board2, 0)
    }
    stage2.update()
}
/*棋盘重置*/
resizeBoard = function () {
    if (mode == playmode.EDITBOARD) {
        comm.pointStartX = (CANVAS_W - SPACE_W * 9) / 2;
        comm.pointStartY = (CANVAS_H - SPACE_H * 10 - 10) / 2 + BOARD_EDIT_CHANGE;
        board.y = BOARD_EDIT_CHANGE;
        verticalReverseboard.y = BOARD_EDIT_CHANGE;
    } else {
        comm.pointStartX = (CANVAS_W - SPACE_W * 9) / 2;//距离左侧位置
        comm.pointStartY = (CANVAS_H - SPACE_H * 10 - 10) / 2;//距离上边位置
        board.y = 0;
        verticalReverseboard.y = 0;
    }
}
/*刷新函数*/
var lastTipsData=[];
var lastTipsData2=[];
var lastTipsData3=[];
replayBtnUpdate = function () {
    if (comm.isAnimating) {
        setTimeout(function () {
            replayBtnUpdate();
        }, 200);
        return;
    }
    if (mode == playmode.TREE) return;
    moves = comm.getMoves4Server();
    var isFirst = comm.isFirst();
    var isEnd = comm.isEnd();

    if (mode == playmode.AIPLAY) {
        setEnable("prevBtn", !isFirst);
        setEnable("autoreplayBtn", true);
    } else {
        setEnable("firstBtn", !isFirst);
        setEnable("prevBtn", !isFirst);
        setEnable("nextBtn", !isEnd);
        setEnable("endBtn", !isEnd);
        setEnable("autoreplayBtn", isanalyse);
    }
    if (mode == playmode.REPLAY) {
        vue.title = chessdata.title + '(' + movesIndex + '/' + moves.length + ')'
        setEnable("autoreplayBtn", true);
        if (isEnd) {
            clearInterval(autoreplayset);
        }
    }

    if (document.getElementById("chessDetailTbody")) {
        chessDetail = '';
        for (var a = 0; a < moves.length; a++) {
            changestep = '';
            childs = comm.nodes[moves[a].pater].child;
            if (childs.length > 1) {
                for (var b = 0; b < childs.length; b++) {
                    if (childs[b] == moves[a].id) {
                        changestep = childs.length + String.fromCharCode((65 + b));
                        break;
                    }
                }
            }
            if (a == movesIndex - 1) {
                movestep = "<font color=\"#0000FF\">" + moves[a].stepcn;
            } else {
                movestep = moves[a].stepcn;
            }
            if (mode == playmode.AIPLAY) {
                if (a % 2 == 0) {
                    chessDetail += "<tr><td>" + (parseInt(a / 2) + 1) + "</td><td>" + movestep + "</td><td>" + changestep + "</td>";
                } else {
                    chessDetail += "<td>" + movestep + "</td><td>" + changestep + "</td></tr>";
                }
            } else {
                if (a % 2 == 0) {
                    chessDetail += "<tr><td>" + (parseInt(a / 2) + 1) + "</td><td onclick=chessDetailTest(" + a + ")>" + movestep + "</td><td>" + changestep + "</td>";
                } else {
                    chessDetail += "<td onclick=chessDetailTest(" + a + ")>" + movestep + "</td><td>" + changestep + "</td></tr>";
                }
            }
        }
        document.getElementById("chessDetailTbody").innerHTML = chessDetail;
    }
    if (mode == playmode.ANALYSE || mode == playmode.CHESSANALYSE || mode == playmode.AIPLAY) {
        var node = comm.getCurrentNode();
        if (node) {
            if (mode == playmode.ANALYSE && (vue.currentAnalyseData.show == false || vue.currentAnalyseData.index == 0)) {
                for (var a = 0; a < node.openbookDetail.length; a++) {
                    var tempmap = comm.arr2Clone(comm.map);
                    if (!node.openbookDetail[a].move && node.openbookDetail[a].step) {
                        if (isVerticalReverse == 1) {
                            node.openbookDetail[a].move = comm.createMove(tempmap, reverseStep(node.openbookDetail[a].step));
                        } else {
                            node.openbookDetail[a].move = comm.createMove(tempmap, node.openbookDetail[a].step);
                        }
                    }
                }
                for (var b = 0; b < node.chessdbDetail.length; b++) {
                    var tempmap = comm.arr2Clone(comm.map);
                    if (!node.chessdbDetail[b].move && node.chessdbDetail[b].step) {
                        if (isVerticalReverse == 1) {
                            node.chessdbDetail[b].move = comm.createMove(tempmap, reverseStep(node.chessdbDetail[b].step));
                        } else {
                            node.chessdbDetail[b].move = comm.createMove(tempmap, node.chessdbDetail[b].step);
                        }
                    }
                }
                for (var i = 0; i < node.computerDetail.length; i++) {
                    var tempmap = comm.arr2Clone(comm.map);
                    if (!node.computerDetail[i].move && node.computerDetail[i].step) {
                        if (isVerticalReverse == 1) {
                            node.computerDetail[i].move = comm.createMove(tempmap, reverseStep(node.computerDetail[i].step));
                        } else {
                            node.computerDetail[i].move = comm.createMove(tempmap, node.computerDetail[i].step);
                        }
                    }
                    var tempArr = node.computerDetail[i].list;
                    var tempMap = comm.arr2Clone(comm.map);
                    var tmpStr = '';
                    if (!node.computerDetail[i].tmpStr) {
                        for (var j = 0; j < tempArr.length; j++) {
                            if (tempArr[j]) {
                                if (isVerticalReverse == 1) {
                                    var move = comm.createMove(tempMap, reverseStep(tempArr[j]));
                                } else {
                                    var move = comm.createMove(tempMap, tempArr[j]);
                                }
                                tmpStr += move + ' ';
                            }
                        }
                        node.computerDetail[i].tmpStr = tmpStr;
                    }
                }
                replyBtnUpdate2(node);
                console.log(JSON.stringify(node.openbookDetail));
                if (mode==playmode.ANALYSE){
                    if (isAnalyseChess){
                        isAnalyseChess=false;
                        if (vue.openList.length==0){
                            isShowEmpty=true;
                        }
                    }
                }
                if (node.openbookDetail.length == 0 && node.chessdbDetail.length == 0) {
                    if (node.tipsStep.length == 2 && vue.displayLine) {
                        if (vue.startLibrary === 4) {
                            if (lastTipsData.toString() !== node.tipsStep.toString()) {
                                cleanLine();
                                lastTipsData = node.tipsStep.slice();
                                console.log("showTipsStep61");
                                showTipsStep(node.tipsStep[0], 1);
                                showTipsStep(node.tipsStep[1], 2);
                            }
                        } else {
                            cleanLine();
                            lastTipsData = node.tipsStep.slice();
                            console.log("showTipsStep6");
                            showTipsStep(node.tipsStep[0], 1);
                            showTipsStep(node.tipsStep[1], 2);
                        }
                    }
                    if (node.tipsStep.length == 1 && vue.displayLine) {
                        if (vue.startLibrary === 4) {
                            if (lastTipsData2.toString() !== node.tipsStep.toString()) {
                                cleanLine();
                                lastTipsData2 = node.tipsStep.slice();
                                console.log("showTipsStep7");
                                showTipsStep(node.tipsStep[0], 1);
                            }
                        } else {
                            cleanLine();
                            lastTipsData2 = node.tipsStep.slice();
                            console.log("showTipsStep7");
                            showTipsStep(node.tipsStep[0], 1);
                        }
                    }
                } else {
                    if (node.openbookDetail && node.openbookDetail.length != 0) {
                        if (vue.displayLine) {
                            console.log("DLIne1");
                            if (vue.startLibrary === 4) {
                                if (lastTipsData3.toString() !== node.tipsStep.toString()) {
                                    console.log("DLIne2");
                                    cleanLine();
                                    lastTipsData3 = node.tipsStep.slice();
                                    console.log("showTipsStep81");
                                    showTipsStep(node.openbookDetail[0].step, 4);
                                }
                            } else if (vue.startLibrary === 3) {
                                cleanLine();
                                lastTipsData3 = node.tipsStep.slice();
                                if (node.openbookDetail[0].fenValue == "??") {
                                    if (node.tipsStep && node.tipsStep.length == 2) {
                                        showTipsStep(node.tipsStep[0], 1);
                                        showTipsStep(node.tipsStep[1], 2);
                                    }
                                } else {
                                    showTipsStep(node.openbookDetail[0].step, 4);
                                }
                            } else {
                                cleanLine();
                                lastTipsData3 = node.tipsStep.slice();
                                console.log("showTipsStep8");
                                showTipsStep(node.openbookDetail[0].step, 4);
                            }
                        }
                    } else {
                        if (vue.displayLine) {
                            if (lastTipsData3.toString()!==node.tipsStep.toString()){
                                cleanLine();
                                lastTipsData3=node.tipsStep.slice();
                                console.log("showTipsStep9");
                            showTipsStep(node.chessdbDetail[0].step, 4);
                            }
                        }
                    }
                }
                if (node.score !== '' && node.score != null) vue.currentScore = node.score;
            }
            if (mode == playmode.CHESSANALYSE) {
                for (var i = 0; i < node.computerDetail.length; i++) {
                    var tempmap = comm.arr2Clone(comm.map);
                    if (!node.computerDetail[i].move && node.computerDetail[i].step) {
                        if (isVerticalReverse == 1) {
                            node.computerDetail[i].move = comm.createMove(tempmap, reverseStep(node.computerDetail[i].step));
                        } else {
                            node.computerDetail[i].move = comm.createMove(tempmap, node.computerDetail[i].step);
                        }
                    }
                }
                chessAnalyseShape();
            }

            if (mode === playmode.AIPLAY){
                if (node.score !== '' && node.score != null) vue.currentScore = node.score;
                if (node.depth !== '' && node.depth != null) vue.currentDepth = node.depth;
            }
            if (mode == playmode.AIPLAY && vue.displayLine) {
                console.log(JSON.stringify(node));
                if (comm.getHold() != computerHold) {
                    cleanLine();
                    showTipsStep(comm.nodes[movesIndex].tipsStep[0], 1);
                }
            }
        }
    }
    if (mode == playmode.CREATE && vue.displayLine){
        cleanLine();
        drawCreateLine(comm.nodes[currentId].openbookDetail);
    }
    displayBranch();
    if (comm.notes[currentId]) {
        vue.noteShow = true;
        vue.noteValue = comm.notes[currentId];
    } else {
        vue.noteShow = false;
    }
}
/*初始化白色光圈，绿色提示点，选中棋子特效，白色小圈*/
initDPLB = function () {
    for (var e = 0; 10 > e; e++) {
        for (var a = 0; 9 > a; a++) {
            var m = new res.Dot;
            o = comm.pointStartX + SPACE_W * a;
            n = comm.pointStartY + SPACE_H * e;
            m.x = o + SPACE_W / 2 - DOTS_W / 2;
            m.y = n + SPACE_H / 2 - DOTS_H / 2;
            m.visible = !1; //初始化绿色提示点的位置,跟棋盘棋子位置对应
            chessTopLayer.addChild(m);
            Dots[a.toString() + e.toString()] = m
        }
        dots = Dots
    }
    box1 = new res.Box;
    box1.visible = !1;
    chessLayer.addChild(box1);
    light = new res.Light;
    light.visible = !1;
    chessBottomLayer.addChild(light);
    border = new res.Border;
    border.visible = !1;
    chessBottomLayer.addChild(border);
}
resetDots = function () {
    for (var e = 0; 10 > e; e++) {
        for (var a = 0; 9 > a; a++) {
            dots[a.toString() + e.toString()].y -= BOARD_EDIT_CHANGE
        }
    }
}
/*编辑棋盘时候的棋子个数
*
*
* i代表 0是黑方，1是红方
* j代表第几列
*
*
* comm.pointStartX 代表棋子距离棋盘左右起始的宽度
* comm.pointStartY 代表棋子距离棋盘上下起始的宽度
*
*
*
* */
drawNum = function (i, j, n) {
    a = i * 6 + j;
    x = j * boardset.outsidescale;
    i == 0 ? y = boardset.boutside : y = boardset.routside;
    chessnum[a] = new createjs.Text(n, "20px Arial", "red");
    chessnum[a].x = comm.pointStartX + SPACE_W * x + SPACE_W * SCALE;
    chessnum[a].y = comm.pointStartY + SPACE_H * y;
    chessLayer.addChild(chessnum[a]);
}
function displayChessDefaultPos(red2black) {
    cleanDefaultChessEx();
    const redPieces = [
        images.che, images.ma, images.pao, images.redXiang, images.redShi, images.redBing
    ];
    const blackPieces = [
        images.che, images.ma, images.pao, images.blackXiang, images.blackShi, images.blackZu
    ];
    const xPositions = [0, 1, 2, 3, 4, 5];
    const ry = red2black ? boardset.boutside : boardset.routside;
    const by = red2black ? boardset.routside : boardset.boutside;
    const redYPosition = comm.pointStartY + SPACE_H * ry + 3;
    const blackYPosition = comm.pointStartY + SPACE_H * by + 3;
    defaultChessList = [];
    [redPieces, blackPieces].forEach((pieces, colorIndex) => {
        const yPosition = colorIndex === 0 ? redYPosition : blackYPosition;
        pieces.forEach((pieceImage, index) => {
            const x = comm.pointStartX + SPACE_W * xPositions[index] * boardset.outsidescale + 11;
            const chessPiece = createChessPiece(pieceImage, x, yPosition);
            defaultChessList.push(chessPiece);
            chessLayer.addChild(chessPiece);
        });
    });
}
function createChessPiece(image, x, y) {
    const bitmap = new createjs.Bitmap(image);
    bitmap.scaleX = 0.5;
    bitmap.scaleY = 0.5;
    bitmap.x = x;
    bitmap.y = y;
    return bitmap;
}
/*清除划线*/
cleanLine = function () {
    for (var a = 0; a < stagetext.length; a++) {
        if (stage.contains(stagetext[a])){
        stage.removeChild(stagetext[a]);
        }
        if (stage.contains(stageshape[a])){
        stage.removeChild(stageshape[a]);
        }
    }
    for (var a = 0; a < stageshape4.length; a++) {
        if (stage.contains(stageshape4[a])){
        stage.removeChild(stageshape4[a]);
        }
    }
    for (var a = 0; a < stageshape5.length; a++) {
        if (stage.contains(stageshape5[a])){
        stage.removeChild(stageshape5[a]);
        }
    }
}
/*清除分支*/
cleanLine2 = function () {
    for (var a = 0; a < stagetext2.length; a++) {
        stage.removeChild(stagetext2[a]);
    }
    for (var b = 0; b < stageshape2.length; b++) {
        stage.removeChild(stageshape2[b]);
    }
}
cleanLineBranch = function () {
    for (var a = 0; a < stagetext3.length; a++) {
        stage.removeChild(stagetext3[a]);
    }
    for (var b = 0; b < stageshape3.length; b++) {
        stage.removeChild(stageshape3[b]);
    }
}
/******修改后的弹窗********/
toastDisplay = function (text) {
    var _this = this.vue;
    _this.toastShow = true;
    _this.toastValue = text;
    setTimeout(function () {
        _this.toastShow = false;
    }, 1000);
}
/*显示控制板*/
showLight = function (x, y) {
    light.x = SPACE_W * x + comm.pointStartX + (SPACE_W - LIGHT_W) / 2;
    light.y = SPACE_H * y + comm.pointStartY + (SPACE_H - LIGHT_H) / 2;
    light.visible = !0;
}
/*隐藏控制板*/
hideLight = function () {
    light.visible = !1
}
/*显示控制板*/
showPane = function (x, y) {
    if (mode != playmode.EDITBOARD) {
        box1.x = SPACE_W * x + comm.pointStartX + (SPACE_W - BOX_W) / 2;
        box1.y = SPACE_H * y + comm.pointStartY + (SPACE_H - BOX_H) / 2;
        box1.visible = !0;
    }
}
/*隐藏控制板*/
hidePane = function () {
    box1.visible = !1
}
showBorder = function (x, y) {
    border.x = SPACE_W * x + comm.pointStartX + (SPACE_W - BORDER_W) / 2;
    border.y = SPACE_H * y + comm.pointStartY + (SPACE_H - BORDER_H) / 2;
    border.visible = !0;
}
hideBorder = function () {
    border.visible = !1;
}
/*显示提示点*/
showDots = function () {
    for (var e = 0; e < comm.dot.dots.length; e++) {
        var a = comm.dot.dots[e].join("");
        var m = dots[a];
        m.visible = !0
    }
}
/*隐藏提示点*/
hideDots = function () {
    for (var e in dots) {
        dots[e].visible = !1
    }
}
/*清空棋盘*/
cleanChess = function () {
    for (var e = 0; e < comm.map.length; e++) {
        for (var a = 0; a < comm.map[e].length; a++) {
            var m = comm.map[e][a];
            if (m) removeChess(m);
        }
    }
}
/*清空扩展棋盘*/
cleanChessEx = function () {
    for (var e = 0; e < comm.sMap.length; e++) {
        for (var a = 0; a < comm.sMap[e].length; a++) {
            var m = comm.sMap[e][a];
            if (m) removeChess(m);
        }
    }
    for (var a = 0; a < chessnum.length; a++) {
        chessLayer.removeChild(chessnum[a])
    }
}
/*清除默认占位棋子*/
cleanDefaultChessEx = function () {
    for (let i = 0; i < defaultChessList.length; i++) {
        if (chessLayer.contains(defaultChessList[i])){
        chessLayer.removeChild(defaultChessList[i])
        }
    }
    defaultChessList=[];
}
/*删除棋子*/
removeChess = function (e) {
    try {
        if (e && comm.mans[e]) {
            var o = comm.mans[e].chess;
            if (o.parent) {
                o.parent.removeChild(o)
            }
        }
    } catch (e) {
        reportBugly(8)
        // console.log(e);
    }
}
/*显示吃将杀等特效*/
showTip = function (div_id, a) {
    if (!isshowTip) {
        a = a || 2000;
        isshowTip = true;
        vue.gameResult = true;
        vue[div_id] = true;
        setTimeout(function () {
            comm.soundplay(div_id, 'chess');
        },200)
        setTimeout(function () {
            vue.gameResult = false;
            vue[div_id] = false;
            isshowTip = false;
        }, a - 1000);
    } else {
        setTimeout(function () {
            showTip(div_id, a);
        }, 1000);
    }
}
/********************复盘相关**************************/
/*显示提示走法*/
showTipsStep = function (e, a, type) {
    if (isVerticalReverse == 1 && !type) {
        e = reverseStep(e);
    }
    drawLine(e, a, type);
}
/*划线*/
drawLine = function (e, a, type) {
    if (e) {
        var m = e.split("");
        stageshape[a - 1] = new createjs.Shape();
        var graphics = stageshape[a - 1].graphics;
        var tempColor;
        var tempX = comm.pointStartX + SPACE_W / 2;
        var tempY = comm.pointStartY + SPACE_H / 2;
        if (a == 1) {
            comm.getHold() == BLACK ? tempColor = '#333333' : tempColor = '#e52323';
            stagetext[a - 1] = new createjs.Text('先', "20px Arial", "white");
        }
        if (a == 2) {
            comm.getHold() == BLACK ? tempColor = '#e52323' : tempColor = '#333333';
            stagetext[a - 1] = new createjs.Text('后', "20px Arial", "white");
        }
        if (a == 3 && type == 3) {
            tempColor = '#3388ff';
            stagetext[a - 1] = new createjs.Text('漏', "20px Arial", "white");
        }
        if (a == 3 && type == 4) {
            tempColor = '#3388ff';
            stagetext[a - 1] = new createjs.Text('错', "20px Arial", "white");
        }
        if (a == 4) {
            tempColor = '#644227';
            stagetext[a - 1] = new createjs.Text('官', "20px Arial", "white");
        }
        graphics.beginStroke(tempColor).setStrokeStyle(5, 'round', 'round');
        graphics.moveTo(tempX + SPACE_W * m[0], tempY + SPACE_H * m[1]).lineTo(tempX + SPACE_W * m[2], tempY + SPACE_H * m[3]);
        graphics.beginFill(tempColor).drawCircle(tempX + SPACE_W * m[2], tempY + SPACE_H * m[3], 12);
        stage.addChild(stageshape[a - 1]);
        stagetext[a - 1].textAlign = 'center';
        stagetext[a - 1].x = tempX + SPACE_W * m[2];
        stagetext[a - 1].y = tempY + SPACE_H * m[3] - 12;
        stage.addChild(stagetext[a - 1]);
        stage.update();
    }
}

drawCreateLine = function (listTips) {
    if (listTips && Array.isArray(listTips)) {
        var firstThree = listTips.slice(0, 3);
        if (firstThree.length > 0) {

            for (var i = firstThree.length - 1; i >= 0; i--) {
                var a = i + 1;
                var item = firstThree[i];
                var m;
                if (isVerticalReverse == 1) {
                    m = reverseStep(item.step);
                } else {
                    m = item.step.split("");
                }


                var lineColor='#00aa00';
                var tempColor;
                comm.getHold() == BLACK ? tempColor = '#333333' : tempColor = '#e52323';

                stageshape4[a - 1] = new createjs.Shape();
                var graphics = stageshape4[a - 1].graphics;
                var tempX = comm.pointStartX + SPACE_W / 2;
                var tempY = comm.pointStartY + SPACE_H / 2;
                graphics.setStrokeStyle(8, 'round', 'round').beginStroke(lineColor);
                var x1 = tempX + SPACE_W * m[0], x2 = tempX + SPACE_W * m[2];
                var y1 = tempY + SPACE_H * m[1], y2 = tempY + SPACE_H * m[3];
                var k = (y2 - y1) / (x2 - x1);
                var angle = x2 - x1 < 0 ? 180 + Math.atan(k) / (Math.PI / 180) : Math.atan(k) / (Math.PI / 180);
                var aa = x2 + 15 * (x1 - x2) / Math.sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2));
                var bb = y2 + 15 * (y1 - y2) / Math.sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2));
                graphics.moveTo(x1, y1).lineTo(x2, y2);
                graphics.beginFill(lineColor).drawPolyStar(aa, bb, 15, 3, 0, angle);
                stage.addChild(stageshape4[a - 1]);


                stageshape[a - 1] = new createjs.Shape();
                var graphics = stageshape[a - 1].graphics;
                var tempX = comm.pointStartX + SPACE_W / 2;
                var tempY = comm.pointStartY + SPACE_H / 2;
                graphics.beginStroke(lineColor).setStrokeStyle(5, 'round', 'round');
                graphics.moveTo(tempX + SPACE_W * m[0], tempY + SPACE_H * m[1]).lineTo(tempX + SPACE_W * m[2], tempY + SPACE_H * m[3]);
                stage.addChild(stageshape[a - 1]);

            }
            for (var i = firstThree.length - 1; i >= 0; i--) {
                var a = i + 1;
                var item = firstThree[i];
                var m;
                if (isVerticalReverse == 1) {
                    m = reverseStep(item.step);
                } else {
                    m = item.step.split("");
                }

                var x1 = tempX + SPACE_W * m[0], x2 = tempX + SPACE_W * m[2];
                var y1 = tempY + SPACE_H * m[1], y2 = tempY + SPACE_H * m[3];

                stageshape5[a - 1] = new createjs.Shape();
                var graphics5 = stageshape5[a - 1].graphics;
                var aaa = x2 + 28 * (x1 - x2) / Math.sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2));
                var bbb = y2 + 28 * (y1 - y2) / Math.sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2));
                graphics5.beginFill(tempColor).drawCircle(aaa, bbb, 15);
                stage.addChild(stageshape5[a - 1]);


            }
            for (var i = firstThree.length - 1; i >= 0; i--) {
                var a = i + 1;
                var item = firstThree[i];
                var m;
                if (isVerticalReverse == 1) {
                    m = reverseStep(item.step);
                } else {
                    m = item.step.split("");
                }

                var x1 = tempX + SPACE_W * m[0], x2 = tempX + SPACE_W * m[2];
                var y1 = tempY + SPACE_H * m[1], y2 = tempY + SPACE_H * m[3];

                var aaa = x2 + 28 * (x1 - x2) / Math.sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2));
                var bbb = y2 + 28 * (y1 - y2) / Math.sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2));

                stagetext[a - 1] = new createjs.Text("" + a, "20px Arial", "white");
                stagetext[a - 1].textAlign = 'center';
                stagetext[a - 1].textBaseline = 'middle';

                stagetext[a - 1].x = aaa;
                stagetext[a - 1].y = bbb;

                stage.addChild(stagetext[a - 1]);

            }
        }
    }
    stage.update();

}



drawLine3 = function (e, a, type) {
    if (e) {
        var m = e.split("");
        stageshape[a - 1] = new createjs.Shape();
        var graphics = stageshape[a - 1].graphics;
        var tempX = comm.pointStartX + SPACE_W / 2;
        var tempY = comm.pointStartY + SPACE_H / 2;
        if (type == 3) {
            stagetext[a - 1] = new createjs.Text('漏', "20px Arial", "white");
        } else if (type == 4) {
            stagetext[a - 1] = new createjs.Text('错', "20px Arial", "white");
        }
        graphics.beginStroke("#3388ff").setStrokeStyle(5, 'round', 'round');
        graphics.moveTo(tempX + SPACE_W * m[0], tempY + SPACE_H * m[1]).lineTo(tempX + SPACE_W * m[2], tempY + SPACE_H * m[3]);
        graphics.beginFill("#3388ff").drawCircle(tempX + SPACE_W * m[2], tempY + SPACE_H * m[3], 12);
        stage2.addChild(stageshape[a - 1]);
        stagetext[a - 1].textAlign = 'center';
        stagetext[a - 1].x = tempX + SPACE_W * m[2];
        stagetext[a - 1].y = tempY + SPACE_H * m[3] - 12;
        stage2.addChild(stagetext[a - 1]);
        stage2.update();
    }
}
/*模拟分支提示信息*/
drawLineBranch = function (e, a) {
    if (e) {
        var m = e.split("");
        stageshape3[a - 1] = new createjs.Shape();
        var graphics = stageshape3[a - 1].graphics;
        var tempX = comm.pointStartX + SPACE_W / 2;
        var tempY = comm.pointStartY + SPACE_H / 2;
        graphics.beginStroke("#2ba346").setStrokeStyle(4, 'round', 'round');
        graphics.moveTo(tempX + SPACE_W * m[0], tempY + SPACE_H * m[1]).lineTo(tempX + SPACE_W * m[2] - 2, tempY + SPACE_H * m[3] + 2);
        graphics.moveTo(tempX + SPACE_W * m[0], tempY + SPACE_H * m[1]).lineTo(tempX + SPACE_W * m[2] + 2, tempY + SPACE_H * m[3] + 2);
        graphics.moveTo(tempX + SPACE_W * m[0], tempY + SPACE_H * m[1]).lineTo(tempX + SPACE_W * m[2] + 2, tempY + SPACE_H * m[3] + 2);
        // graphics.moveTo(tempX + SPACE_W * m[0], tempY + SPACE_H * m[1]).lineTo(tempX + SPACE_W * m[0] - 2, tempY + SPACE_H * m[1] - 2);
        var x1 = tempX + SPACE_W * m[0], x2 = tempX + SPACE_W * m[2];
        var y1 = tempY + SPACE_H * m[1], y2 = tempY + SPACE_H * m[3];
        var aaa = x2 + 20 * (x1 - x2) / Math.sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2));
        var bbb = y2 + 20 * (y1 - y2) / Math.sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2));
        var hasCommon=false;
        var countPath = comm.getBrachLength();
        for (var i = 0; i < countPath; i++) {
            if (i !== a-1) {
                var childID = comm.nodes[currentId].child[i];
                var stepForList = comm.nodes[childID].step;
                if (stepForList) {
                    var mStepForList = stepForList.split("");
                    const x2ForList = tempX + SPACE_W * mStepForList[2];
                    const y2ForList = tempY + SPACE_H * mStepForList[3];
                    if (x2 === x2ForList && y2 === y2ForList) {
                        hasCommon = true;
                    }
                }
            }
        }
        if (hasCommon){
            graphics.beginFill("#2ba346").drawCircle(aaa, bbb, 12);
        }else {
        graphics.beginFill("#2ba346").drawCircle(tempX + SPACE_W * m[2], tempY + SPACE_H * m[3], 12);
        }
        stage.addChild(stageshape3[a - 1]);
        stagetext3[a - 1] = new createjs.Text(a, "20px Arial", "white");
        stagetext3[a - 1].textAlign = 'center';
        if (hasCommon){
            stagetext3[a - 1].x = aaa;
            stagetext3[a - 1].y =bbb - 12;
        }else {
        stagetext3[a - 1].x = tempX + SPACE_W * m[2];
        stagetext3[a - 1].y = tempY + SPACE_H * m[3] - 12;
        }
        stage.addChild(stagetext3[a - 1]);
        stage.update();
    }
}
drawLineArrow = function (e, a, color) {
    var color = color || '#2ba346';
    if (e && vue.displayLine) {
        if (isVerticalReverse == 1) {
            e = reverseStep(e);
        }
        var m = e.split("");
        stageshape2[a - 1] = new createjs.Shape();
        var graphics = stageshape2[a - 1].graphics;
        var tempX = comm.pointStartX + SPACE_W / 2;
        var tempY = comm.pointStartY + SPACE_H / 2;
        graphics.setStrokeStyle(8, 'round', 'round').beginStroke(color);
        var x1 = tempX + SPACE_W * m[0], x2 = tempX + SPACE_W * m[2], x = x2 - x1;
        var y1 = tempY + SPACE_H * m[1], y2 = tempY + SPACE_H * m[3], y = y2 - y1;
        var k = (y2 - y1) / (x2 - x1);
        var angle = x2 - x1 < 0 ? 180 + Math.atan(k) / (Math.PI / 180) : Math.atan(k) / (Math.PI / 180);
        var aa = x2 + 15 * (x1 - x2) / Math.sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2));
        var bb = y2 + 15 * (y1 - y2) / Math.sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2));
        // var X1 = x1-y/Math.sqrt(3), Y1 = y1+x/Math.sqrt(3);
        // var res_a = x2 - 30*(X1-x2)/Math.sqrt((X1-x2)*(X1-x2)+(Y1-y2)*(Y1-y2));
        // var res_b = y2 + 30*(Y1-y2)/Math.sqrt((X1-x2)*(X1-x2)+(Y1-y2)*(Y1-y2));
        // var res_c = (2*res_b*k-2*y1*k-res_a*k*k+2*x1*k*k+res_a)/(1+k*k);
        // var res_d = res_b - (2*res_b-2*y1-2*res_a*k+2*x1*k)/(1+k*k);
        graphics.moveTo(x1, y1).lineTo(x2, y2);
        graphics.beginFill(color).drawPolyStar(aa, bb, 15, 3, 0, angle);
        // graphics.beginFill("#2ba346");
        // graphics.moveTo(x2,y2).lineTo(res_a,res_b).lineTo(res_c,res_d).lineTo(x2,y2);
        // graphics.endFill();
        // graphics.beginFill("#2ba346").drawCircle(x2,y2, 10);
        stage.addChild(stageshape2[a - 1]);
        // stagetext2[a - 1] = new createjs.Text(a, "20px Arial", "white");
        // stagetext2[a - 1].x = tempX + SPACE_W * m[2] - 5;
        // stagetext2[a - 1].y = tempY + SPACE_H * m[3] - 10;
        // stage.addChild(stagetext2[a - 1]);
        stage.update();
    }
}
drawCircleResult = function (e, a, text, color) {
    if (e) {
        if (isVerticalReverse == 1) {
            e = reverseStep(e);
        }
        var m = e.split("");
        stageshape2[a - 1] = new createjs.Shape();
        var graphics = stageshape2[a - 1].graphics;
        var tempX = comm.pointStartX + SPACE_W;
        var tempY = comm.pointStartY;
        graphics.beginFill(color).drawCircle(tempX + SPACE_W * m[2] - 8, tempY + SPACE_H * m[3] + 12, 18);
        if (!text) {
            graphics.beginFill("#ffffff").drawPolyStar(tempX + SPACE_W * m[2] - 8, tempY + SPACE_H * m[3] + 12, 14, 5, 0.6, -90);
        }
        stage.addChild(stageshape2[a - 1]);
        if (text) {
            stagetext2[a - 1] = new createjs.Text(text, "24px Arial", "white");
            stagetext2[a - 1].x = tempX + SPACE_W * m[2] - 8 - 13;
            stagetext2[a - 1].y = tempY + SPACE_H * m[3] + 12 - 15;
            stage.addChild(stagetext2[a - 1]);
        }
        stage.update();
    }
}
/*点击图表 路路*/
onClickChart = function (i, id, index) {
    if (id) {
        moves = comm.getMoves4Server(id);
    }
    movesIndex = i;
    comm.gotoStep(moves, movesIndex, index);
}
/*改变折线图的标记 路路*/
onChangeTip = function (index, seriesIndex) {
    if (vue.myChart) {
        var option = vue.myChart.getOption();
        if (typeof seriesIndex == 'undefined') {
            seriesIndex = vue.getSeries(currentId);
        }
        if (seriesIndex != vue.seriesIndex) {
            moves = comm.getMoves4Server(currentId);
            for (var i = 0; i < option.series.length; i++) {
                if (i == seriesIndex) {
                    vue.changeToolTip(seriesIndex, index);
                    if (comm.nodes[vue.branchList[seriesIndex].ID[index]].score > 0) {
                        option.tooltip[0].backgroundColor = 'rgba(255,0,0,.8)';
                    } else if (comm.nodes[vue.branchList[seriesIndex].ID[index]].score == 0) {
                        option.tooltip[0].backgroundColor = 'rgba(43,163,70,.8)';
                    } else {
                        option.tooltip[0].backgroundColor = 'rgba(0,0,0,.8)';
                    }
                    option.series[i].lineStyle.color = '#ffffff';
                    option.series[i].emphasis.lineStyle.color = '#ffffff';
                    option.series[i].lineStyle.width = 2;
                    option.series[i].emphasis.lineStyle.width = 2;
                } else {
                    option.series[i].lineStyle.color = '#dcc5b3';
                    option.series[i].emphasis.lineStyle.color = '#dcc5b3';
                    option.series[i].lineStyle.width = 1;
                    option.series[i].emphasis.lineStyle.width = 1;
                }
            }
        } else {
            vue.changeToolTip(seriesIndex, index);
            if (comm.nodes[vue.branchList[seriesIndex].ID[index]].score > 0) {
                option.tooltip[0].backgroundColor = 'rgba(255,0,0,.8)';
            } else if (comm.nodes[vue.branchList[seriesIndex].ID[index]].score == 0) {
                option.tooltip[0].backgroundColor = 'rgba(43,163,70,.8)';
            } else {
                option.tooltip[0].backgroundColor = 'rgba(0,0,0,.8)';
            }
            if (option.series[seriesIndex]){
                option.series[seriesIndex].lineStyle.color = '#ffffff';
                option.series[seriesIndex].emphasis.lineStyle.color = '#ffffff';
                option.series[seriesIndex].lineStyle.width = 2;
                option.series[seriesIndex].emphasis.lineStyle.width = 2;
            }
        }
        vue.myChart.setOption(option, true);
    }
}
/*显示分支分支*/
displayBranch = function () {
    cleanLineBranch();
    var countPath = comm.getBrachLength();
    if (countPath > 1) {
        for (var j = 0; j < countPath; j++) {
            var childID = comm.nodes[currentId].child[j];
            var step = comm.nodes[childID].step;
            drawLineBranch(step, j + 1);
        }
    }
}
/*清除显示信息*/
cleanDetail = function () {
    cleanArrowDetail();
    cleanComputerDetail();
    cleanChessdbDetail();
    cleanOpenBookDetail();
}
/*清除引擎信息*/
cleanComputerDetail = function () {
    if (vue.middleList) {
        vue.middleList = [];
    }
}
/*清除线条缓存*/
cleanArrowDetail = function () {
    lastTipsData=[];
    lastTipsData2=[];
    lastTipsData3=[];
}
/*清除云库信息*/
cleanChessdbDetail = function () {
    if (vue.endList) {
        vue.endList = [];
    }
}
/*清除开局库信息*/
cleanOpenBookDetail = function () {
    if (vue.openList) {
        vue.openList = [];
    }
    var node = node || comm.getCurrentNode();
    if (node && node.openbookDetail && node.openbookDetail.length != 0){
        node.openbookDetail=[]
    }
}
replyBtnUpdate2 = function (node) {
    var node = node || comm.getCurrentNode();
    if (node.openbookDetail && node.openbookDetail.length != 0) {
        if (vue.startLibrary===3){
            if (flagWaitAjax){
        vue.openList = node.openbookDetail;
            }
        }else {
            vue.openList = node.openbookDetail;
        }

        vue.analyseIndex = 0;
    }
    if (node.computerDetail && node.computerDetail.length != 0) {
        console.log("刷新引擎");
        vue.middleList = node.computerDetail;

        vue.displayMiddleList=vue.middleList;
        vue.displayMiddleList.sort(function (a, b) {
            return b.depth - a.depth;
        })
        // vue.analyseType = '旋风引擎';
        // vue.analyseIndex = 1;
    }
    if (node.chessdbDetail && node.chessdbDetail.length != 0) {
        vue.endList = node.chessdbDetail;
        vue.analyseType = '残局库';
        vue.analyseIndex = 2;
    }
}
/*响应列表点击事件*/
chessDetailTest = function (i) {
    movesIndex = i + 1;
    moves = comm.getMoves4Server();
    comm.gotoStep(moves, movesIndex);
    replayBtnUpdate();
}

/***新功能****/
getMovesList = function () {
    var returnMoves = [];
    var tempStep = '';
    for (var i = 0; i < moves.length; i++) {
        tempStep = isVerticalReverse ? reverseStep(moves[i].step) : moves[i].step;
        returnMoves.push(tempStep);
    }
    return returnMoves
}
getTotalFen = function (step, notTotal) {
    try {
        if (!moves) {
            if (notTotal) {
                return comm.getCurrentNode().currentFen;
            } else {
                return comm.getCurrentNode().currentFen + ' - - 0 0';
            }
        }
        var chiNums = 0;
        if (step) {
            var step = isVerticalReverse ? comm.Step2XY(reverseStep(step)) : comm.Step2XY(step);
            var map = comm.arr2Clone(comm.map);
            var nowManKey = map[step.src.y][step.src.x];
            var resultKey = map[step.dst.y][step.dst.x];
            var eatKey = '';
            if (resultKey) {
                eatKey = resultKey;
            }
            var nowMan = comm.mans[nowManKey];
            delete map[nowMan.y][nowMan.x];
            map[step.dst.y][step.dst.x] = nowManKey;
            for (var i = 0; i < movesIndex; i++) {
                if (moves[i].eatKey) {
                    chiNums = 0;
                } else {
                    chiNums++;
                }
            }
            if (eatKey) {
                chiNums = 0;
            } else {
                chiNums++;
            }
            if (notTotal) {
                return comm.getBoard2(map);
            } else {
                return comm.getBoard2(map) + ' - - ' + chiNums + ' ' + Math.round((movesIndex + 1) / 2);
            }
        } else {
            for (var i = 0; i < movesIndex; i++) {
                if (moves[i].eatKey) {
                    chiNums = 0;
                } else {
                    chiNums++;
                }
            }
            if (notTotal) {
                return comm.getCurrentNode().currentFen;
            } else {
                return comm.getCurrentNode().currentFen + ' - - ' + chiNums + ' ' + Math.round(movesIndex / 2);
            }
        }
    } catch (error) {
        reportBugly(9);
    }
}
comm.getBoard2 = function (mapdata, isBegin) {
    var map = '';
    comm.getReverse() ? (map = mapdata ? arrReverse(mapdata) : arrReverse(comm.arr2Clone(comm.map))) : (map = mapdata ? mapdata : comm.arr2Clone(comm.map));
    var key = "";
    var coutZero = 0;
    var board = "";
    for (var i = 0; i < 10; i++) {
        coutZero = 0;
        for (var j = 0; j < 9; j++) {
            key = map[i][j];

            if (!key) {
                coutZero++;
                continue;
            }
            if (coutZero > 0) {
                board += "" + coutZero;
                coutZero = 0;
            }
            board += comm.getFenKey(key);
        }
        if (coutZero > 0) {
            board += "" + coutZero;
            coutZero = 0;
        }
        if (i < (map.length - 1)) {
            board += "/";
        }
    }
    comm.getHold(isBegin) == 1 ? (board += " b") : (board += " w");
    return board;
}
onTreeMove = function (step) {
    if (isVerticalReverse == 1) {
        var move = comm.Step2XY(reverseStep(step));
    } else {
        var move = comm.Step2XY(step);
    }
    Player.selected(move.src);
    Player.clickBoard(move.dst);
    waitServerPlay = !1;
}
cleanLineTree = function () {
    for (var a = 0; a < stageshape2.length; a++) {
        stage.removeChild(stageshape2[a]);
    }
}

chessAnalyseShape = function () { //优 良 中 差 错 漏 官 星星
    var node = comm.clone(comm.getCurrentNode());
    if (currentId > 0) {
        cleanLine2();
        if (movesIndex > 1) {
            var lastNode = moves[movesIndex - 2];
        } else {
            var lastNode = comm.nodes[0];
        }
        if (node.isKjk) {
            drawLineArrow(isVerticalReverse ? reverseStep(node.step) : node.step, 2);
        } else {
            drawLineArrow(lastNode.tipsStep[0], 2);
        }
        vue.currentAnalyseData = getAnalyseObj(lastNode, node);
    } else {
        vue.currentAnalyseData = {};
    }
}
getAnalyseObj = function (lastNode, node, notDraw) {
    if (isVerticalReverse) {
        var tempStep = reverseStep(node.step);
    } else {
        var tempStep = node.step;
    }
    var tempObj = {};
    tempObj.correctStep = lastNode.tipsStep && lastNode.tipsStep[0] || '';
    tempObj.step = tempStep;
    tempObj.correctMove = lastNode.computerDetail && lastNode.computerDetail[0] && lastNode.computerDetail[0].move || '';
    tempObj.move = node.stepcn;
    tempObj.correctScore = lastNode.score;
    tempObj.score = node.score || lastNode.score;
    tempObj.correctColor = '#2ba346';
    tempObj.index = movesIndex;
    tempObj.hold = comm.getOppHold();
    if (lastNode.computerDetail && lastNode.computerDetail.length!==0) {
        tempObj.correctList = lastNode.computerDetail[0].list;
    }
    if (node.computerDetail && node.computerDetail[0]) {
        tempObj.list = node.computerDetail[0].list;
    }
    if (node.isKjk) {
        tempObj.grade = '官';
        tempObj.color = '#644227';
    } else if (lastNode.tipsStep[0] == tempStep) {
        tempObj.correctColor = '#a86f41';
        tempObj.grade = '';
        tempObj.color = '#2ba346';
        tempObj.correctScore = node.score;
    } else {
        if (comm.isOffensive == node.index % 2) {
            var tempScore = lastNode.score - node.score;
        } else {
            var tempScore = node.score - lastNode.score;
        }
        if (tempScore > 0) {
            tempObj.grade = '优';
            tempObj.color = '#2ba38e';
        } else if (Math.abs(tempScore) > 20000 && (comm.getHold() == RED ? lastNode.score < -29000 : lastNode.score > 29000)) {
            tempObj.grade = '漏';
            tempObj.color = '#e52323';
        } else if (Math.abs(tempScore) > 200) {
            tempObj.grade = '错';
            tempObj.color = '#e52323';
        } else if (Math.abs(tempScore) > 150 && Math.abs(tempScore) <= 200) {
            tempObj.grade = '差';
            tempObj.color = '#fe8905';
        } else if (Math.abs(tempScore) > 100 && Math.abs(tempScore) <= 150) {
            tempObj.grade = '中';
            tempObj.color = '#999999';
        } else if (Math.abs(tempScore) > 50 && Math.abs(tempScore) <= 100) {
            tempObj.grade = '良';
            tempObj.color = '#3388ff';
        } else if (Math.abs(tempScore) >= 0 && Math.abs(tempScore) <= 50) {
            tempObj.grade = '优';
            tempObj.color = '#2ba38e';
        }
    }
    if (!notDraw) {
        drawCircleResult(tempStep, 1, tempObj.grade, tempObj.color);
    }
    return tempObj;
}
getRetryObj = function (isKjk, isCorrect, score, lastId) {
    var tempObj = {};
    if (isKjk) {
        tempObj.grade = '官';
        tempObj.color = '#644227';
    } else if (isCorrect) {
        tempObj.correctColor = '#a86f41';
        tempObj.grade = '';
        tempObj.color = '#2ba346';
        tempObj.correctScore = score;
    } else {
        if (comm.isOffensive == (lastId + 1) % 2) {
            var tempScore = comm.nodes[lastId].score - score;
        } else {
            var tempScore = score - comm.nodes[lastId].score;
        }
        if (tempScore > 0) {
            tempObj.grade = '优';
            tempObj.color = '#2ba346';
        } else if (Math.abs(tempScore) > 20000 && (comm.isOffensive == (lastId + 1) % 2 ? comm.nodes[lastId].score < -29000 : comm.nodes[lastId].score > 29000)) {
            tempObj.grade = '漏';
            tempObj.color = '#e52323';
        } else if (Math.abs(tempScore) > 200) {
            tempObj.grade = '错';
            tempObj.color = '#e52323';
        } else if (Math.abs(tempScore) > 150 && Math.abs(tempScore) <= 200) {
            tempObj.grade = '差';
            tempObj.color = '#fe8905';
        } else if (Math.abs(tempScore) > 100 && Math.abs(tempScore) <= 150) {
            tempObj.grade = '中';
            tempObj.color = '#999999';
        } else if (Math.abs(tempScore) > 50 && Math.abs(tempScore) <= 100) {
            tempObj.grade = '良';
            tempObj.color = '#3388ff';
        } else if (Math.abs(tempScore) >= 0 && Math.abs(tempScore) <= 50) {
            tempObj.grade = '优';
            tempObj.color = '#2ba346';
        }
    }
    return tempObj;
}

//小棋盘相关操作
secondGoToStep = function (moves, index, map) {
    cleanLine2();
    hideDots();
    hideBorder();
    hideLight();
    hidePane();
    cleanChess();
    comm.init(map || comm.cMap, !0);
    if (moves) {
        for (var e = 0; e < index; e++) {
            if (map) {
                var tempStep = moves[e];
                if (isVerticalReverse) {
                    tempStep = reverseStep(tempStep);
                }
            } else {
                var tempStep = moves[e].step;
            }
            var step = comm.Step2XY(tempStep);
            var nowManKey = comm.map[step.src.y][step.src.x];
            var resultKey = comm.map[step.dst.y][step.dst.x];
            if (resultKey) {
                var man = comm.mans[resultKey];
                man.isShow = !1;
                if (man.chess.parent) {
                    man.chess.parent.removeChild(man.chess)
                }
            }
            var nowMan = comm.mans[nowManKey];
            delete comm.map[nowMan.y][nowMan.x];
            comm.map[step.dst.y][step.dst.x] = nowManKey;
            nowMan.x = step.dst.x;
            nowMan.y = step.dst.y;
            nowMan.move();
            if (e == (index - 1)) {
                showPane(step.src.x, step.src.y);
                showLight(step.dst.x, step.dst.y);
            }
        }
    }
}
showTips = function (x, y) {
    tips = new createjs.Bitmap(images.Loading);
    tips.regX = tips.regY = 45;//设置图形的X和Y轴位移
    tips.x = SPACE_W * x + comm.pointStartX + (SPACE_W - 90) / 2 + 45;
    tips.y = SPACE_H * y + comm.pointStartY + (SPACE_H - 90) / 2 + 45;
    stage.addChild(tips);
    createjs.Tween.get(tips, { loop: true }).to({
        scaleX: 1,
        scaleY: 1
    }, 500).to({
        scaleX: 1.2,
        scaleY: 1.2
    }, 500).to({
        scaleX: 1,
        scaleY: 1
    }, 500);
}
hideTips = function () {
    if (tips) {
        createjs.Tween.removeTweens(tips);
        stage.removeChild(tips);
        tips = '';
    }
}
