var before = 0;
var after = 0;
apiready = function () {
    mypomelo = api.require('mypomelo');
    vue = new Vue({
        el: '#main',
        mixins: [mixin],
        data: {
            deleTimer:null,
            deleClick:false,
            deleItem:null,
            pageShareType: 'index_wzxq',
            showTabBar: true,
            tabActive: 2,
            currentBannerId: 0,
            qipuList: [],
            pageIndex: 1,
            loading: true,
            finished: false,
            isLoading: false,
            indexTab: true, //右下角圆圈
            beforeTop: 0,
            afterTop: 0,
            target: '',
            loadEnd: false,
            qipanLoading: true,
            nowDays: {
                year: '',
                month: '',
                day: ''
            },
            topTab: [
                { text: '棋力评测', class: 'gra_blue', icon: 'iconduizhanpingtai', url: 'play_chess/qlcp' },
                { text: '好友对战', class: 'gra_orange', icon: 'iconhaoyouduizhan', url: 'play_chess/create_room' },
                { text: 'AI博弈', class: 'gra_purple', icon: 'iconai1', url: 'play_chess/ai' },
                { text: '棋社', class: 'gra_blue', icon: 'iconshequ4', url: 'play_chess/association' },
                { text: '人机对战', class: 'gra_purple', icon: 'iconjiqiren1', url: 'chess/ai' },
                { text: 'AI分析', class: 'gra_green', icon: 'iconcaidanlanfupanlanse', url: 'chess/analyse' },
                { text: '排行榜', class: 'gra_blue', icon: 'iconpaihangbang1', url: 'play_chess/rank_list' },
                { text: '我的棋谱', class: 'gra_red', icon: 'iconwenkuguanli', url: 'frame/frame4' },
            ],
            bannerList: [],
            connected: false, //监控ws是否已经连接成功
            mySwiper: '',
            winWidth: 0,
            newMessage: 0,
            lessonList:[],
            followList:null
        },
        created: function () {
            var _this = this;
            this.init();
            this.initData();
            this.initDays();
            this.initMessage();
            this.getUserInfo();
            api.addEventListener({
                name: 'refreshQipu'
            }, function (ret, err) {
                if (ret) {
                    _this.onRefresh();
                }
            });
            document.getElementById('loading').innerText = '';
         

        },
        methods: {
            initMessage: function () {
                mySendMessage(mysetting.routes.getMessageNums, {}, function (data) {
                    if (data.errno == 0) {
                        vue.newMessage = data.data.nums;
                        api.setAppIconBadge({
                            badge: data.data.nums
                        });
                    }
                });
            },
            initData: function () {
                this.ajaxPost(xqwxt_url + "&do=common&op=getChessBanner", {}, function (vm, ret) {
                    vm.bannerList = ret.data.banner;
                    vm.topTab = ret.data.topTab;
                    setTimeout(function () {
                        if (vm.mySwiper) {
                            vm.mySwiper.update()
                        } else {
                            vm.mySwiper = new Swiper('.my-swipe', {
                                loop: true,
                                autoplay: {
                                    delay: 2500,
                                    disableOnInteraction: false,//用户操作swiper之后是否禁止自动切换
                                },
                                pagination: {
                                    el: '.swiper-pagination',
                                }
                            })
                        }
                    }, 100)
                })
                let that=this
                mySendMessage(mysetting.routes.getFollowsFans, {
                    page: 1,
                    op: 'follows',
                    infoUid: uid
                }, function (ret) {
                    that.followList = []
                    mySendMessage(mysetting.routes.getTableList, {}, function (data) {
                        let roomList = {};
                        for (let vo of data.data) {
                            roomList[vo.usersInfo[0].uid] = {
                                roomId: vo.roomID,
                                role: vo.usersInfo[0].role,
                            };
                            roomList[vo.usersInfo[1].uid] = {
                                roomId: vo.roomID,
                                role: vo.usersInfo[1].role,
                            };
                        }
                        for (let i = 0; i < 2; i++) {
                            if (
                                ret.data[i] &&
                                ret.data[i].roomType == "qlcp" &&
                                (ret.data[i].role == 1 || ret.data[i].role == 2)
                            ) {
                                if (roomList[ret.data[i].uid]) {
                                    ret.data[i].room = roomList[ret.data[i].uid];
                                    that.followList.push(ret.data[i]);
                                }
                            }
                        }
                        if (that.followList.length == 0) {
                            if (data.data.length > 0) {
                                that.followList.push({
                                    uid: data.data[0].usersInfo[0].uid,
                                    nickname: data.data[0].usersInfo[0].nickname,
                                    strengthname: data.data[0].usersInfo[0].strengthname,
                                    avatar: data.data[0].usersInfo[0].avatar,
                                    room: roomList[data.data[0].usersInfo[0].uid]
                                })
    
                            }
                            if (data.data.length > 1) {
                                that.followList.push({
                                    uid: data.data[1].usersInfo[0].uid,
                                    nickname: data.data[1].usersInfo[0].nickname,
                                    strengthname: data.data[1].usersInfo[0].strengthname,
                                    avatar: data.data[1].usersInfo[0].avatar,
                                    room: roomList[data.data[1].usersInfo[0].uid]
                                })
                            }
                        } else if (that.followList.length == 1) {
                            for (let i in data.data) {
                                let k = -1;
                                if (data.data[i].usersInfo[0].uid != this.followList[0].uid) {
                                    k = 0
                                } else if (data.data[i].usersInfo[0].uid != this.followList[1].uid) {
                                    k = 1
                                }
                                if (k != -1) {
                                    that.followList.push({
                                        uid: data.data[i].usersInfo[k].uid,
                                        nickname: data.data[i].usersInfo[k].nickname,
                                        strengthname: data.data[i].usersInfo[k].strengthname,
                                        avatar: data.data[i].usersInfo[k].avatar,
                                        room: roomList[data.data[i].usersInfo[k].uid]
                                    })
                                    break
                                }
                            }
                        }
                    });
                })

            },
            clickBanner: function (item) {
                if (!item) return;
                if (item.type == 'window') {
                    this.openPage(item.path, item.params);
                } else {
                    var browser = api.require('webBrowser');
                    if (item.path.indexOf('?') == -1) {
                        browser.open({
                            url: item.path + '?appuid=' + this.memberinfo.uid
                        });
                    } else {
                        browser.open({
                            url: item.path + '&appuid=' + this.memberinfo.uid
                        });
                    }

                }
            },
            onChange: function (index) {
                this.currentBannerId = index;
            },
            onRefresh: function () {
                var _this = this;
                this.pageIndex = 1;
                this.finished = false;
                this.initData();
                setTimeout(function () {
                    _this.getList(1);
                }, 300);
            },
            qlcp_lookon (roomID, status) {
                var _this = this;
                _this.roleStatus=status;
                localStorage.setItem('roleStatus', status);
                if (roomID) {
                    mySendMessage(mysetting.routes.joinRoom, {roomID: roomID}, function (data) {
                        if (data.errno == 0) {
                            if (data.data.playData) {
                                if ( data.data.roomType == 'hydz' || data.data.roomType == 'QS') {
                                    _this.openPage('play_chess/create_room', {role: status});
                                } else {
                                    _this.openPage('play_chess/qlcp',{'showLoading':true});
                                }
                            }
                        } else {
                            _this.$dialog.alert({
                                title: '提醒',
                                message: data.message,
                                confirmButtonColor: '#3388ff'
                            }).then(function () {
                                _this.rebackHall();
                            });
                        }
                    });
                }
            },
            getList: function (type) {
                var _this = this;
                _this.ajaxPost(xqwxt_url + "&do=search&op=getLesson", {
                    sort:'time',
                    page: _this.pageIndex
                }, function (vm, ret) {
                    if (_this.pageIndex == 1) {
                        _this.lessonList = [];
                    }
                    if (ret.errno == 0) {
                        for (var i = 0; i < ret.data.length; i++) {
                            _this.lessonList.push(ret.data[i]);
                        }
                        _this.loading = false;
                        _this.isLoading = false;
                        _this.finished = false;
                        if(ret.data.length<10){
                            _this.finished = true;
                        }
                        _this.pageIndex++;
                    } else {
                        _this.loading = false;
                        _this.isLoading = false;
                        _this.finished = true;
                    }
                });

            },
            getResultStr(result){
                let msg=''
                if(result['win']){
                    msg = result['win']+"胜"
                }
                if(result['lose']){
                    msg += (result['win']?"/":"") + result['lose']+"负"
                }
                if(result['draw']){
                    msg += (result['lose']?"/":"") + result['draw']+"和"
                }
                return msg
            },
            touchDele:function(e,item){
                // e.preventDefault();
                 let _this=this
                 _this.deleItem=item
                 _this.deleClick = false 
                  _this.deleTimer = setTimeout(function(){
                 _this.deleClick=true
                 _this.$dialog.confirm({
                     title: '删除棋谱',
                     message: '确认删除棋谱吗？',
                     closeOnClickOverlay:true
                 }).then(function() {
              
                     _this.ajaxPost(xqwxt_url+'&op=delete_index_chess&do=chess', { chessid: _this.deleItem.id }, function(vm,data) {
                        // data = $.parseJSON(data);
                         console.log(data.message,123456);
                         vm.$toast({
                             message: data.message,
                         })
                         setTimeout(function(){
                             _this.pageIndex = 1;
                             _this.getList(1);
                         },1000)
                     });
                 }).catch(() => {
                    // on cancel
                    console.log('取消')
                  });
                  },500)
                 return false
             },
             touchDeleMove(){
                 clearTimeout(this.deleTimer)
                 this.deleClick=true
                 
             },
             touchDeleEnd(){
             
                 clearTimeout(this.deleTimer)
                 if(!this.deleClick){
                     this.openPage('chess/chess', {role: (this.deleItem.reduid==this.uid?1:2), chessid: this.deleItem.id })
                 }
                 
             },
            initDays: function () {
                var now = new Date();
                this.nowDays.year = now.getFullYear();
                this.nowDays.month = now.getMonth() + 1;
                this.nowDays.day = now.getDate();
            },
            handleScroll: function (e) {
                this.afterTop = e.target.documentElement.scrollTop || e.target.body.scrollTop;
                if (this.afterTop <= this.beforeTop) {
                    this.indexTab = true;
                    this.beforeTop = this.afterTop;
                } else {
                    this.indexTab = false;
                    this.beforeTop = this.afterTop;
                }
            },
            init: function () {
                var loader = new createjs.LoadQueue(false, null, "");
                loader.on("fileload", this.handleFileLoad);
                loader.on("complete", this.handleComplete);
                loader.loadFile({ src: "../../script/util/ZobristTable.js" });
                loader.loadFile({ src: "../../script/lib/easeljs.min.js", id: 'Easeljs' });
                loader.loadFile({ src: "../../script/lib/tweenjs.min.js" });
                loader.loadFile({ src: "../../script/Model.js" });
                loader.loadFile({ src: "../../script/View.js" });
                loader.loadFile({ src: "../../script/Control.js" });
                loader.loadFile({ src: "../../script/Player.js" });
                loader.loadFile({ src: "../../script/Chess.js" });
                loader.loadFile({ src: "../../script/lib/gameRes.js" });
                loader.loadManifest([
                    { src: "../../assets/images/board.png", id: "Board", loadTimeout: 20000 },
                    { src: "../../assets/images/border1.png", id: "Border1", loadTimeout: 20000 },
                    { src: "../../assets/images/border2.png", id: "Border2", loadTimeout: 20000 },
                    { src: "../../assets/images/vertical1.png", id: "Vertical1", loadTimeout: 20000 },
                    { src: "../../assets/images/vertical2.png", id: "Vertical2", loadTimeout: 20000 }
                ]);
            }, //初始化加载资源
            handleFileLoad: function (evt) {
                if (evt.item.type == "image") {
                    images[evt.item.id] = evt.result;
                }
                if (evt.item.id == 'Easeljs') {
                    chessList = new createjs.SpriteSheet(CHESS_SLIM);
                    effectList = new createjs.SpriteSheet(F_ATLAS);
                }
            },
            handleComplete: function (evt) {
                if (chessList.complete && effectList.complete) {
                    this.target = evt;
                    this.loadEnd = true;
                    this.qipanLoading = false;
                    this.getList();
                } else {
                    chessList.addEventListener("complete", function () {
                        vue.handleComplete();
                    });
                    effectList.addEventListener("complete", function () {
                        vue.handleComplete();
                    });
                }
            }
        },
    });
}