var messageTimeout;
var messageTimeout2;
var messageTimeout3;
//匹配成功
function onQlcpListener() {
    mypomelo.on({ route: 'onMsg_gameStart' }, function (data) {
        if (data.errno == 0) {
            var s_c_body = data.data;
            if (typeof vue.scenePlay === "function" && vue.pageType == s_c_body.roomType) {
                vue.scenePlay(s_c_body);
            } else {
                if (s_c_body.roomType == 'hydz' || s_c_body.roomType == 'QS') {
                    vue.openPage('play_chess/create_room');
                } else if (s_c_body.roomType == 'qlcp') {
                    vue.openPage('play_chess/qlcp');
                } else {
                    vue.openPage('play_chess/ai_test');
                }
            }
        } else {
            vue.$toast(data.message);
        }
    });
    mypomelo.on({ route: 'onKick' }, function (data) {
        mypomelo.disconnect();
        vue.dialogType = dialog_login;
    });
    mypomelo.on({ route: 'onMsg_invitePlay' }, function (data) {
        if (data.errno == 0) {
            if (data.data.result) { //消息格式，uid,nickname,agree(false OR true)
                if (vue.popup_unit) vue.popup_unit.show = false;
                if (!data.data.agree) {
                    popupDisplay('对方拒绝了你的约战请求', false, 1.5);
                }
            } else { //约战请求,收到战书。消息格式，uid,nickname,
                vue.getBookInfo.uid = data.data.uid;
                vue.getBookInfo.nickname = data.data.nickname;
                vue.getBookInfo.headimg = data.data.avatar; //头像也需要展示
                vue.getBookInfo.time = 5;
                vue.getBook = true;
                zhanshu_timer = setInterval(function () {
                    vue.getBookInfo.time--;
                    if (vue.getBookInfo.time <= 0 || !vue.getBook) {
                        vue.getBook = false;
                        clearInterval(zhanshu_timer);
                    }
                }, 1000);
            }
        } else {
            vue.$toast(data.message);
        }
    });
    ///公共结束
    mypomelo.on({ route: 'onMsg_matchTable' }, function (data) {
        if (data.errno == 0) {
            var temp = data.data.players;
            if (temp[0].uid == vue.uid) {
                vue.role = temp[0].role;
                var temp_temp = temp[0];
                temp[0] = temp[1];
                temp[1] = temp_temp;
                vue.chairId = 0;
            } else {
                vue.role = temp[1].role;
                vue.chairId = 1;
            }
            vue.dialogType = dialog_default;
            // vue.playersInfo = temp;
            vue.redBlack = true;
            if (vue.pageType == 'AI') {
                var lo = localStorage.getItem('ruleAIHide');
            } else {
                var lo = localStorage.getItem('ruleHide');
            }
            if (lo && lo == '1') {
                vue.popupRule = false;
            } else {
                vue.popupRule = true;
            }
        } else {
            vue.$toast(data.message);
        }
    });
    mypomelo.on({ route: 'onMsg_check' }, function (data) {
        //console.log("onMsg_check"+JSON.stringify(data)+"==="+vue.role)
        if (data.errno == 0) {
            if (!vue.qipanLoading && comm.map && !vue.iscontinue && vue.role != 3) {
                var currentFen = comm.getBoard();
                if ((currentFen != data.data.map || data.data.movesIndex != movesIndex || data.data.current_user != vue.current_user) && !waitServerPlay) {
                    popupDisplay('局面同步中，请稍后', true);
                    mySendMessage(mysetting.routes.getPlayData, {}, function (data) {
                        if (data.errno == 0) {
                            vue.scenePlay(data.data.playData,isVerticalReverse);
                            vue.popup_unit.show = false;
                        } else {
                            vue.$toast(data.message);
                        }
                    })
                } else {
                    var s_c_body = data.data;
                    if (vue.role == 1) {
                        vue.player_times = vue.exchangeAB(s_c_body.player_times);
                    } else if (vue.role == 2) {
                        vue.player_times = s_c_body.player_times;
                    } else {
                        if (isVerticalReverse == 1) {
                            vue.player_times = s_c_body.player_times;
                        } else {
                            vue.player_times = vue.exchangeAB(s_c_body.player_times);
                        }
                    }
                    vue.player_status[0].total_time = vue.player_times[0].steptimeTotal;
                    vue.player_status[1].total_time = vue.player_times[1].steptimeTotal;
                    // console.log('onMsg_check: ' + s_c_body.current_user)
                    if (isVerticalReverse == 1) {
                        if (s_c_body.current_user != 0) {
                            vue.player_status[1].display = true;
                            vue.player_status[1].currentRate = vue.player_times[1].steptime / vue.player_status[1].total_time * 100;
                        } else {
                            vue.player_status[0].display = true;
                            vue.player_status[0].currentRate = vue.player_times[0].steptime / vue.player_status[0].total_time * 100;
                        }
                    } else {
                        if (s_c_body.current_user == 0) {
                            vue.player_status[1].display = true;
                            vue.player_status[1].currentRate = vue.player_times[1].steptime / vue.player_status[1].total_time * 100;
                        } else {
                            vue.player_status[0].display = true;
                            vue.player_status[0].currentRate = vue.player_times[0].steptime / vue.player_status[0].total_time * 100;
                        }

                    }
                    vue.onTime();
                }
            }
        } else {
            vue.$toast(data.message);
        }
    });
    mypomelo.on({ route: 'onMsg_chessMove' }, function (data) {
        if (data.errno == 0) {
            if (vue.qipanLoading) return;
            var s_c_body = data.data;
            //走棋统一用这个接口
            if (comm.getBoard() != s_c_body.prev_board && s_c_body.move_chess_user != vue.chairId && !waitServerPlay) {
                popupDisplay('局面同步中，请稍后', true);
                mySendMessage(mysetting.routes.getPlayData, {}, function (data) {
                    if (data.errno == 0) {
                        vue.scenePlay(data.data.playData,isVerticalReverse);
                    } else {
                        vue.$toast(data.message);
                    }
                    vue.popup_unit.show = false;
                })
                return;
            }
            if (s_c_body.move_chess_user != vue.chairId) {
                Player.serverAIPlay(s_c_body.move_chess_data.from_pos.x + '' + s_c_body.move_chess_data.from_pos.y + '' + s_c_body.move_chess_data.to_pos.x + '' + s_c_body.move_chess_data.to_pos.y);
                eatKey = '';
                state = 0;
            }
            vue.move_step = s_c_body.move_chess_data.from_pos.x + '' + s_c_body.move_chess_data.from_pos.y + '' + s_c_body.move_chess_data.to_pos.x + '' + s_c_body.move_chess_data.to_pos.y;
            if (isVerticalReverse == 1) {
                vue.move_step = reverseStep(vue.move_step);
            }
            onRefreshTimes();
            if (mode == playmode.ONLINE) {
                var action = Player.analyseAction(data.data.action);
                if (action == 'jiangjun') {
                    showTip("gameChecked");
                } else if (action == 'chi') {
                    showTip("gameEat");
                } else if (action == 'zhuo') {
                    toastDisplay('捉');
                } else if (action == 'sha') {
                    toastDisplay('杀棋');
                } else if (action == 'juesha') {
                    showTip("gameCheckmate");
                } else if (action == 'kunbi') {
                    showTip("gameStalemate");
                }
            }
            vue.current_user = s_c_body.current_user;
            vue.player_status[0].currentRate = 100;
            vue.player_status[1].currentRate = 100;
            vue.player_status[0].display = false;
            vue.player_status[1].display = false;
            if (vue.role != 3) {
                if (s_c_body.move_chess_user != vue.chairId) {
                    vue.$set(vue.player_times, 0, s_c_body.player_time);
                    vue.player_status[1].display = true;
                } else {
                    vue.$set(vue.player_times, 1, s_c_body.player_time);
                    vue.player_status[0].display = true;
                }
            } else {
                if (isVerticalReverse == 1) {
                    if (s_c_body.current_user == 0) {
                        vue.$set(vue.player_times, 1, s_c_body.player_time);
                        vue.player_status[0].display = true;
                    } else {
                        vue.$set(vue.player_times, 0, s_c_body.player_time);
                        vue.player_status[1].display = true;
                    }
                } else {
                    if (s_c_body.current_user == 0) {
                        vue.$set(vue.player_times, 0, s_c_body.player_time);
                        vue.player_status[1].display = true;
                    } else {
                        vue.$set(vue.player_times, 1, s_c_body.player_time);
                        vue.player_status[0].display = true;
                    }
                }
            }
            vue.player_status[0].total_time = vue.player_times[0].steptime;
            vue.player_status[1].total_time = vue.player_times[1].steptime;
        } else {
            vue.$toast(data.message);
        }
    });
    mypomelo.on({ route: 'onMsg_chessAction' }, function (data) {
        if (data.errno == 0) {
            // if (mode == playmode.ONLINE) {
            //     var action = Player.analyseAction(data.data.action);
            //     if (action == 'jiangjun') {
            //         showTip("gameChecked");
            //     } else if (action == 'chi') {
            //         showTip("gameEat");
            //     } else if (action == 'zhuo') {
            //         toastDisplay('捉');
            //     } else if (action == 'sha') {
            //         toastDisplay('杀棋');
            //     } else if (action == 'juesha') {
            //         showTip("gameCheckmate");
            //     } else if (action == 'kunbi') {
            //         showTip("gameStalemate");
            //     }
            // }
        } else {
            // vue.$toast(data.message);
        }
    });
    mypomelo.on({ route: 'onMsg_gameEnd' }, function (data) {
        if (data.errno == 0) {
            var s_c_body = data.data;
            vue.qlcp_result.reason = s_c_body.gameOver.reason;
            vue.qlcp_result.winner = s_c_body.gameOver.result;
            vue.qlcp_result.endData = s_c_body.xqwxt_game_end_data;
            var myDate = new Date();
            vue.qlcp_result.steps = Math.ceil(s_c_body.steps / 2);
            vue.qlcp_result.time = (myDate.getMonth() + 1) + '月' + myDate.getDate() + '日' + myDate.getHours() + ":" + myDate.getMinutes();
            vue.qlcp_result.memberinfo.red = s_c_body.players[0];
            vue.qlcp_result.reduid = s_c_body.players[0].uid;
            vue.qlcp_result.blackuid = s_c_body.players[1].uid;
            vue.qlcp_result.memberinfo.black = s_c_body.players[1];
            vue.qlcp_result.chessid = s_c_body.xqwxt_game_end_data.chessid;
            vue.qlcp_result.fen = s_c_body.xqwxt_game_end_data.fen;
            vue.qlcp_result.type = s_c_body.type;
            vue.qlcp_result.upgrade = s_c_body.xqwxt_game_end_data.upgrade;
            vue.qlcp_result.nextNum = s_c_body.xqwxt_game_end_data.nextNum;
            onGameOver();
        } else {
            vue.$toast(data.message);
        }
    });
    mypomelo.on({ route: 'onMsg_resetRoom' }, function (data) {
        if (data.errno == 0) {
            vue.prepare(data.data);
        } else {
            vue.$toast(data.message);
        }
    });
    mypomelo.on({ route: 'onMsg_changeCreator' }, function (data) {
        if (data.errno == 0) {
            vue.$dialog.alert({
                title: '提醒',
                message: data.message,
                confirmButtonColor: '#3388ff'
            }).then(function () {
                vue.isCreator = true;
                if (vue.readyBegin.gameTime == 0) {
                    vue.activeRule.show = true
                }
            })
        } else {
            vue.$toast(data.message);
        }
    });
    //用户加入房间,在房间的人收到消息后进行处理，进房间的人收到此消息忽略
    mypomelo.on({ route: 'onMsg_userEnter' }, function (data) {
        if (data.errno == 0) {
            if (data.data.uid != uid) {
                if (data.data.role == 1 || data.data.role == 2) {
                    if (vue.role != 1 && vue.role != 2) {
                        data.data.role == 1 ? vue.$set(vue.playersInfo, 1, data.data) : vue.$set(vue.playersInfo, 0, data.data);
                    } else {
                        vue.$set(vue.playersInfo, 0, data.data);
                    }
                } else {
                    vue.pangguanList.push(data.data);
                    vue.pangguanPerson++;
                }
            }
        } else {
            vue.$toast(data.message);
        }
    });
    mypomelo.on({ route: 'onMsg_leaveRoom' }, function (data) {
        if (data.errno == 0) {
            var uid = data.data.uid;
            if (data.data.role == 3) {
                vue.pangguanPerson--;
                for (var i in vue.pangguanList) {
                    if (vue.pangguanList[i].uid == uid) {
                        vue.pangguanList.splice(i, 1);
                        break;
                    }
                }
            } else {
                if (vue.pageType == 'hydz' || vue.pageType == 'QS') {
                    for (var i in vue.playersInfo) {
                        if (vue.playersInfo[i].uid == uid) {
                            vue.$set(vue.playersInfo, i, comm.clone(user_base_info));
                            break;
                        }
                    }
                }
            }
        } else {
            vue.$toast(data.message);
        }
    });
    mypomelo.on({ route: 'onMsg_voteApply' }, function (data) {
        if (data.errno == 0) {
            if (data.data.result) {
                if (data.data.type == 1) {
                    if (data.data.agree) {
                        toastDisplay('对方同意悔棋');
                    } else {
                        toastDisplay('对方不同意悔棋');
                    }
                } else if (data.data.type == 2) {
                    if (data.data.agree) {
                        toastDisplay('对方同意求和');
                    } else {
                        toastDisplay('对方不同意求和');
                    }
                }
                setTimeout(function () {
                    vue.$set(vue.popup_unit, 'show', false);
                }, 100);
            } else {
                if (data.data.type == 1) {
                    vue.dialogType = comm.clone(dialog_agree_huiqi);
                    timer = setInterval(function () {
                        vue.dialogType.time--;
                        if (vue.dialogType.time < 0) {
                            handle_agree(1, false);
                        }
                    }, 1000);
                } else if (data.data.type == 2) {
                    vue.dialogType = comm.clone(dialog_agree_qiuhe);
                    timer = setInterval(function () {
                        vue.dialogType.time--;
                        if (vue.dialogType.time < 0) {
                            handle_agree(2, false);
                        }
                    }, 1000);
                }
            }
        } else {
            vue.$toast(data.message);
        }
    });
    mypomelo.on({ route: 'onMsg_undoChess' }, function (data) {
        if (data.errno == 0) {
            var s_c_body = data.data;
            comm.initChessBymap(board2map(s_c_body.chessid_map));
            comm.map = board2map(s_c_body.chessid_map);
            if (vue.role == 1) {
                vue.player_times = vue.exchangeAB(s_c_body.player_times);
            } else if (vue.role == 2) {
                vue.player_times = vue.player_times;
            } else if (vue.role == 3) {
                if (isVerticalReverse == 1) {
                    vue.player_times = s_c_body.player_times;
                } else {
                    vue.player_times = vue.exchangeAB(s_c_body.player_times);
                }
            }
            vue.current_user = s_c_body.current_user;
            comm.initLight(s_c_body.move_chess_data_previous);
            movesIndex = s_c_body.move_chess_step;

            vue.player_status[0].currentRate = 100;
            vue.player_status[1].currentRate = 100;
            vue.player_status[0].display = false;
            vue.player_status[1].display = false;
            if (isVerticalReverse == 1) {
                if (s_c_body.current_user != 0) {
                    vue.player_status[1].display = true;
                } else {
                    vue.player_status[0].display = true;
                }
            } else {
                if (s_c_body.current_user == 0) {
                    vue.player_status[1].display = true;
                } else {
                    vue.player_status[0].display = true;
                }

            }
            vue.player_status[0].total_time = vue.player_times[0].steptime;
            vue.player_status[1].total_time = vue.player_times[1].steptime;
            refreshRegretTimes();
        } else {
            vue.$toast(data.message);
        }
    });
    mypomelo.on({ route: 'onMsg_userChat' }, function (data) {
        if (data.errno == 0) {
            //判断是下棋着还是旁观者说的话
            if (data.data.chairId != null) {
                //红方说的
                if (data.data.chairId == (vue.role - 1)) {
                    vue.message[1] = data.data;
                    vue.messageContent.push(data.data);
                    if (data.data.name && data.data.name.indexOf('img') == -1) {
                        comm.soundplay(data.data.name, 'message');
                    }
                    if (messageTimeout) clearTimeout(messageTimeout);
                    messageTimeout = setTimeout(function () {
                        vue.$set(vue.message, 1, '');
                    }, 4000);
                } else {
                    if (acceptMessage) {
                        vue.message[0] = data.data;
                        vue.messageContent.push(data.data);
                        if (data.data.name && data.data.name.indexOf('img') == -1) {
                            comm.soundplay(data.data.name, 'message');
                        }
                        if (messageTimeout2) clearTimeout(messageTimeout2);
                        messageTimeout2 = setTimeout(function () {
                            vue.$set(vue.message, 0, '');
                        }, 4000);
                    }
                }
            } else {
                vue.pangguanMessage = data.data;
                vue.messageContent.push(data.data);
                if (messageTimeout3) clearTimeout(messageTimeout3);
                messageTimeout3 = setTimeout(function () {
                    vue.pangguanMessage = {};
                }, 3000);
            }
            if (vue.role == 3) {
                vue.$nextTick(function () {
                    var div = vue.$refs.messageBox;
                    div.scrollTop = div.scrollHeight;
                });
            }
        } else {
            vue.$toast(data.message);
        }
    });
    mypomelo.on({ route: 'onMsg_userOutLine' }, function (data) {
        if (data.errno == 0) {
            if (data.data.role == 3) {
                for (var i = 0; i < vue.pangguanList.length; i++) {
                    if (data.data.uid == vue.pangguanList[i].uid) {
                        vue.pangguanList[i].isLogin = false;
                        break;
                    }
                }
            } else {
                if (data.data.uid == vue.playersInfo[0].uid) {
                    vue.playersInfo[0].isLogin = false
                } else {
                    vue.playersInfo[1].isLogin = false
                }
            }
        } else {
            vue.$toast(data.message);
        }
    });
    mypomelo.on({ route: 'onMsg_userInLine' }, function (data) {
        if (data.errno == 0) {
            if (data.data.role == 3) {
                for (var i = 0; i < vue.pangguanList.length; i++) {
                    if (data.data.uid == vue.pangguanList[i].uid) {
                        vue.pangguanList[i].isLogin = true;
                        break;
                    }
                }
            } else {
                if (data.data.uid == vue.playersInfo[0].uid) {
                    vue.playersInfo[0].isLogin = true
                } else {
                    vue.playersInfo[1].isLogin = true
                }
            }
        }
    });
    mypomelo.on({ route: 'onMsg_analyseData' }, function (data) {
        if (data.errno == 0) {
            vue.dataX[data.data.movesIndex] = data.data.movesIndex;
            vue.dataY[data.data.movesIndex] = turnScore(data.data.score);
            if (vue.myChart2) {
                var option = vue.myChart2.getOption();
                option.xAxis[0].data = vue.dataX;
                option.series[0].data = vue.dataY;
                vue.myChart2.setOption(option, true);
                vue.changeToolTip(0, vue.dataY.length - 1);
            }
        } else {
            vue.$toast(data.message);
        }
    });
    mypomelo.on({ route: 'onMsg_bestMoveData' }, function (data) {
        console.log(JSON.stringify(data));
        console.log(JSON.stringify(currentId));
        if (data.errno == 0) {
            if (!data.data.move || data.data.move.match("checkmate") || data.data.move.match("stalemate") || data.data.move.match("slatemate") || data.data.move.match("none")) {
            } else {
                if (data.data.params.currentId == currentId-1) {
                    console.log("ddd")
                    comm.nodes[data.data.params.currentId].tipsStep[0] = data.data.move;
                    chessAnalyseShape();
                }
            }
        } else {
            vue.$toast(data.message);
        }
    });
    mypomelo.on({ route: 'onMsg_updateRoom' }, function (data) {
        if (data.errno == 0) {
            if (data.data.uid == vue.playersInfo[0].uid && data.data.status == 1) {
                vue.playersInfo[0].status = 504;
            }
            if (data.data.uid == vue.playersInfo[1].uid && data.data.status == 1) {
                vue.playersInfo[1].status = 504;
            }
            if (data.data.initMap && !vue.isCreator) {
                cleanChess();
                initMap = board2map(data.data.initMap);
                comm.initChessBymap(initMap);
            }
            if (data.data.time_rule) {
                vue.readyBegin.gameTime = data.data.time_rule.gametime;
                vue.readyBegin.stepTime = data.data.time_rule.steptime;
                vue.readyBegin.addSecond = data.data.time_rule.addsecond;
                vue.readyBegin.readTime = data.data.time_rule.readtime;
            }
        } else {
            vue.$toast(data.message);
        }
    });
    mypomelo.on({ route: 'onMsg_closeRoom' }, function (data) {
        if (data.errno == 0) {
            vue.$dialog.alert({
                title: '提醒',
                message: data.message,
                confirmButtonColor: '#3388ff'
            }).then(function () {
                vue.rebackHall();
            });
        } else {
            vue.$toast(data.message);
        }
    });
    mypomelo.on({ route: 'onMsg_kickRoom' }, function (data) {
        if (data.errno == 0) {
            vue.$dialog.alert({
                title: '提醒',
                message: data.message,
                confirmButtonColor: '#3388ff'
            }).then(function () {
                vue.qlcp_lookon(vue.roomID, 0, 3, 1)
            });
        } else {
            vue.$toast(data.message);
        }
    });
}
function closeEventListener() {
    vue.noListener = true;
    mypomelo.off({ all: true });
}
