var mode = 5;
waitServerPlay = false;
qlcp_timeer = null;
var mysetting = {
    host: "online.wechess.cn",
    port: {
        online: {
            dev: ['51004', '51006', '51008'],
            pro: ['50004', '50006', '50008']
        }
    },
    servers: {
        qlcp: "online.wechess.cn:51006,online.wechess.cn:51008,online.wechess.cn:51010",
        analyse: "online.wechess.cn:60002"
    },
    routes: {
        gate: "gate.gateHandler.queryEntry",
        login: "connector.entryHandler.login",
        connector: "connector.entryHandler.enter",
        getData: "analyse.analyseHandler.getData",//复盘拆解
        getBestMove: "analyse.analyseHandler.getBestMove",//ai
        getTableList: "game.gameHandler.getTableList",
        matchTable: "game.gameHandler.matchTable",
        chessMove: "game.gameHandler.chessMove",
        cancelGame: "game.gameHandler.cancelGame",
        joinRoom: "game.gameHandler.joinRoom",
        leaveRoom: "game.gameHandler.leaveRoom",
        vote: "game.gameHandler.vote",
        voteApply: "game.gameHandler.voteApply",
        userChat: "game.gameHandler.userChat",
        collect: "game.gameHandler.collect", //预约收藏
        invitePlay: "game.gameHandler.invitePlay",
        invitePlayApply: "game.gameHandler.invitePlayApply",
        getPlayData: "game.gameHandler.getPlayData",
        userCollect: "game.gameHandler.userCollect", //下完棋之后的收藏
        getMemberInfo: "game.gameHandler.getMemberInfo",
        getMemberAllInfo: "game.gameHandler.getMemberAllInfo",
        getStatics: "game.gameHandler.getStatics",
        initialize: "game.gameHandler.initialize",//
        addFriend: "game.gameHandler.addFriend",
        getPaihangList: "game.gameHandler.getPaihangList",
        // getNoticeFriendList: "game.gameHandler.getNoticeFriendList",
        dealFriend: "game.gameHandler.dealFriend",
        getFriendList: "game.gameHandler.getFriendList",
        getChatMessage: "game.gameHandler.getChatMessage",
        sendChatMessage: "game.gameHandler.sendChatMessage",
        getChatNums: "game.gameHandler.getChatNums",
        updateMessageStatus: "game.gameHandler.updateMessageStatus",
        getUsersState: "game.gameHandler.getUsersState",
        inGuanka: "game.gameHandler.inGuanka",
        createHydzRoom: "game.gameHandler.createHydzRoom",
        updateRoom: "game.gameHandler.updateRoom",
        kickRoom: "game.gameHandler.kickRoom",
        createAssociation: "game.gameHandler.createAssociation",
        joinAssociation: "game.gameHandler.joinAssociation",
        outAssociation: "game.gameHandler.outAssociation",
        updateAssociation: "game.gameHandler.updateAssociation",
        getAssociation: "game.gameHandler.getAssociation",
        getAssociations: "game.gameHandler.getAssociations",
        updateSetting: "ws.wsHandler.updateSetting",
        kickRoomByManager: "game.gameHandler.kickRoomByManager",
        getMemberInfos: "game.gameHandler.getMemberInfos",
        getChesses: "ws.wsHandler.getChesses",
        getCommonData: "ws.wsHandler.getCommonData",
        forbidden: "game.gameHandler.forbidden",
        getScoreRecord: "ws.wsHandler.getScoreRecord",
        report: "game.gameHandler.report",
        getReports: "ws.wsHandler.getReports",
        feedback: "ws.wsHandler.feedback",
        getFeedback: "ws.wsHandler.getFeedback",
        getSelfChesses: "ws.wsHandler.getSelfChesses",
        editChess: "ws.wsHandler.editChess",
        getShare: "game.gameHandler.getShare",
        updateLocation: "ws.wsHandler.updateLocation",

        geSelfRank: "ws.wsHandler.geSelfRank", //获取个人排名信息，传值type，取值1,2,3代表棋力测评，ai博弈，卫冕排名
        getGuankaList: "ws.wsHandler.getGuankaList", //获取关卡列表和通关人数。
        getManMachine: "ws.wsHandler.getManMachine", //获取人机对战设置
        getChess: "ws.wsHandler.getChess", //获取单个棋谱信息，传值chessid，
        publishChess: "ws.wsHandler.publishChess",
        getAnalyse: "ws.wsHandler.getAnalyse",
        deleteChess: "ws.wsHandler.deleteChess", //删除自己的棋谱
        getChessCategory: "ws.wsHandler.getChessCategory", //获取人机对战设置
        searchChess: "ws.wsHandler.searchChess", //搜索棋谱，传值，page，keyword，categorid,playerid,sort,没有的传null或者false
        getPlayer: "ws.wsHandler.getPlayer", //获取单个棋手信息，传值id，代表棋手id
        getPlayers: "ws.wsHandler.getPlayers",
        searchInit: "ws.wsHandler.searchInit", //棋谱搜索页面的初始化信息
        updateCollect: "ws.wsHandler.updateCollect", //更新收藏，传值type，取值chess或者player，id代表棋谱id或者棋手id
        getCollects: "ws.wsHandler.getCollects", //传值page，获取收藏的棋谱信息
        saveChess: "ws.wsHandler.saveChess",
        getDescription: "ws.wsHandler.getDescription",
        getFollowsFans: 'game.gameHandler.getFollowsFans',
        follow: 'game.gameHandler.follow',
        black: 'game.gameHandler.black',
        getNoticeNums: 'game.gameHandler.getNoticeNums',//通知消息
        getChatList: 'game.gameHandler.getChatList',//通知消息
        dealNotice: 'game.gameHandler.dealNotice',//通知消息
        getSystemNoticeList: 'game.gameHandler.getSystemNoticeList',//通知消息
        getCommentList: 'game.gameHandler.getCommentList',//通知消息
        getPrizeList: 'game.gameHandler.getPrizeList',//通知消息
        getCollectList: 'game.gameHandler.getCollectList',//通知消息
        getMessageNums: 'game.gameHandler.getMessageNums',//通知消息
        getUserTree: 'tree.treeHandler.getUserTree', //开局树
        getKjCategory: 'tree.treeHandler.getKjCategory', //开局树
        getUserKjCategories: 'tree.treeHandler.getUserKjCategories', //开局树
        getChessesByCid: 'tree.treeHandler.getChessesByCid',
        getUserStatistics: 'tree.treeHandler.getUserStatistics',
        getLessonsByCid: 'tree.treeHandler.getLessonsByCid',
        getChessesByFen: 'tree.treeHandler.getChessesByFen',
        getAssociationKjCategories: 'tree.treeHandler.getAssociationKjCategories',
        getAIplayerList: 'tree.treeHandler.getAIplayerList',
        getQpzj: 'tree.treeHandler.getQpzj',
        getHighData: "analyse.analyseHandler.getHighData",
        getScore: "analyse.analyseHandler.getScore",
        stopHighData: "analyse.analyseHandler.stopHighData",
        getEventList: 'ws.wsHandler.getEventList',
        dealCat: 'ws.wsHandler.dealCat',
    }
}
user_base_info = {
    "uid": null,
    "nickname": null,
    "avatar": null,
    "strengthname": null,

}
chess_move_action = {
    action: 0
}

actions = {
    action_null: 0x0000,
    action_juesha: 0x0001,
    action_jiang: 0x0002,
    action_sha: 0x0004,
    action_chi: 0x0008,
    action_zhuo: 0x0010,
}

move_foul_type = {
    move_foul_type_null: 0,
    move_foul_type_songjiang: 1, //送将
    move_foul_type_cycle_jiangjiang: 2, //两将
    move_foul_type_cycle_shasha: 3, //两杀
    move_foul_type_cycle_zhuozhuo: 4, //两捉
    move_foul_type_cycle_jiangsha: 5, //一将一杀
    move_foul_type_cycle_jiangzhuo: 6, //一将一捉
    move_foul_type_cycle_shazhuo: 7, //一杀一捉
}
foule_fen = {
    jiang: 6,
    sha: 5,
    zhuo: 2,
    xian: 0
}