Vue.component('my-canvas', {
    template: '<canvas :id="pro.id" width="720" height="830" style="width: 100%;vertical-align: top"></canvas>',
    props: {
        pro: Object,
        target: Object
    },
    watch: {
        target: function (val, oldVal) {
            if (val) {
                if (this.pro.reduid == uid) {
                    initialization(val, this.pro.id + '', board2map(this.pro.fen, 1));
                } else {
                    initialization(val, this.pro.id + '', arrReverse(board2map(this.pro.fen, 1)), 0, 1);
                }
            }
        }
    },
    mounted: function () {
        if (this.target) {
            this.$forceUpdate();
            if (this.pro.reduid == uid) {
                initialization(this.target, this.pro.id + '', board2map(this.pro.fen, 1));
            } else {
                initialization(this.target, this.pro.id + '', arrReverse(board2map(this.pro.fen, 1)), 0, 1);
            }
        }
    },
    methods: {

    }
});
