Vue.component('my-user-info', {
    template: '        <div><van-popup class="popup_big" v-model="popupInform" :overlay-style="{backgroundColor:\'rgba(0,0,0,.5)\'}" @click-overlay="$emit(\'display-inform\')">\n' +
        '            <div class="big2">\n' +
        '                <div class="close_setting" @click="$emit(\'display-inform\')"><van-icon name="cross" size="30"></van-icon></div>\n' +
        '                <div class="top_inform">\n' +
        '                    <div class="head_img2" @click="openPage(\'message/self_page\',{infoUid:clickplayerinfo.uid,reload: true})" style="border: 2px solid #333333;">\n' +
        '                        <img :src="clickplayerinfo.avatar?clickplayerinfo.avatar:defaultAvatar" />\n' +
        '                    </div>\n' +
        '                    <div class="nickname ellipsized" v-show="clickplayerinfo&&clickplayerinfo.nickname">{{clickplayerinfo.nickname}}[ID:{{clickplayerinfo.uid | userId}}]</div>\n' +
        '                    <div class="time">' +
        '                       <span style="text-decoration:underline" @click="$emit(\'display-grade\')">[{{clickplayerinfo?clickplayerinfo.strengthname:\'暂无级别\'}}]</span>' +
        '                       <span v-show="gradeData.currentScore2">/</span> ' +
        '                       <span v-show="gradeData.currentScore2" style="text-decoration:underline" @click="$emit(\'display-grade2\')">[{{clickplayerinfo.integralname}}]</span>' +
        '                   </div>\n' +
        '                </div>\n' +
        '                <div class="bottom_inform">' +
        '                    <van-tabs v-model="tabIndex" :color="deep_yellow" :background="light_yellow" :title-active-color="deep_yellow" :title-inactive-color="deep_yellow" line-width="30%" line-height="2" @click="onChange">\n' +
        '                        <van-tab title="等级分">' +
        '                            <div style="padding: 10px;"><div style="width:100%;line-height: 20px;text-align: center;font-size: 12px;">{{gradeData.currentDate}} {{gradeData.currentScore}}分<span v-show="gradeData.currentScore2">/{{gradeData.currentScore2}}分</span></div>\n' +
        '                            <div id="grade_score" style="height: 160px;"></div>' +
        '                            <div v-show="clickplayerinfo.uid!=uid" style="width:100%;line-height: 30px;text-align: center;font-size: 14px;font-weight: bold;">' +
        '                                <span @click="openPage(\'message/self_page\',{infoUid:clickplayerinfo.uid,reload: true})">查看主页</span>' +
        '                                <span @click="follow(clickplayerinfo.uid)" v-show="!isFollow">&nbsp;&nbsp;&nbsp;关注</span>' +
        // '                                <span @click="follow(clickplayerinfo.uid,true)" v-show="isFollow">&nbsp;&nbsp;&nbsp;取消关注</span>' +
        // '                                <span @click="deleteFriend" v-show="clickplayerinfo.isfriend==1">删除</span>' +
        // '                                <span @click="dataDialog=true" v-show="clickplayerinfo.isfriend==1">&nbsp;&nbsp;&nbsp;备注</span>' +
        '                                <span @click="gotoChat" v-show="isFollow">&nbsp;&nbsp;&nbsp;私信</span>' +
        '                                <span @click="gotoPangguan(clickplayerinfo)" v-if="clickplayerinfo.isLogin&&myRole!=1&&myRole!=2&&(clickplayerinfo.role==1||clickplayerinfo.role==2)&&myRoomID!=clickplayerinfo.roomID&&clickplayerinfo.roomPlayersLength==1">&nbsp;&nbsp;&nbsp;加入房间</span>' +
        '                                <span @click="gotoPangguan(clickplayerinfo)" v-else-if="clickplayerinfo.isLogin&&myRole!=1&&myRole!=2&&(clickplayerinfo.role==1||clickplayerinfo.role==2)&&myRoomID!=clickplayerinfo.roomID">&nbsp;&nbsp;&nbsp;旁观</span>' +
        '                                <span @click="$emit(\'fight-someone\')" v-else-if="clickplayerinfo.isLogin&&myRole!=1&&myRole!=2&&clickplayerinfo.role!=1&&clickplayerinfo.role!=2">&nbsp;&nbsp;&nbsp;约战</span>' +
        '                                <span @click="reportDialog=true">&nbsp;&nbsp;&nbsp;举报</span></div>' +
        '                            </div>\n' +
        '                        </van-tab>\n' +
        '                        <van-tab title="统计">\n' +
        '                            <div style="padding: 10px;">' +
        '                            <span v-show="!gradeData.currentScore2">总对局数：{{clickplayerinfo.strengthnum}}<br></span>' +
        '                            <span v-show="!gradeData.currentScore2">胜率：{{(clickplayerinfo.winrate*100).toFixed(0)}}%<br></span>' +
        '                            <span v-show="gradeData.currentScore2">纯人对局数：{{clickplayerinfo.strengthnum}}<br></span>' +
        '                            <span v-show="gradeData.currentScore2">纯人对局胜率：{{(clickplayerinfo.winrate*100).toFixed(0)}}%<br></span>' +
        '                            <span v-show="gradeData.currentScore2">AI对局数：{{clickplayerinfo.integralnum}}<br></span>' +
        '                            <span v-show="gradeData.currentScore2">AI对局胜率：{{(clickplayerinfo.wininterate*100).toFixed(0)}}%<br></span>' +
        '                            <span>棋力：{{clickplayerinfo.engine!=-1?(clickplayerinfo.engine):\'-\'}}</span><br></div>' +
        '                        </van-tab>\n' +
        '                        <van-tab title="信息">\n' +
        '                            <div style="padding: 10px;">' +
        '                            <span>地区：{{clickplayerinfo.nationality==\'CN\'?\'中国\':clickplayerinfo.nationality}}/{{clickplayerinfo.resideprovince}}/{{clickplayerinfo.residecity}}</span><br>\n' +
        '                            <span>排名：{{clickplayerinfo.nationalitypaihang||\'\'}}/{{clickplayerinfo.resideprovincepaihang}}/{{clickplayerinfo.residecitypaihang}}</span><br>\n' +
        '                            <span v-show="gradeData.currentScore2">AI排名：{{clickplayerinfo.integralnationalitypaihang||\'\'}}/{{clickplayerinfo.integralresideprovincepaihang||\'\'}}/{{clickplayerinfo.integralresidecitypaihang||\'\'}}<br></span>\n' +
        '                            <span>实名认证：{{clickplayerinfo.realname!=0?clickplayerinfo.realname:\'未认证\'}}</span><br>\n' +
        '                            <span>信用分：{{clickplayerinfo.creditscore}}</span><br>\n' +
        '                        </van-tab>\n' +
        '                    </van-tabs>\n' +
        '                </div>\n' +
        '            </div>\n' +
        '        </van-popup>' +
        '        <van-dialog v-model="showDialog" title="添加对方为好友" @confirm="addFriend(clickplayerinfo)" show-cancel-button confirm-button-color="#3388ff" cancel-button-color="#666666">\n' +
        '           <van-field v-model="addValue" />\n' +
        '        </van-dialog>' +
        '        <van-dialog v-model="dataDialog" title="添加好友备注" @confirm="dataFriend" show-cancel-button confirm-button-color="#3388ff" cancel-button-color="#666666"><van-field v-model="dataValue" placeholder="请填写备注名"/></van-dialog>' +
        '        <van-dialog v-model="reportDialog" title="用户举报" show-cancel-button :before-close="beforeClose" confirm-button-color="#3388ff" cancel-button-color="#666666">' +
        '           <van-radio-group v-model="radio" direction="horizontal" style="padding: 10px 16px"><van-radio :name="item.index" icon-size="16px" v-for="item in reportList">{{item.name}}</van-radio></van-radio-group>' +
        '        <van-field v-model="message" rows="3" :autosize="{maxHeight: 90}" type="textarea" maxlength="200" placeholder="请填写具体的举报原因" show-word-limit style="line-height: 30px"></van-field>' +
        '        </van-dialog>' +
        '</div>',
    props: {
        popupInform: Boolean,
        clickplayerinfo: Object
    },
    data: function () {
        return {
            tabIndex: 0,
            gradeData: {
                dataX: [],
                dataY: [],
                dataY2: [],
                currentDate: '',
                currentScore: '',
                currentScore2: '',
            },
            myChart: '',
            showDialog: false,
            addValue: '交个朋友吧！',
            dataDialog: false,
            dataValue: '',
            reportDialog: false,
            radio: '1',
            message: '',
            light_yellow: '#E8C191',
            deep_yellow: '#5A422B',
            isFollow: false,
            reportList: [
                { index: '1', name: '软件作弊', type: 'cheat' },
                { index: '2', name: '粗言秽语', type: 'curse' },
                { index: '3', name: '恶意断线', type: 'duan' },
                { index: '4', name: '色情|广告|政治敏感', type: 'sex' },
                { index: '5', name: '其他', type: 'other' }
            ],
            myRole: '',
            myRoomID: ''
        }
    },
    filters: {
        userId: function (value) {
            if (value >= 10000000) {
                var r = /^(1[0]*)/;
                value = value + '';
                var val = value.replace(r, '');
                return val
            } else {
                return value
            }
        }
    },
    watch: {
        clickplayerinfo: function (val, oldVal) {
            if (val) {
                this.tabIndex = 0;
                this.initInfo(this.clickplayerinfo.uid);
                var _this = this;
                var temp = (this.clickplayerinfo.strengthStatic || []).reverse();
                var temp2 = (this.clickplayerinfo.integralStatic || []).reverse();
                this.gradeData.dataX = [];
                this.gradeData.dataY = [];
                this.gradeData.dataY2 = [];
                this.gradeData.currentDate = '';
                this.gradeData.currentScore = '';
                this.gradeData.currentScore2 = '';
                this.myChart = '';
                if (temp2.length > 0) {
                    var tempLength = temp.length + temp2.length;
                    var tempList = [];
                    var tempList2 = [];
                    var x = 0;
                    var y = 0;
                    for (var i = 0; i < tempLength; i++) {
                        if (x == temp.length && y == temp2.length) {
                            break;
                        }
                        if (x == temp.length) {
                            temp[x] = {
                                day: temp2[y].day,
                                num: temp[x - 1].num
                            }
                        }
                        if (y == temp2.length) {
                            temp2[y] = {
                                day: temp[x].day,
                                num: temp2[y - 1].num
                            }
                        }
                        if (temp[x].day == temp2[y].day) {
                            tempList.push(temp[x]);
                            tempList2.push(temp2[y]);
                            x++;
                            y++;
                        } else if (temp[x].day < temp2[y].day) {
                            tempList.push(temp[x]);
                            var tempVal = {
                                day: temp[x].day,
                                num: y > 0 ? temp2[y - 1].num : temp2[0].num
                            }
                            tempList2.push(tempVal);
                            x++;
                        } else {
                            tempList2.push(temp2[y]);
                            var tempVal = {
                                day: temp2[y].day,
                                num: x > 0 ? temp[x - 1].num : temp[0].num
                            }
                            tempList.push(tempVal);
                            y++;
                        }
                        this.gradeData.dataX.push(this.handleDay(tempList[i].day));
                        this.gradeData.dataY.push(tempList[i].num);
                        this.gradeData.dataY2.push(tempList2[i].num);
                    }
                } else {
                    for (var j = 0; j < temp.length; j++) {
                        this.gradeData.dataX.push(this.handleDay(temp[j].day));
                        this.gradeData.dataY.push(temp[j].num);
                    }
                }
                setTimeout(function () {
                    if (_this.gradeData.dataX.length == 0) {
                        _this.gradeData.dataX.push(_this.handleDay(getDay(0)));
                        _this.gradeData.dataY.push(1500);
                        _this.gradeData.currentDate = _this.handleDay2(_this.handleDay(getDay(0)));
                        _this.gradeData.currentScore = 1500;
                    } else {
                        if (_this.gradeData.dataY2.length != 0) {
                            _this.gradeData.currentScore2 = temp2[temp2.length - 1].num;
                        }
                        _this.gradeData.currentDate = _this.handleDay2(_this.gradeData.dataX[temp.length - 1]);
                        _this.gradeData.currentScore = temp[temp.length - 1].num;
                    }
                    _this.initChart();
                })
            }
        },
    },
    methods: {
        gotoPangguan: function (item) {
            if (item.roomType == 'hydz' || item.roomType == 'QS') {
                this.openPage('play_chess/create_room', { roomID: item.roomID });
            } else if (item.roomType == 'AI') {
                this.openPage('play_chess/ai_test', { roomID: item.roomID });
            } else {
                this.openPage('play_chess/qlcp', { roomID: item.roomID });
            }
        },
        openPage: function (url, params) {
            this.$emit('display-inform');
            this.$emit('close-event');
            if (url == 'play_chess/qlcp' || url == 'play_chess/ai_test' || url == 'play_chess/create_room') {
                var params = params || {};
                params.reload = true;
            }
            api.openTabLayout({
                slidBackType: 'edge',
                name: url,
                url: '../../html/_header.html',
                pageParam: params,
                hideHomeIndicator: true,
                reload: params && params.reload ? true : false,
            });
        },
        onChange: function (name) {
            this.tabIndex = name;
        },
        gotoChat: function () {
            this.openPage('message/chat_detail', { friendid: this.clickplayerinfo.uid });
        },
        follow: function (_uid, isDelete) {
            var _this = this;
            mySendMessage(mysetting.routes.follow, {
                followUid: _uid,
                op: isDelete ? 'delete' : ''
            }, function (data) {
                if (data.errno == 0) {
                    _this.isFollow = !_this.isFollow
                }
                _this.$toast(data.message);
                api.sendEvent({
                    name: 'refreshFollow'
                });
            });
        },
        addFriend: function (info) {
            var _this = this;
            mySendMessage(mysetting.routes.addFriend, {
                friendid: info.uid,
                remark: _this.addValue
            }, function (data) {
                _this.$emit('display-inform');
                _this.$toast(data.message);
                if (api.frameName == 'discover/message_new') {
                    vue.onRefresh();
                }
            });
        },
        deleteFriend: function () {
            var _this = this;
            if (this.clickplayerinfo.friendid == null) return;
            this.$dialog.confirm({
                message: '您确定要删除好友吗？',
                confirmButtonText: '删除',
                confirmButtonColor: '#3388ff',
                cancelButtonColor: '#666666'
            }).then(function () {
                mySendMessage(mysetting.routes.dealFriend, {
                    op: 'delete',
                    friendid: _this.clickplayerinfo.friendid
                }, function (data) {
                    _this.$emit('display-inform');
                    _this.$toast(data.message);
                    if (api.frameName == 'discover/message_new') {
                        vue.onRefresh();
                    }
                });
            }).catch(function () {

            })
        },
        initInfo: function (_uid) {
            var _this = this;
            mySendMessage(mysetting.routes.getMemberAllInfo, {
                infoUid: _uid,
                op: 'init'
            }, function (data) {
                if (data.errno == 0) {
                    _this.isFollow = data.data.isFollow;
                    _this.myRole = data.data.myRole;
                    _this.myRoomID = data.data.myRoomID;
                } else {
                    _this.$toast(data.message);
                }
            })
        },
        dataFriend: function () {
            var _this = this;
            if (this.clickplayerinfo.friendid == null) return;
            mySendMessage(mysetting.routes.dealFriend, {
                op: 'update',
                friendid: _this.clickplayerinfo.friendid,
                name: _this.dataValue
            }, function (data) {
                _this.$emit('display-inform');
                _this.$toast(data.message);
            });
        },
        beforeClose: function (action, done) {
            if (action === 'confirm') {
                var _this = this;
                if (!this.radio) {
                    this.reportDialog = true;
                    this.$toast('请选择举报类型');
                    done(false);
                    return;
                }
                if (this.message == '') {
                    this.$toast('举报原因不能为空');
                    done(false);
                    return;
                }
                done();
                mySendMessage(mysetting.routes.report, {
                    reportUid: _this.clickplayerinfo.uid,
                    type: _this.reportList[parseInt(_this.radio) - 1].type,
                    content: _this.message
                }, function (data) {
                    _this.radio = '1';
                    _this.message = '';
                    if (data.errno == 0) {
                        _this.$toast(data.message + '，系统会核实具体情况后进行处理');
                    } else {
                        _this.$toast(data.message);
                    }
                });
            } else {
                done();
            }
        },
        initChart: function () {
            var _this = this;
            _this.myChart = echarts.init(document.getElementById('grade_score'));
            option = {
                tooltip: {
                    trigger: 'axis',
                    showContent: false,
                },
                grid: {
                    left: 0,
                    right: '4%',
                    bottom: '2%',
                    top: '3%',
                    containLabel: true
                },
                xAxis: {
                    type: 'category',
                    data: _this.gradeData.dataX,
                    boundaryGap: false,
                    axisTick: false,
                    axisLine: {
                        lineStyle: {
                            color: '#5A422B'
                        }
                    },
                    axisLabel: {
                        color: '#5A422B',
                        fontSize: 10,
                        margin: 3,
                    },
                },
                yAxis: [
                    {
                        name: '纯人',
                        type: 'value',
                        splitLine: {
                            lineStyle: {
                                color: '#5A422B',
                                opacity: 0.2
                            }
                        },
                        axisTick: false,
                        axisLine: {
                            lineStyle: {
                                color: '#5A422B'
                            }
                        },
                        axisLabel: {
                            color: '#5A422B',
                            margin: 3,
                            fontSize: 10,
                        }
                    }
                ],
                series: [
                    {
                        name: '棋力评测等级分',
                        type: 'line',
                        data: _this.gradeData.dataY,
                        lineStyle: {
                            color: '#6B4A2B'
                        },
                        emphasis: { // hover状态折线显示
                            scale: false,
                            lineStyle: {
                                color: '#6B4A2B',
                                width: 2
                            }
                        },
                        hoverAnimation: false,
                        itemStyle: {
                            color: '#6B4A2B',

                        },
                        symbolSize: 0,
                        animation: false,
                    }
                ],
            };
            if (false) {
                option.yAxis[1] = {
                    name: 'AI',
                    type: 'value',
                    splitLine: {
                        lineStyle: {
                            color: '#5A422B',
                            opacity: 0
                        }
                    },
                    axisTick: false,
                    axisLine: {
                        lineStyle: {
                            color: '#5A422B'
                        }
                    },
                    axisLabel: {
                        color: '#5A422B',
                        margin: 3,
                        fontSize: 10,
                    }
                }
                option.series[1] = {
                    name: 'AI博弈等级分',
                    type: 'line',
                    data: _this.gradeData.dataY2,
                    lineStyle: {
                        color: '#39a9ed'
                    },
                    hoverAnimation: false,
                    itemStyle: {
                        color: '#39a9ed',

                    },
                    symbolSize: 0,
                    animation: false,
                    yAxisIndex: 1,
                }
            }
            _this.myChart.setOption(option, true);
            _this.myChart.getZr().on('mousemove', function (params) { //点击操作
                var pointInPixel = [params.offsetX, params.offsetY];
                if (_this.myChart.containPixel('grid', pointInPixel)) {
                    var xIndex = _this.myChart.convertFromPixel({ seriesIndex: 0 }, pointInPixel)[0]; //X轴序号
                    _this.gradeData.currentDate = _this.handleDay2(_this.gradeData.dataX[xIndex]);
                    _this.gradeData.currentScore = _this.gradeData.dataY[xIndex];
                    if (_this.gradeData.dataY2.length > 0) {
                        _this.gradeData.currentScore2 = _this.gradeData.dataY2[xIndex];
                    }
                }
            });
        },//个人等级分变动折线图
        handleDay: function (params) {
            params = params + '';
            var now = new Date();
            var year = now.getFullYear();
            var year2 = params.slice(0, 4);
            var month = params.slice(4, 6);
            if (month.slice(0, 1) == '0') {
                month = month.slice(1, 2);
            }
            var day = params.slice(6, 8);
            if (day.slice(0, 1) == '0') {
                day = day.slice(1, 2);
            }
            if (year == year2) {
                return month + '.' + day;
            } else {
                return year2 + '.' + month + '.' + day;
            }
        },//点击头像的个人信息等级分日期处理
        handleDay2: function (params) {
            params = params + '';
            var temp = params.split(".");
            if (temp.length == 2) {
                return temp[0] + '月' + temp[1] + '日';
            } else {
                return temp[0] + '年' + temp[1] + '月' + temp[2] + '日';
            }
        },
    }
});



Vue.component('my-grade', {
    template: '<van-popup class="popup_grade" v-model="popupGrade" @click-overlay="$emit(\'display-grade\')" :overlay-style="{backgroundColor:\'rgba(0,0,0,.5)\'}">\n' +
        '            <div class="close_setting" @click="$emit(\'display-grade\')"><van-icon name="cross" size="30"></van-icon></div>\n' +
        '            <div class="popup_label">等级分规则</div>\n' +
        '            <div class="popup_box"><div class="popup_text">\n' +
        '                <div v-html="ruleText" style="width: 100%;font-size: 12px"></div>\n' +
        '                <div style="width: 100%;height: auto;">\n' +
        '                    <ul><li class="rule_list"><div class="rule_item">称号</div><div class="rule_item">积分</div></li><li class="rule_list" v-for="(item, index) in strengthList"><div class="rule_item">{{item.name}}</div><div class="rule_item">\>\={{item.amount}}</div></li></ul>\n' +
        '                </div>\n' +
        '            </div></div>\n' +
        '        </van-popup>',
    props: {
        popupGrade: Boolean,
        strengthList: Array,
    },
    data: function () {
        return {
            ruleText: '暂无'
        }
    },
    watch: {
        popupGrade: function (val, oldVal) {
            if (val) {
                var _this = this;
                mySendMessage(mysetting.routes.getDescription, {
                    type: ['strength']
                }, function (data) {
                    if (data.errno == 0) {
                        _this.ruleText = data.data.strength;
                    } else {
                        _this.$toast(data.message);
                    }
                });
            }
        }
    }
})

Vue.component('ai-grade', {
    template: '<van-popup class="popup_grade" v-model="popupGrade2" @click-overlay="$emit(\'display-grade\')" :overlay-style="{backgroundColor:\'rgba(0,0,0,.5)\'}">\n' +
        '            <div class="close_setting" @click="$emit(\'display-grade\')"><van-icon name="cross" size="30"></van-icon></div>\n' +
        '            <div class="popup_label">等级分规则</div>\n' +
        '            <div class="popup_box"><div class="popup_text">\n' +
        '                <div v-html="ruleText" style="width: 100%;font-size: 12px"></div>\n' +
        '                <div style="width: 100%;height: auto;">\n' +
        '                    <ul><li class="rule_list"><div class="rule_item">称号</div><div class="rule_item">积分</div></li><li class="rule_list" v-for="(item, index) in integralList"><div class="rule_item">{{item.name}}</div><div class="rule_item">\>\={{item.amount}}</div></li></ul>\n' +
        '                </div>\n' +
        '            </div></div>\n' +
        '        </van-popup>',
    props: {
        popupGrade2: Boolean,
        integralList: Array,
    },
    data: function () {
        return {
            ruleText: '暂无'
        }
    },
    watch: {
        popupGrade2: function (val, oldVal) {
            if (val) {
                var _this = this;
                mySendMessage(mysetting.routes.getDescription, {
                    type: ['integral']
                }, function (data) {
                    if (data.errno == 0) {
                        _this.ruleText = data.data.integral;
                    } else {
                        _this.$toast(data.message);
                    }
                });
            }
        }
    }
})

Vue.component('weimian-grade', {
    template: '<van-popup class="popup_grade" style="height: auto" v-model="weimianRule" @click-overlay="$emit(\'display-grade\')" :overlay-style="{backgroundColor:\'rgba(0,0,0,.5)\'}">\n' +
        '            <div class="close_setting" @click="$emit(\'display-grade\')"><van-icon name="cross" size="30"></van-icon></div>\n' +
        '            <div class="popup_label">卫冕分规则</div>\n' +
        '            <div style="height:88%;margin-top: 5%;overflow-y: auto;">\n' +
        '                <div v-html="ruleText" style="width: 100%;color: #6B4A2B;font-size: 12px"></div>\n' +
        '            </div>\n' +
        '        </van-popup>',
    props: {
        weimianRule: Boolean,
    },
    data: function () {
        return {
            ruleText: '暂无'
        }
    },
    watch: {
        weimianRule: function (val, oldVal) {
            if (val) {
                var _this = this;
                mySendMessage(mysetting.routes.getDescription, {
                    type: ['winscore']
                }, function (data) {
                    if (data.errno == 0) {
                        _this.ruleText = data.data.winscore;
                    } else {
                        _this.$toast(data.message);
                    }
                });
            }
        }
    }
})
