Vue.component('send-book', {
    template: '<van-popup v-model="sendBook" @click-overlay="$emit(\'display-book\')" class="war_book">\n' +
        '        <div class="bottom">\n' +
        '            <div class="btn_button two_btn">\n' +
        '                <div class="button_normal_bg" @click="$emit(\'display-book\')">\n' +
        '                    <img class="button_text" :src="CDN_PATH+\'assets/images/button/button_cancel.png\'">\n' +
        '                </div>\n' +
        '            </div>\n' +
        '            <div class="btn_button two_btn">\n' +
        '                <div class="button_normal_bg" @click="invitePlay">\n' +
        '                    <img class="button_text" :src="CDN_PATH+\'assets/images/button/button_send.png\'">\n' +
        '                </div>\n' +
        '            </div>\n' +
        '        </div>\n' +
        '    </van-popup>',
    props: {
        sendBook: Boolean,
        sendBookId: Infinity
    },
    methods: {
        invitePlay: function () {
            var _this = this;
            this.$emit('display-book');
            if (this.sendBookId == uid) {
                return;
            }
            mySendMessage(mysetting.routes.invitePlay, {
                inviteUid: _this.sendBookId
            }, function (data) {
                if (data.errno == 0) {
                    popupDisplay('正在等待约战结果...', true);
                } else {
                    popupDisplay(data.message, false, 1.5);
                }
            });
        },//约战对手,playerid对手uid
    }
});



Vue.component('get-book', {
    template: '<van-popup v-model="getBook" @click-overlay="$emit(\'display-book\')" class="war_book war_book2">\n' +
        '        <div class="middle">\n' +
        '            <div class="head_img"><img :src="getBookInfo.headimg"></div>\n' +
        '            <div class="nickname">{{getBookInfo.nickname}}</div>\n' +
        '        </div>\n' +
        '        <div class="bottom">\n' +
        '            <div class="btn_button two_btn">\n' +
        '                <div class="button_normal_bg" @click="invitePlayApply(getBookInfo.uid, false)">\n' +
        '                    <img class="button_text" :src="CDN_PATH+\'assets/images/button/button_refuse.png\'">\n' +
        '                    <span class="button_time">{{getBookInfo.time}}</span>\n' +
        '                </div>\n' +
        '            </div>\n' +
        '            <div class="btn_button two_btn">\n' +
        '                <div class="button_normal_bg" @click="invitePlayApply(getBookInfo.uid, true)">\n' +
        '                    <img class="button_text" :src="CDN_PATH+\'assets/images/button/button_match.png\'">\n' +
        '                </div>\n' +
        '            </div>\n' +
        '        </div>\n' +
        '    </van-popup>',
    props: {
        getBook: Boolean,
        getBookInfo: Object
    },
    methods: {
        invitePlayApply: function (inviteUid, agree) {
            this.$emit('display-book');
            mySendMessage(mysetting.routes.invitePlayApply, {
                inviteUid: inviteUid,
                agree: agree
            }, function (data) {
                if (data.errno == 0) {//回答成功
                    // toastDisplay('一起玩游戏');
                } else {
                    popupDisplay(data.message, false, 1.5);
                }
            });
        },//收到战书后的回答
    }
});
