/*初始化结构布局*/
initLayer = function (e) {
    mode = playmode.CREATE;
    isanalyse = 1;
    comm.sMap = comm.arr2Clone(sMapEmpty);
    comm.sMapList = JSON.parse(JSON.stringify(emptychessMan));
    initMap = comm.clone(InitMap);
    initialization(e);
    sendMessage();
}



/*保存棋盘*/
onSaveCreate = function () {
    comm.cMap = comm.arr2Clone(comm.map);
    cleanChess();
    cleanChessEx();
    cleanDefaultChessEx();
    mode = playmode.CREATE;
    movesIndex = 0;
    resizeBoard();
    //resetDots();
    comm.init(comm.map, !0);
    comm.notes = comm.notes || [];
    comm.nodes = comm.nodes || [];
    sendMessage()
    replayBtnUpdate();
}

sendMessage = function (type, cb) {
    flagWaitAjax=false;
    isAnalyseChess=true;
    isShowEmpty=false;
    var a = {};
    a.type = mode == playmode.CHESSANALYSE ? 'analyse' : 'all';
    a.nocache = type || 0;
    a.movesIndex = movesIndex;

    a.params = {
        currentId: currentId,
        isStartLibrary: 1,
        isDepth: 17,
        isRetry: vue.isRetry
    };
    if (movesIndex > 0) {
        a.board = comm.getBoard();
        if (movesIndex > 1) {
            a.prev_board = moves[movesIndex - 2].currentFen;
        } else {
            a.prev_board = comm.nodes[0].currentFen;
        }
        if (isVerticalReverse) {
            var temp_step = reverseStep(moves[movesIndex - 1].step);
        } else {
            var temp_step = moves[movesIndex - 1].step;
        }
        a.move_chess_data = comm.Step2FT(temp_step);
    } else {
        a.board = comm.nodes[0].currentFen;
        a.prev_board = null;
        a.move_chess_data = null;
    }

    a.robot_setting ={
        "level": "17",
        "caltime": "0.5",
        "kaiju": "3|5,5|1"
    };
    a.robot_setting2 ={
        "level": "17",
        "caltime": "0.5",
        "kaiju": "3|5,5|1"
    };


    a.needKjk = true;
    if (vue.startLibrary===2){
        var tempMove = getMovesList().slice(0, 20);
        a.treeType='all_s';
        a.totalFenBoard=getTotalFen();
        a.moves=tempMove;
    }
    //设置用户数据库
    a.user_set_db=1;
    mySendMessage(mysetting.routes.getData, a, function (data) {
        if (cb) {
            cb && cb(data);
            return;
        }
    });
}

