function initLayer(e) {
    target = e;
}
//点击了开始测评
function onClickStart() {
    var c_s_body = {};
    c_s_body.game_id = "xiangqi";
    c_s_body.type = vue.pageType;
    c_s_body.playercount = 2;
    c_s_body.extend_createsetting = { time_rule: vue.time_rule };
    mySendMessage(mysetting.routes.matchTable, c_s_body, function (data) {
        if (data.errno == 0) {
            vue.$toast.clear();
            if (data.data.isplaying) {
                vue.scenePlay(data.data.playData);
            } else {
                vue.pageIndex = 1;
                vue.dialogType = comm.clone(dialog_pipei);
            }
        } else {
            vue.$toast(data.message);
            vue.getPlayData();
        }
    })
}
//取消匹配
function onCacelGame() {
    mySendMessage(mysetting.routes.cancelGame, {}, function (data) {
        if (data.errno == 0) {
            vue.rebackHall();
        } else {
            vue.$toast(data.message);
            vue.getPlayData();
        }
    });
}
//开始游戏
function onGameBegin() {
    mode = playmode.ONLINE;
    vue.dialogType = dialog_default;
    setTimeout(function () {
        vue.redBlack = false;
    }, 1700);
    waitServerPlay = false;
    if (vue.pageIndex == 0) {
        return;
    }
    initialization(target);
    vue.onTime();
    if (movesIndex > 0 && vue.initMove && vue.initMove.to_pos) {
        comm.initLight(vue.initMove);
    }
    onRefreshTimes();
}
//游戏结束
function onGameOver() {
    hideDots();
    hideBorder();
    vue.cancelTime();
    vue.resetValue();
    if (vue.role == 3) {
        if (vue.qlcp_result.winner == 1) {
            dialog_pangguan.title2 = vue.qlcp_result.memberinfo.red.nickname + '战胜了' + vue.qlcp_result.memberinfo.black.nickname;
        } else if (vue.qlcp_result.winner == 2) {
            dialog_pangguan.title2 = vue.qlcp_result.memberinfo.black.nickname + '战胜了' + vue.qlcp_result.memberinfo.red.nickname;
        } else {
            dialog_pangguan.title2 = vue.qlcp_result.memberinfo.red.nickname + '战平了' + vue.qlcp_result.memberinfo.black.nickname;
        }
        if (vue.favorChess) {
            dialog_pangguan.button2_img = 'assets/images/button/button_favored.png';
        }
        vue.dialogType = comm.clone(dialog_pangguan);
    } else {
        if (vue.pageType == 'hydz' || vue.pageType == 'QS' || vue.pageType == 'AI') {
            vue.popupOver = true;
        } else {
            vue.pageIndex = 2;
        }
        setTimeout(function () {
            var hold = (vue.role == 1 ? 'red' : 'black');
            var upgate = vue.qlcp_result.upgrade[hold];
            if (upgate.isupgrade == 1 && (vue.pageType == 'qlcp' || vue.pageType == 'AI')) {
                vue.pageShareType = vue.pageType == 'qlcp' ? 'upgrade_qlcp' : 'upgrade_ai';
                vue.upgrade_result = upgate;
                vue.showUpgrade = true;
            }
        }, 1000);
    }
    mode = playmode.GAMEOVER;
    api.sendEvent({
        name: 'refreshQipu',
        extra: {}
    });
}
//悔棋
function onRegret() {
    if ((movesIndex % 2 == 1 && vue.role == 2) || (movesIndex % 2 == 0 && vue.role == 1)) {
        return;
    }
    if (movesIndex < 7) {
        return;
    }
    if (vue.optionInfo[1].times < 1) {
        return;
    }
    mySendMessage(mysetting.routes.vote, { type: 1 }, function (data) {
        if (data.errno == 0) {
            popupDisplay('正在等待对方同意', true);
            vue.optionInfo[1].times--;
            refreshRegretTimes();
        } else {
            popupDisplay(data.message, false, 2);
        }
    })

}
//是否求和
function onVote() {
    if (movesIndex < 13) {
        return;
    }
    if (vue.optionInfo[3].times < 1) {
        return;
    }
    vue.dialogType = comm.clone(dialog_qiuhe);
}
//是否强退
function onEscape() {
    if ((vue.role == 1 || vue.role == 2) && vue.pageIndex == 1) {
        vue.dialogType = comm.clone(dialog_tuichu);
    } else {
        mySendMessage(mysetting.routes.leaveRoom, {}, function (data) {
            vue.rebackHall();
        });
    }
}
//认输
function onGiveUp() {
    if (movesIndex < 6) {
        // vue.toastDisplay_qlcp("前三回合不能认输", 1000);
        return;
    }
    vue.dialogType = comm.clone(dialog_renshu);
}
//刷新悔棋求和认输的状态
function onRefreshTimes() {
    if (vue.role != 3) {
        refreshRegretTimes();
        refreshGiveUpTimes();
    }
}
function refreshRegretTimes() {
    if ((movesIndex % 2 == 1 && vue.role == 2) || (movesIndex % 2 == 0 && vue.role == 1) || movesIndex < 7 || vue.optionInfo[1].times < 1) {
        vue.$set(vue.optionInfo[1], 'isActive', false);
    } else {
        vue.$set(vue.optionInfo[1], 'isActive', true);
    }
}
function refreshGiveUpTimes() {
    if (movesIndex < 13) {
        vue.$set(vue.optionInfo[2], 'isActive', false);
    } else {
        vue.$set(vue.optionInfo[2], 'isActive', true);
    }
    if ((movesIndex % 2 == 0 && vue.role == 2) || (movesIndex % 2 == 1 && vue.role == 1) || movesIndex < 13 || vue.optionInfo[3].times < 1) {
        vue.$set(vue.optionInfo[3], 'isActive', false);
    } else {
        vue.$set(vue.optionInfo[3], 'isActive', true);
    }
}
// 用户聊天
function userChat(mess, params) {
    if (mess != '') {
        //百度内容过滤
        let vm = vue
        vm.ajaxPost(xqwxt_url + '&op=chat_check&do=message', { text: mess, type: 1 }, function (vm, res) {
            console.log(res)
            if (res.conclusionType == 1) {
                mySendMessage(mysetting.routes.userChat, { content: mess, name: params }, function (data) {
                    if (data.errno != 0) {
                        vue.$toast(data.message);
                    }
                })
            } else if (res.conclusionType == 2) {
                vm.$toast({
                    message: res.data[0].msg,
                    onClose: function () {
                        vm.message = ''
                    }
                })
            } else if (res.error_msg) {
                vm.$toast(res.error_msg)
            }
        })
    }
}