apiready = function () {
    id = api.pageParam.id;
    oxPlayer = api.require('oxPlayer');
    fs = api.require('fs');
    mypomelo = api.require('mypomelo');
    var keyboardHeight = 0, screenHeight = window.innerHeight;
    vue = new Vue({
        el: '#main',
        mixins: [mixin],
        data: {
	    tabIndex:1,
	    giftShow:false,
            giftMembers:[],
            giftUid:'',
            pageShareType: 'lesson',
            lessonId: api.pageParam.id,
            title: '',
            navColor: '#ffffff',
            isBuy: -1,
            lesson: [],//课程章节列表
            lessonT: [], //课程信息
            section_count: '',
            activeNames: [0],//活跃中的章节card
            currentIndex: 0,//tab栏index
            teacher: {}, //教师信息
            record: {}, //最近播放
            isCollect: false, //是否收藏
            stock_config: 0,//是否售罄
            currSectionId: '',//当前播放点击的章节id
            cindex: '',
            sindex: '',
            isPlaying: 0,//播放器状态

            screenH: api.winWidth * 9 / 16,
            allow_evaluate: 0,//允许评价
            consultShow: false, //咨询是否显示
            pageIndex: [1, 1, 1],//评价 评论
            loading: [false, false, false],
            finished: [false, false, false],
            evaluateList: [],//评价列表
            commentList: [],//评论列表
            countComment: 0,
            countEvaluate: 0,

            commentLesson: true,
            commentInput: {
                showOverlay: false,
                value: '',
                isImg: false,
                image: '',
                placeholder: '快来参与课程讨论吧'
            },
            replyInput: {
                showOverlay: false,
                show: false,
                value: '',
                isImg: false,
                image: '',
                placeholder: '@'
            },
            currentCommentIndex: '', //评论列表commentlist当前的index
            commenting: false,

            share: '',
            weixinimageshow: false, //微信咨询图片
            keybordH: 0,
            orderBy: 'hot',
            isMine: 0,
            offsetTop: 0,
            isTouPing: false,

            touPing: {
                name: '',
                status: 0,
                currentPosition: 0,
                duration: 0,
                inter: '',
                touPingVal: 0,
                showTime: true,
                isPlay: false
            },
            playUrl: '',
            speedShow: false,
            actions: [
                { name: '2.0X', value: 2 },
                { name: '1.5X', value: 1.5 },
                { name: '1.25X', value: 1.25 },
                { name: '1.0X', value: 1 },
                { name: '0.75X', value: 0.75 },
                { name: '0.5X', value: 0.5 },
            ],
            speedValue: 1,
            praiseValue: 0,
            sectionList: [],
            winWidth: api.winWidth,
            winHeight: api.winHeight,
            showReply: false,
            valueReply: '',
            currentEvaluate: 0,
            isTeacher: false,
            vipShow: false,
            hasStorage: true,
            chat_dialog:false,
            kefu:{
                nickname:'',
                avatar:'',
                qrcode:'',
            },
        },
        created: function () {
            var _this = this;
            this.ajaxPost(xqwxt_url + '&do=common&op=payed_init',
            {id:id},
            function (vm,ret) {
               console.log(ret)
               vm.kefu = ret.data.kefu
           })
            this.listen();
            this.getUserInfo();
            this.init();
            api.sendEvent({
                name: 'update_study',
                extra: { index: 0 }
            });
            var resultList = api.hasPermission({
                list: ['storage'],
                code: 1
            });
            var flag = 0;
            for(let i in resultList){
                if(!resultList[i].granted){
                    flag=1
                    break
                }
            }

            if (flag && (  api.deviceName.toUpperCase() == 'HUAWEI')) {
                _this.$dialog.confirm({
                    title: '提示',
                    message: ' 在您使用分享、评论、下载等服务时,需要您授权存储权限',
                    confirmButtonText: '去授权',
                    confirmButtonColor: '#333',
                   
                }).then(() => {
                    _this.setPermission(function (param) {
                        if (param) {
                            fnPlayEvent();
                        } else {
                            _this.hasStorage = false;
                        }
                    })
                })
            } else {
                _this.setPermission(function (param) {
                    if (param) {
                        fnPlayEvent();
                    } else {
                        _this.hasStorage = false;
                    }
                })
            }
        },
        mounted: function () {
            var vm = this;
            window.onscroll = function () {
                var scrollTop = document.documentElement.scrollTop || document.body.scrollTop;
                vm.offsetTop = scrollTop;
                if (scrollTop >= vm.screenH - 44 - 1 && !vm.isTouPing) {
                    vm.title = '课程详情';
                    vm.navColor = '#333333'
                } else {
                    vm.title = '';
                    vm.navColor = '#ffffff'
                }
            }
        },
        watch: {
            touPing: {
                handler: function (newValue, oldValue) {
                    this.touPing.touPingVal = parseInt(this.touPing.currentPosition / this.touPing.duration * 100)
                },
                deep: true
            }
        },
        filters: {
            filterTT: function (val) {
                var HH = 0;
                var MM = 0;
                var SS = 0;
                if (val > 60) {
                    if (val > 3600) {
                        HH = parseInt(val / 3600);
                        MM = parseInt((val % 3600) / 60);
                        SS = (val % 3600) % 60;
                    } else {
                        MM = parseInt(val / 60);
                        SS = val % 60;
                    }
                } else {
                    SS = val;
                }
                MM = MM < 10 ? '0' + MM : MM;
                SS = SS < 10 ? '0' + SS : SS;
                if (HH) {
                    HH = HH < 10 ? '0' + HH : HH;
                }
                return HH ? HH + ':' + MM + ':' + SS : MM + ':' + SS;
            }
        },
        methods: {
            buy(para) {
                this.ajaxPost(xqwxt_url + '&do=mylesson&op=isbuy', para, function (vm, ret) {
                    console.log(ret)
                    vm.giftShow = false
                    vm.openPage('lesson/pay', para)
                });
            },
	        giftSearch(){
            	this.ajaxPost(xqwxt_url + '&do=mylesson&op=member', {
                     giftUid: this.giftUid
            	},function(vm,ret){
                    vm.giftMembers=ret.data;
                });
            },
            onSelect: function (item) {
                var vm = this;
                if (vm.currSectionId) {
                    oxPlayer.setSpeed({ speed: item.value });
                }
                vm.speedValue = item.value;
            },
            init: function () {
                this.ajaxPost(xqwxt_url + '&do=lesson&op=init', {
                    id: id
                }, function (vm, ret) {
                    vm.isBuy = ret.data.isbuy;
                    vm.lessonT = ret.data.lesson;
                    vm.section_count = ret.data.section_count;
                    vm.teacher = ret.data.teacher;
                    vm.isTeacher = ret.data.isTeacher;
                    vm.countComment = ret.data.lesson.commentsum;
                    vm.countEvaluate = ret.data.lesson.evaluatesum; //评价总数
                    vm.vipShow = ret.data.lesson.vipview ? true : false;
                    vm.isCollect = ret.data.isCollect == '1' ? true : false;
                    vm.stock_config = ret.data.stock_config;
                    vm.allow_evaluate = ret.data.canEvaluate;
                    localStorage.setItem(id + '_lessoninfo', JSON.stringify(ret.data.lesson)); //记录课程信息
                    vm.record = ret.data.record;
                    if (ret.data.isbuy) {
                        vm.currentIndex = 1;
                        localStorage.setItem(uid + '_' + id + '_play', ret.play);
                        vm.getCatalogList(1);
                        vm.initDownloadListener();
                        var tuisongLesson = localStorage.getItem('tuisongLessonlist' + uid);
                        if (tuisongLesson) {
                            var tuisongLessonList = JSON.parse(tuisongLesson);
                            if (tuisongLessonList.indexOf('l' + id) != -1) {
                                vm.tuisongFlag = true;
                            } else {
                                vm.tuisongFlag = false;
                            }
                        } else {
                            vm.tuisongFlag = false;
                        }
                    }
                    vm.ajaxPost(xqwxt_url + '&do=lesson&op=getCatalogList', {
                        isAll: 1,
                        id: id,
                    }, function (vm, ret2) {
                        if (ret2 && ret2.data) {
                            for (var i = 0; i < ret2.data.length; i++) {
                                for (var j = 0; j < ret2.data[i]['section'].length; j++) {
                                    var tempSec = ret2.data[i]['section'][j];
                                    if (tempSec.tid == 0 && (vm.isBuy || tempSec.is_free == 1)) {
                                        vm.sectionList.push({
                                            vid: tempSec.id,//扩展字段 视频id(可选，会随事件返回)
                                            title: tempSec.title,
                                            index: (i + 1) + '-' + (j + 1),
                                            url: tempSec.videourl,
                                            touPingUrl: tempSec.videourl,
                                            videotime: tempSec.videotime,
                                            mprocess: tempSec.user_learn
                                        });
                                    }
                                    if (tempSec.id == api.pageParam.sid) {
                                        vm.currentIndex = 1;
                                        vm.clickTab(1);
                                        if (vm.isBuy || tempSec.is_free == 1) {
                                            vm.playVideo(tempSec.id, tempSec.is_free);
                                        } else {
                                            vm.$toast('付费章节需购买课程才可观看~');
                                        }
                                    }
                                }
                            }
                        }
                    });
                });
            },
            clickTab: function (index) {
                var _this = this;
		_this.tabIndex=index
                if (this.isBuy && index == 0 && this.commentList.length == 0) {
                    this.loading[2] = true;
                    setTimeout(function () {
                        _this.getCommentList(2);
                    }, 300)
                }
                if (index == 1 && this.lesson.length == 0) {
                    this.loading[1] = true;
                    this.getCatalogList(1);
                }
                if (index == 2 && this.evaluateList.length == 0) {
                    this.loading[0] = true;
                    setTimeout(function () {
                        _this.getEvaluateList(0);
                    }, 300)
                }
            },
            onLoad: function (index) {
                if (index == 0 && this.currentIndex == 2) {
                    this.getEvaluateList(index);
                } else if (index == 1 && this.currentIndex == 1) {
                    this.getCatalogList(index);
                } else {
                    this.getCommentList(index);
                }
            },
            getCatalogList: function (index) {
                var vm = this;
                api.ajax({
                    url: getSignUrl(xqwxt_url + '&do=lesson&op=getCatalogList'),
                    method: 'post',
                    data: {
                        values: {
                            page: this.pageIndex[index],
                            id: id
                        }
                    }
                }, function (ret, err) {
                    if (vm.pageIndex[index] == 1) vm.lesson = [];
                    if (ret && ret.errno == 0) {
                        for (var j = 0; j < ret.data.length; j++) {
                            vm.lesson.push(ret.data[j]);
                        }
                        vm.$set(vm.loading, index, false);
                        vm.$set(vm.finished, index, false);
                        vm.pageIndex[index]++;
                        var flag = false;
                        for (var ckey = 0; ckey < vm.lesson.length; ckey++) {
                            for (var skey = 0; skey < vm.lesson[ckey]['section'].length; skey++) {
                                if (api.pageParam.sid) {
                                    if (vm.lesson[ckey]['section'][skey].id == api.pageParam.sid) {
                                        // vm.activeNames[0] = parseInt(ckey);
                                        vm.$set(vm.activeNames, 0, parseInt(ckey));
                                        flag = true;
                                    }
                                } else if (vm.record && JSON.stringify(vm.record) != '{}') {
                                    if (vm.lesson[ckey]['section'][skey].id == vm.record.sectionid) {
                                        vm.record.cindex = parseInt(ckey);
                                        vm.record.sindex = parseInt(skey);
                                        // vm.activeNames[0] = parseInt(ckey);
                                        vm.$set(vm.activeNames, 0, parseInt(ckey));
                                        flag = true;
                                    }
                                } else {
                                    flag = true;
                                }
                                if (ckey == vm.lesson.length - 1 && skey == vm.lesson[ckey]['section'].length - 1 && !flag) {
                                    vm.getCatalogList(index);
                                }
                            }
                        }
                        if (vm.isBuy) {
                            vm.initDown();
                        }
                    } else {
                        vm.$set(vm.loading, index, false);
                        vm.$set(vm.finished, index, true);
                    }
                });
            },
            getCommentList: function (index) {
                var vm = this;
                api.ajax({
                    url: getSignUrl(xqwxt_url + '&do=comment&op=getCommentList'),
                    method: 'post',
                    data: {
                        values: {
                            page: this.pageIndex[index],
                            lessonid: id,
                            orderby: vm.orderBy,
                            ismine: vm.isMine
                        }
                    }
                }, function (ret, err) {
                    if (vm.pageIndex[index] == 1) vm.commentList = [];
                    if (ret && ret.errno == 0) {
                        for (var j = 0; j < ret.data.length; j++) {
                            vm.commentList.push(ret.data[j]);
                        }
                        vm.$set(vm.loading, index, false);
                        vm.$set(vm.finished, index, false);
                        vm.pageIndex[index]++;
                    } else {
                        vm.$set(vm.loading, index, false);
                        vm.$set(vm.finished, index, true);
                    }
                });
            },
            getEvaluateList: function (index) {
                var vm = this;
                api.ajax({
                    url: getSignUrl(xqwxt_url + '&do=lesson&op=getEvaluateList'),
                    method: 'post',
                    data: {
                        values: {
                            page: this.pageIndex[index],
                            id: id
                        }
                    }
                }, function (ret, err) {
                    if (vm.pageIndex[index] == 1) vm.evaluateList = [];
                    if (ret && ret.errno == 0) {
                        for (var j = 0; j < ret.data.length; j++) {
                            vm.evaluateList.push(ret.data[j]);
                        }
                        vm.$set(vm.loading, index, false);
                        vm.pageIndex[index]++;

                    } else {
                        vm.$set(vm.loading, index, false);
                        vm.$set(vm.finished, index, true);
                    }
                });
            },
            changeOrderBy: function (type) {
                if (type == 'hot') {
                    if (this.orderBy == 'hot') return;
                    this.orderBy = 'hot';
                    this.isMine = 0;
                }
                if (type == 'time') {
                    if (this.orderBy == 'time') return;
                    this.orderBy = 'time';
                    this.isMine = 0;
                }
                if (type == 'mine') {
                    this.isMine = (this.isMine ? 0 : 1);
                }
                this.commentList = [];
                this.loading[2] = true;
                this.pageIndex[2] = 1;
                this.finished[2] = false;
                this.getCommentList(2);
            },
            //////////////播放相关///////////////////
            playVideo: function (sectionId, is_free, tid, fen) {
                var vm = this;
                if (this.isBuy || this.lessonT.price == 0 || is_free == 1) {
                    if (tid && tid != 0) {
                        this.openPage('chess/practice', { fen: fen, lessonId: this.lessonId });
                        return;
                    }
                    if (this.currSectionId == sectionId) {
                        return;
                    } else {
                        if (vm.currSectionId) {
                            recordPlayPosition(false, vm.currSectionId);
                        }
                        for (var i = 0; i < vm.sectionList.length; i++) {
                            if (vm.sectionList[i].vid == sectionId) {
                                var playIndex = i;
                                var mprocess = vm.sectionList[i].mprocess ? vm.sectionList[i].mprocess * 1000 : (localStorage.getItem(id + '_' + sectionId) || 0);
                                var murl = 'mydownloads/' + id + '/' + id + '_' + sectionId + '.mp4';
                                fs.exist({
                                    path: 'fs://' + murl
                                }, function (ret, err) {
                                    if (ret) {
                                        if (ret.exist) {
                                            var tempData = vm.sectionList[playIndex];
                                            if (api.systemType == 'ios') {
                                                tempData.url = 'file://' + api.fsDir + '/' + murl;
                                            } else {
                                                tempData.url = api.fsDir + '/' + murl;
                                            }
                                            var param = {
                                                index: playIndex,
                                                data: tempData
                                            };
                                            oxPlayer.updateDataAtIndex(param)
                                            if (vm.currSectionId) {
                                                fnModulePlayUrl(playIndex, mprocess)
                                            } else {
                                                fnModulePlay(playIndex, mprocess);
                                            }
                                            vm.isPlaying = true;
                                            vm.currSectionId = sectionId;
                                            vm.$toast('已为您播放下载文件，请放心观看');
                                        } else {
                                            vm.ajaxPost(xqwxt_url + '&do=lesson&op=getSection', {
                                                id: id,
                                                sectionid: sectionId
                                            }, function (vm, ret) {
                                                if (vue && vue.self_setting) {
                                                    var look = vue.self_setting.wifi_play;
                                                }
                                                if (ret.data.sectiontype == 1 || ret.data.sectiontype == 2 || ret.data.sectiontype == 3) {
                                                    if (ret.data.savetype == '2') {
                                                        if (api.connectionType != 'wifi' && look) {
                                                            vue.$toast('您当前是移动网络，请注意流量使用');
                                                        }
                                                    } else if (ret.data.savetype == '1' || ret.data.savetype == '3') {
                                                        if (api.connectionType != 'wifi' && look) {
                                                            vm.$dialog.confirm({
                                                                message: '您当前是移动网络，播放将使用流量',
                                                                confirmButtonText: '流量播放',
                                                                confirmButtonColor: '#3388ff',
                                                                cancelButtonColor: '#666666'
                                                            }).then(function () {
                                                                vm.isPlaying = true;
                                                                if (vm.currSectionId) {
                                                                    fnModulePlayUrl(playIndex, mprocess)
                                                                } else {
                                                                    fnModulePlay(playIndex, mprocess);
                                                                }
                                                                vm.currSectionId = sectionId;
                                                            }).catch(function () { });
                                                        } else {
                                                            vm.isPlaying = true;
                                                            if (vm.currSectionId) {
                                                                fnModulePlayUrl(playIndex, mprocess)
                                                            } else {
                                                                fnModulePlay(playIndex, mprocess);
                                                            }
                                                            vm.currSectionId = sectionId;
                                                        }
                                                    }
                                                } else if (ret.data.sectiontype == 4) {
                                                    oxPlayer.pause();
                                                }
                                            });
                                        }
                                    } else {
                                        vm.$toast('系统错误，请删除下载文件后重试~');
                                    }
                                });
                                break;
                            }
                        }
                    }
                } else {
                    if (tid != 0) {
                        this.$toast('付费章节练一练需购买课程才可练习~')
                    } else {
                        this.$toast('付费章节需购买课程才可观看~')
                    }
                }
            },
            fnPause: function () {
                if (this.isTouPing) {
                    this.touPing.isPlay = false;
                    clearInterval(this.touPing.inter);
                    api.sendEvent({
                        name: 'pauseDLNA'
                    });
                    this.isPlaying = false;
                } else {
                    oxPlayer.pause();
                }
            },
            fnContinue: function () {
                if (this.isTouPing) {
                    var _this = this;
                    this.touPing.isPlay = true;
                    this.touPing.inter = setInterval(function () {
                        _this.touPing.currentPosition++;
                        if (_this.touPing.currentPosition >= _this.touPing.duration) clearInterval(_this.touPing.inter);
                    }, 1000);
                    api.sendEvent({
                        name: 'playDLNA'
                    });
                    this.isPlaying = true;
                } else {
                    oxPlayer.start();
                    this.isPlaying = true;
                }
            },
            ////////////点赞评论回复相关//////////////
            replySomeone: function (nickname, index) {
                this.commentLesson = false;
                this.replyInput.show = true;
                this.currentCommentIndex = index;
                this.replyInput.placeholder = '@' + nickname;
                this.inputFocus();
            },
            toDetail: function (cid, index) {
                api.openFrame({
                    name: 'lesson/lesson_comment',
                    url: './lesson_comment.html',
                    rect: {
                        x: 0,
                        y: this.currSectionId ? this.screenH + this.fixBar - 1 : this.fixBar,
                        w: 'auto',
                        h: this.currSectionId ? api.winHeight - this.screenH - this.fixBar - 1 : api.winHeight - this.fixBar
                    },
                    pageParam: {
                        commentId: cid,
                        commentIndex: index,
                        teacherId: this.lessonT.teacherid,
                        lessonId: id
                    }
                });
            },
            likeComment: function (cid, index) {
                var vm = this;
                api.ajax({
                    url: getSignUrl(xqwxt_url + '&do=comment&op=postPrize'),
                    method: 'post',
                    data: {
                        values: {
                            id: id,
                            commentType: 'comment',
                            commentId: cid,
                        }
                    }
                }, function (ret, err) {
                    if (ret && ret.errno == 0) {
                        if (ret.data.type == 0) {
                            vm.commentList[index].islike = false;
                            vm.commentList[index].prizenum--;
                        } else {
                            vm.commentList[index].islike = true;
                            vm.commentList[index].prizenum++;
                        }
                    } else {
                        vm.$toast('系统错误，请稍后重试~')
                    }
                });
            },
            sendComment: function () {
                var vm = this;
                if (this.commenting) return;
                this.commenting = true;
                api.ajax({ //评论课程
                    url: getSignUrl(xqwxt_url + '&do=comment&op=postComment'),
                    method: 'post',
                    data: {
                        values: {
                            id: id,
                            content: this.commentLesson ? this.commentInput.value : this.replyInput.value,
                            uploadFile: this.commentLesson ? this.commentInput.image : this.replyInput.image,
                            commentType: this.commentLesson ? 'comment' : 'reply',
                            commentId: this.commentLesson ? 0 : this.commentList[this.currentCommentIndex].id,
                        },
                    }
                }, function (ret, err) {
                    vm.commenting = false;
                    if (ret && ret.errno == 0) {
                        vm.$toast('评论成功');
                        if (vm.commentLesson) {
                            vm.commentList.unshift(ret.data.comment);
                            vm.countComment++;
                        } else {
                            if (!vm.commentList[vm.currentCommentIndex].reply) {
                                vm.commentList[vm.currentCommentIndex].reply = [];
                                vm.commentList[vm.currentCommentIndex].reply.push(ret.data.comment);
                            } else {
                                vm.commentList[vm.currentCommentIndex].reply.unshift(ret.data.comment);
                            }
                            vm.commentList[vm.currentCommentIndex].replynum++;
                        }
                    } else {
                        vm.$toast('评论失败');
                    }
                    vm.cancelInput();
                });
            },
            deleteComment: function (cid, index) {
                var vm = this;
                this.$dialog.confirm({
                    message: '确认删除评论吗？',
                    confirmButtonText: '删除',
                    confirmButtonColor: '#3388ff',
                    cancelButtonColor: '#666666'
                }).then(function () {
                    vm.ajaxPost(xqwxt_url + '&do=comment&op=deleteComment', {
                        id: id,
                        commentType: 'comment',
                        commentId: cid
                    }, function (vm, ret) {
                        vm.commentList.splice(index, 1);
                        vm.countComment--;
                    })
                }).catch(function () { });
            },
            insertImg: function (file) { ////上传图片
                if (this.commentLesson) {
                    this.commentInput.isImg = true;
                    this.commentInput.image = file.content;
                    this.inputFocus();
                } else {
                    this.replyInput.isImg = true;
                    this.replyInput.image = file.content;
                    this.inputFocus();
                }
            },
            clearImage: function () { //清除图片评论
                if (this.commentLesson) {
                    this.commentInput.isImg = false;
                    this.commentInput.image = '';
                    this.inputFocus();
                } else {
                    this.replyInput.isImg = false;
                    this.replyInput.image = '';
                    this.inputFocus();
                }
            },
            inputFocus: function () {
                var that = this;
                if (this.commentLesson) { //评论课程
                    this.commentInput.showOverlay = true;
                    setTimeout(function () {
                        var el = that.$refs.commentField;
                        el.focus();
                    }, 20);
                } else {
                    this.replyInput.showOverlay = true;
                    setTimeout(function () {
                        var el = that.$refs.replyField;
                        el.focus();
                    }, 20);

                }
            },
            cancelInput: function () {
                if (this.commentLesson) {
                    this.commentLesson = false;
                    this.commentInput = {
                        showOverlay: false,
                        value: '',
                        isImg: false,
                        image: '',
                        placeholder: '快来参与课程讨论吧'
                    }
                } else {
                    this.currentCommentIndex = '';
                    this.replyInput = {
                        showOverlay: false,
                        show: false,
                        value: '',
                        isImg: false,
                        image: '',
                        placeholder: '@'
                    }
                }
            },
            upImage: function (img) {
                api.openFrame({
                    name: 'lesson/previewImage',
                    url: '../lesson/previewImage.html',
                    rect: {
                        x: 0,
                        y: 0,
                        w: 'auto',
                        h: 'auto'
                    },
                    pageParam: {
                        img: img
                    },
                    bgColor: 'rgba(0,0,0,0)'
                })
            },
            replyEvaluate: function () {
                if (!this.valueReply) {
                    this.$toast('回复内容不能为空');
                    return;
                }
                this.ajaxPost(xqwxt_url + '&do=evaluate&op=reply', {
                    lessonid: id,
                    id: this.evaluateList[this.currentEvaluate].id,
                    reply: this.valueReply
                }, function (vm, ret) {
                    vm.$toast(ret.message);
                    vm.evaluateList[vm.currentEvaluate].reply = vm.valueReply;
                })
            },
            ////////下载相关/////////////
            initDown: function () {
                var vm = this;
                if (vm.lesson && vm.lesson.length) {
                    var temp2 = new Array;
                    Object.assign(temp2, vm.lesson);
                    for (var i = 0; i < vm.lesson.length; i++) {
                        if (vm.lesson[i]['section'] && vm.lesson[i]['section'].length) {
                            var temp = new Array;
                            Object.assign(temp, vm.lesson[i].section);
                            for (var k = 0; k < vm.lesson[i].section.length; k++) {
                                if (vm.lesson[i]['section'][k].tid > 0) {
                                    temp[k].status = -1;
                                    continue;
                                }
                                var params = {
                                    uid: uid,
                                    pid: id,
                                    sid: vm.lesson[i]['section'][k].id
                                }
                                var result = $download.select(params, '*');
                                if (result && result[0]) {
                                    temp[k].status = result[0]['status'];
                                    temp[k].is_cancel = result[0]['is_cancel'];
                                } else {
                                    temp[k].status = -1;
                                }
                            }
                            temp2[i].section = temp;
                        }
                    }
                    vm.lesson = temp2;
                }
            },
            initDownloadListener: function () {
                var vm = this;
                api.addEventListener({
                    name: 'lessonDowned'
                }, function (ret, err) {
                    if (ret && ret.value) {
                        vm.initDown();
                    }
                });
                api.addEventListener({
                    name: 'downRemoved'
                }, function (ret, err) {
                    if (ret) {
                        vm.initDown();
                    }
                });
                api.addEventListener({
                    name: 'addDownSuccess'
                }, function (ret, err) {
                    if (ret) {
                        vm.initDown();
                    }
                });
                api.addEventListener({
                    name: 'downFaild'
                }, function (ret, err) {
                    if (ret) {
                        vue.initDown();
                    }
                });
            },
            clickConsult: function (type) {
                var vm = this;
                this.consultShow = false;
                if (type == 'weixin') {
                    this.weixinimageshow = true;
                    api.addEventListener({
                        name: 'longpress'
                    }, function (ret, err) {
                        var resultList = api.hasPermission({
                            list: ['storage'],
                            code: 1
                        });
                        var flag = 0;
                        for(let i in resultList){
                            if(!resultList[i].granted){
                                flag=1
                                break
                            }
                        }
                        if (flag) {
                            vm.$dialog.confirm({
                                title: '提示',
                                message: '长按保存二维码图片,需要您授权存储权限',
                                confirmButtonText:'去授权',
                                confirmButtonColor:'#333'
                            }).then(() => {
                                vm.setPermission(function (param) {
                                    if (param) {
                                        api.download({
                                            url: vm.lessonT['weixin_qrcode'],
                                            savePath: 'fs://userimage/' + id + '_weixin_qrcode.jpg',
                                            report: true,
                                            cache: true,
                                            allowResume: true
                                        }, function (ret, err) {
                                            if (ret.state == 1) {
                                                api.saveMediaToAlbum({
                                                    path: 'fs://userimage/' + id + '_weixin_qrcode.jpg'
                                                }, function (ret, err) {
                                                    vm.weixinimageshow = false;
                                                    if (ret && ret.status) {
                                                        vm.$toast.success({
                                                            duration: 2000,
                                                            message: '已保存到系统相册',
                                                            forbidClick: true
                                                        })
                                                    } else {
                                                        vm.$toast('保存失败，请稍后重试');
                                                    }
                                                });
                                            } else {
                                                vm.$toast('保存失败，请稍后重试');
                                            }
                                        });
                                    } else {
                                        vm.$toast('无法获得存储权限，请在设置中打开应用的存储权限');
                                    }
                                })
                            })
                        }else{
                            vm.setPermission(function (param) {
                                if (param) {
                                    api.download({
                                        url: vm.lessonT['weixin_qrcode'],
                                        savePath: 'fs://userimage/' + id + '_weixin_qrcode.jpg',
                                        report: true,
                                        cache: true,
                                        allowResume: true
                                    }, function (ret, err) {
                                        if (ret.state == 1) {
                                            api.saveMediaToAlbum({
                                                path: 'fs://userimage/' + id + '_weixin_qrcode.jpg'
                                            }, function (ret, err) {
                                                vm.weixinimageshow = false;
                                                if (ret && ret.status) {
                                                    vm.$toast.success({
                                                        duration: 2000,
                                                        message: '已保存到系统相册',
                                                        forbidClick: true
                                                    })
                                                } else {
                                                    vm.$toast('保存失败，请稍后重试');
                                                }
                                            });
                                        } else {
                                            vm.$toast('保存失败，请稍后重试');
                                        }
                                    });
                                } else {
                                    vm.$toast('无法获得存储权限，请在设置中打开应用的存储权限');
                                }
                            })
                        }
                        
                    });
                } else if (type == 'qq') {
                    location.href = this.lessonT.qqhref
                } else {
                    location.href = this.lessonT.qqgroupLink
                }
            },
            clearListen: function () {
                this.weixinimageshow = false;
                api.removeEventListener({
                    name: 'longpress'
                });
            },
            favor: function () {
                var _this = this;
                mySendMessage(mysetting.routes.updateCollect, {
                    type: 'lesson',
                    id: id
                }, function (ret) {
                    if (ret.errno == 0) {
                        if (ret.data.result) {
                            _this.isCollect = true;
                            _this.$toast("收藏成功");
                        } else {
                            _this.isCollect = false;
                            _this.$toast("取消收藏");
                        }
                        api.sendEvent({
                            name: 'update_collect',
                        });
                    } else {
                        _this.$toast(ret.message);
                    }
                });
            },
            listen: function () {
                var _this = this;
                api.addEventListener({
                    name: 'commentPageShow'
                }, function (ret, err) {
                    if (ret && ret.value && ret.value.show) {
                        api.setWinAttr({
                            slidBackEnabled: false
                        });
                    } else {
                        api.setWinAttr({
                            slidBackEnabled: true
                        });
                    }
                })
                api.addEventListener({
                    name: 'buySuccess'
                }, function (ret, err) {
                    console.log(JSON.stringify(ret),916)
                    if (ret) {

                        _this.init();
                        _this.ajaxPost(xqwxt_url + '&do=mylesson&op=myplaylesson', {}, function (vm, ret2) {
                            localStorage.setItem('lessonListBuy', JSON.stringify(ret2.data));
                        })
                        api.sendEvent({
                            name: 'update_study',
                            extra: { index: 1 }
                        });
                    }
                })
                api.addEventListener({
                    name: 'commentDetail'
                }, function (ret, err) {
                    if (_this.replyDetail == true) {
                        _this.replyDetail = false;
                        return;
                    } else {
                        _this.closePage();
                    }
                })
                api.addEventListener({
                    name: 'rebootApp'
                }, function (ret, err) {
                    oxPlayer.remove();
                })
                api.addEventListener({
                    name: 'pauseApp'
                }, function (ret, err) {
                    oxPlayer.pause();
                })
                api.addEventListener({
                    name: 'resumeApp'
                }, function (ret, err) {
                    oxPlayer.start();
                })
                api.addEventListener({
                    name: 'evaluate_success'
                }, function (ret, err) {
                    if (ret) {
                        _this.allow_evaluate = 0;
                        _this.pageIndex[0] = 1;
                        _this.getEvaluateList(0);
                    }
                });
                api.addEventListener({
                    name: 'comment_delete'
                }, function (ret, err) {
                    if (ret && ret.value) {
                        _this.commentList.splice(ret.value.commentIndex, 1);
                        _this.countComment--
                    }
                });
                api.addEventListener({
                    name: 'reply_delete'
                }, function (ret, err) {
                    if (ret && ret.value) {
                        _this.commentList[ret.value.commentIndex].reply.splice(ret.value.replyIndex, 1);
                        _this.commentList[ret.value.commentIndex].replynum--
                    }
                });
                api.addEventListener({
                    name: 'searchResult'
                }, function (ret, err) {
                    if (ret && ret.value && ret.value.type == 'select') return;
                    var flag = false;
                    if (ret && ret.value && ret.value.result && _this.isTouPing) {
                        var list = JSON.parse(ret.value.data);
                        for (var i = 0; i < list.length; i++) {
                            if (list[i].name == localStorage.getItem('toupingName')) {
                                flag = true;
                                list[i].url = play_url;
                                api.sendEvent({
                                    name: 'startDLNA',
                                    extra: list[i]
                                })
                            }
                        }
                    }
                    if (!flag) {
                        _this.isTouPing = false;
                        oxPlayer.showPlay();
                        _this.openPage('lesson/lesson_touping', { url: play_url })
                    }
                });
           
                api.addEventListener({
                    name: 'connectResult'
                }, function (ret, err) {
                    if (ret && ret.value && ret.value.result) {
                        localStorage.setItem('toupingName', ret.value.name);
                        _this.isPlaying = true;
                        _this.isTouPing = true;
                        _this.touPing.name = localStorage.getItem('toupingName');
                        _this.touPing.status = 1;
                        _this.touPing.isPlay = true;
                        if (_this.touPing.inter) clearInterval(_this.touPing.inter);
                        for (var i = 0; i < _this.sectionList.length; i++) {
                            if (_this.sectionList[i].vid == _this.currSectionId) {
                                var time = _this.sectionList[i].videotime.split(':');
                                if (time.length == 1) {
                                    var time2 = parseInt(time[0]);
                                } else if (time.length == 2) {
                                    var time2 = parseInt(time[0]) * 60 + parseInt(time[1]);
                                } else if (time.length == 3) {
                                    var time2 = parseInt(time[0]) * 3600 + parseInt(time[1]) * 60 + parseInt(time[2]);
                                }
                                _this.touPing.duration = parseInt(time2);
                                break;
                            }
                        }
                        oxPlayer.position(function (ret3) {
                            if (ret3.code == 0) {
                                _this.touPing.currentPosition = parseInt(ret3.position / 1000);
                            }
                        });
                        _this.touPing.inter = setInterval(function () {
                            _this.touPing.currentPosition++;
                            if (_this.touPing.currentPosition >= _this.touPing.duration) clearInterval(_this.touPing.inter);
                        }, 1000);
                        oxPlayer.hidePlay();
                    } else {
                        _this.$toast('投屏失败，请重试');
                        _this.touPing.status = 2;
                    }
                });
                api.addEventListener({
                    name: 'changeResult'
                }, function (ret, err) {
                    if (ret && ret.value && ret.value.result) {
                        _this.touPing.isPlay = true;
                        if (_this.touPing.inter) clearInterval(_this.touPing.inter);
                        _this.touPing.duration = parseInt(ret.value.duration);
                        _this.touPing.currentPosition = parseInt(ret.value.process);
                        _this.touPing.inter = setInterval(function () {
                            _this.touPing.currentPosition++;
                            if (_this.touPing.currentPosition >= _this.touPing.duration) clearInterval(_this.touPing.inter);
                        }, 1000);
                    } else {
                        _this.$toast('切换地址失败，请重试');
                        _this.touPing.status = 3;
                    }
                });
            },
            changeTouping: function () {
                this.openPage('lesson/lesson_touping');
            },
            stop: function () {
                api.sendEvent({
                    name: 'stopDLNA'
                });
                this.isTouPing = false;
                this.touPing.status = 0;
                this.fnContinue();
                oxPlayer.showPlay();
            },
            seek: function (val) {
                var process = parseInt(val / 100 * this.touPing.duration);
                this.touPing.currentPosition = process;
                api.sendEvent({
                    name: 'seekDLNA',
                    extra: {
                        process: process
                    }
                });
            },
            //分享相关
            shareTo: function (index) {
                var _this = this;
                this.setPermission(function (param) {
                    mySendMessage('game.gameHandler.getShare', {
                        type: 'lesson',
                        lessonid: id,
                    }, function (data) {
                        if (data.errno == 0) {
                            if (param) {
                                api.download({
                                    url: data.data.shareInfo.image,
                                    report: false,
                                    cache: true,
                                    allowResume: false
                                }, function (ret, err) {
                                    if (ret && ret.state == 1) {
                                        data.data.shareInfo.image = ret.savePath;
                                        _this.shareInfo(data, index);
                                    } else {
                                        _this.shareInfo(data, index);
                                    }
                                });
                            } else {
                                _this.shareInfo(data, index);
                            }
                        } else {
                            _this.$toast(data.message);
                        }
                    });
                });

            },
            shareInfo: function (data, index) {
                if (index == 0) {
                    var wx = api.require('wxPlus');
                    wx.isInstalled(function (ret, err) {
                        if (!ret.installed) {
                            vue.$toast('当前设备未安装微信客户端~');
                        } else {
                            wx.shareWebpage({
                                scene: 'session',
                                title: data.data.shareInfo.title,
                                description: data.data.shareInfo.desc,
                                thumb: data.data.shareInfo.image,
                                contentUrl: data.data.shareInfo.link
                            }, function (ret, err) {
                            });
                        }
                    });
                } else if (index == 1) {
                    var wx = api.require('wxPlus');
                    wx.isInstalled(function (ret, err) {
                        if (!ret.installed) {
                            vue.$toast('当前设备未安装微信客户端~');
                        } else {
                            wx.shareWebpage({
                                scene: 'timeline',
                                title: data.data.shareInfo.title,
                                description: data.data.shareInfo.desc,
                                thumb: data.data.shareInfo.image,
                                contentUrl: data.data.shareInfo.link
                            }, function (ret, err) {

                            })
                        }
                    });
                } else if (index == 2) {
                    var qq = api.require('QQPlus');
                    qq.installed(function (ret, err) {
                        if (ret.status) {
                            qq.shareNews({
                                url: data.data.shareInfo.link,
                                title: data.data.shareInfo.title,
                                description: data.data.shareInfo.desc,
                                imgUrl: data.data.shareInfo.image,
                                type: 'QFriend'
                            }, function (ret, err) {

                            });
                        } else {
                            vue.$toast('当前设备未安装QQ客户端~');
                        }
                    });
                } else if (index == 3) {
                    var qq = api.require('QQPlus');
                    qq.installed(function (ret, err) {
                        if (ret.status) {
                            qq.shareNews({
                                url: data.data.shareInfo.link,
                                title: data.data.shareInfo.title,
                                description: data.data.shareInfo.desc,
                                imgUrl: data.data.shareInfo.image
                            }, function (ret, err) {

                            })
                        } else {
                            vue.$toast('当前设备未安装QQ客户端~');
                        }
                    });
                }
            },
            checkCamera: function () {
                var _this = this;
                var list = ['storage', 'camera'];
                this.setPermission(function (param) {
                    if (!param) {
                        _this.$toast('请在设置中打开应用的相机和存储权限');
                    }
                }, list);
            },
        }
    })
};