var optionInfo = [
    {
        name: 'leave',
        image: '../../assets/images/button/button_leave.png',
        image2: '../../assets/images/button/button_disabled_leave.png',
        isActive: true,
        times: 0
    }, {
        name: 'huiqi',
        image: "../../assets/images/button/button_huiqi.png",
        image2: "../../assets/images/button/button_disabled_huiqi.png",
        isActive: false,
        times: 3
    }, {
        name: 'renshu',
        image: '../../assets/images/button/button_lose.png',
        image2: '../../assets/images/button/button_disabled_lose.png',
        isActive: false,
        times: 0
    }, {
        name: 'qiuhe',
        image: '../../assets/images/button/button_he.png',
        image2: '../../assets/images/button/button_disabled_he.png',
        isActive: false,
        times: 3
    }, {
        name: 'setting',
        image: '../../assets/images/button/button_setting.png',
        image2: '../../assets/images/button/button_disabled_setting.png',
        isActive: true,
        times: 0
    },
];
var default_message = [
    { text: '阁下，神速些吧！', name: 'gexia' },
    { text: '稍等片刻，容我再思量思量！', name: 'shaodeng' },
    { text: '棋逢对手，将遇良才，痛快，痛快！', name: 'qifeng' },
    { text: '胜败乃兵家常事，再与我对弈一局？', name: 'shengbai' },
    { text: '呀！大意失荆州！', name: 'dayi' },
    { text: '一着不慎，满盘皆输！', name: 'yizhao' },
    { text: '宁失一子，不失一先！', name: 'ningshi' },
    { text: '当局者迷，旁观者清！', name: 'dangju' },
    { text: '观棋不语真君子，落子无悔大丈夫！', name: 'guanqi' },
    { text: '河界三分阔，智谋万丈深！', name: 'hejie' },
    { text: '得子得先方为胜，得子失先却是输！', name: 'dezi' },
    { text: '不思而应者，无谋之人，随手而下者，取败之道！', name: 'busi' },
    { text: '哈哈，小卒过河顶大车！', name: 'xiaozu' },
    { text: '单车难破士象全啊！', name: 'danche' },
    { text: '你这是，单车寡炮瞎胡闹！', name: 'guapao' },
    { text: '你这是，围棋盘里摆象棋，不对路数呀！', name: 'weiqi' },
    { text: '临杀勿急，稳中取胜！', name: 'linsha' },
    { text: '老将出马，一个顶俩！', name: 'laojiang' },
    { text: '死子勿急吃！', name: 'sizi' },
    { text: '赢棋不闹事！', name: 'yingqi' },
    { text: '哈哈，缺士怕双车！', name: 'queshi' },
    { text: '哈哈，一车十子寒！', name: 'yiche' },
    { text: '车怕低头将怕高！', name: 'chepa' },
    { text: '马退窝心，不死也昏！', name: 'matui' },
    { text: '马跳边，易被歼！', name: 'matiao' },
    { text: '马入宫，多遭凶！', name: 'maru' },
    { text: '摆上羊角士，不怕马来将！', name: 'baishang' },
    { text: '小卒坐大堂，将帅活不长！', name: 'datang' },
    { text: '开局炮胜马，残局马胜炮！', name: 'kaiju' },
    { text: '支错士，自找事！', name: 'zhicuo' },
    { text: '有炮须留他家士！', name: 'youpao' },
    { text: '三子归边一盘棋！', name: 'sanzi' },
    { text: '炮得势时兵换象，马得势时卒换士！', name: 'paodeshi' },
    { text: '防车攻宜补花士，防炮攻宜补顺士，防马攻宜补羊角士！', name: 'fangche' }
];
var default_message2 = [
    { text: '红棋胜！', name: 'message01' },
    { text: '黑棋胜！', name: 'message02' },
    { text: '和棋！', name: 'message03' },
];
var default_count = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10];
var soundPlayer = '';
var chessData = [];
var mixin_chess = {
    data: function () {
        return {
            gameResult: false,
            gameWin: false,
            gameLose: false,
            gameChecked: false,
            gameEat: false,
            gameError: false,
            gameStalemate: false,
            gameCheckmate: false,//页面效果：吃将杀等
            screenWidth: '',
            screenHeight: '',
            qipanLoading: true,
            redBlack: false,
            popupButtons: false,//左下角的五个按钮
            optionInfo: optionInfo,//左下角的五个按钮内容
            popupAnalyse: false,//对弈中的局势图
            analyseNum: parseInt(localStorage.getItem('analyseNum')),//对弈中的局势图展示次数
            popupSetting: false,//设置页面
            settingInfo: [
                // { name: '背景音乐', checked: true, type: 'bgm' },
                { name: '游戏音效', checked: true, type: 'sound' },
                // { name: '接收对方语音', checked: true, type: 'voice' },
                { name: '接收对方消息', checked: true, type: 'message' },
            ],
            popupMessage: 0,//发消息
            imgText: 'text',//消息类型
            messageContent: [],//消息内容
            inputValue: '',//输入内容
            defaultImg: [],
            pangguanList: [],
            pangguanPerson: 0,
            popupPangguan: false,
            favorChess: false,
            soundTog: true, //棋谱音效（开关）
            toastValue: '测试',
            toastShow: false,
            isFullScreen: false,
            pangguanInfos: 0,
            myChart2: '',
            dataX: [0],
            dataY: [0],
            iscontinue: false, //是否在游戏中
            message: [],
            pangguanMessage: {},
            qlcp_result: {
                winner: 1, //1红胜，2黑胜，3和局，
                steps: 0, //回合,
                time: 0, //结束时间
                reason: '', //原因
                fen: {},
                upgrade: {},
                memberinfo: {},
                chessid: 0,
                type: 1
            },
            chess_move_action: {},
            roomID: '', //为了分享的roomID
            isplaying: false, //为了确保用户在断线重连之后点了测评，网速慢导致二次加载界面
            forbiddenUid: [],
            role: null,
            chairId: null,
            current_user: null,
            playersInfo: [{}, {}],
            fileloaded: false, //js是否加载完毕
            move_step: '',
            temp_url: '../../assets/audio/',
            sound_type: 'man',
            soundList: [
                { id: 'select', src: 'select.mp3' },
                { id: 'drop', src: 'drop.mp3' },
                { id: 'gameWin', src: 'gameWin.mp3', type: 1 },
                { id: 'gameLose', src: 'gameLose.mp3', type: 1 },
                { id: 'gameEat', src: 'gameEat.mp3', type: 1 },
                { id: 'gameError', src: 'gameError.mp3', type: 1 },
                { id: 'gameChecked', src: 'gameChecked.mp3', type: 1 },
                { id: 'gameStalemate', src: 'gameStalemate.mp3', type: 1 },
                { id: 'gameCheckmate', src: 'gameCheckmate.mp3', type: 1 },
            ],
            byCreator: null,
            // howlerList: {},
            pageLoaded: false,
            chessWidth: '100%',
            showNetError:false,
            showNetErrorTimes:0,
        }
    },
    created: function () {
        soundPlayer = api.require('audioStreamer');
        this.getUserInfo();
        api.addEventListener({
            name: 'connected_net'
        }, function (ret, err) {
            if (vue) {
                vue.showNetError=false;
                vue.showNetErrorTimes=0;
            }
        });
        api.addEventListener({
            name: 'reconnectAttempt_net'
        }, function (ret, err) {
            if (vue) {
                vue.showNetError=true;
                vue.showNetErrorTimes++;
                var txBugly = api.require('txBugly');
                if (localStorage.getItem('userinfo')) {
                    var userinfo = JSON.parse(localStorage.getItem('userinfo'));
                    txBugly.setUserValue({
                        key:"uid",
                        value:userinfo.uid
                    })
                }
                txBugly.reportException({
                    name:'js-error',
                    reason:"断网记录"+ " 2024429版本:" + api.appVersion
                });
            }
        });
    },
    watch: {
        pageIndex: function () {
            this.resizeS();
        },
        memberinfo: function (val, oldVal) {
            if (val.uid != oldVal.uid) {
                if (this.memberinfo.gender == 2) {
                    this.sound_type = 'woman';
                }
                // for (var i = 0; i < this.soundList.length; i++) {
                //     if (!this.soundList[i].type) {
                //         this.howlerList[this.soundList[i].id] = new Howl({
                //             src: [this.temp_url + this.soundList[i].src]
                //         });
                //     }
                // }
                if (this.pageType == 'AI' && this.memberinfo.aiguanka > 5) {
                    this.can = 1
                }
                this.initValue();
            }
        },
        showNetErrorTimes:function (val, oldVal) {
            if (val > 2) {
                this.dialogType = dialog_reconnect;
                var txBugly = api.require('txBugly');
                if (localStorage.getItem('userinfo')) {
                    var userinfo = JSON.parse(localStorage.getItem('userinfo'));
                    txBugly.setUserValue({
                        key:"uid",
                        value:userinfo.uid
                    })
                }
                txBugly.reportException({
                    name:'js-error',
                    reason:"3次重试断网记录"+ " 2024429版本:" + api.appVersion
                });
            }
        }
    },
    computed: {
        circleColor: function () {
            return this.handleColor(0);
        },
        circleColor2: function () {
            return this.handleColor(1);
        },
        defaultContent: function () {
            if (this.role != 3) {
                return default_message;
            } else {
                return default_message2;
            }
        }
    },
    methods: {
        getPlayData: function () {
            mySendMessage(mysetting.routes.getPlayData, {}, function (data) {
                if (data.errno == 0 && data.data.playData) {
                    if (vue.pageType == 'hydz' && (data.data.roomType == 'hydz' || data.data.roomType == 'QS')) {
                        vue.pageType = data.data.roomType;
                        if (data.data.roomType == 'QS') {
                            vue.pageShareType = 'association';
                        } else {
                            vue.pageShareType = data.data.roomType;
                        }
                    }
                    if (data.data.playData.forbiddenUids && vue.forbiddenUid) {
                        vue.forbiddenUid = data.data.playData.forbiddenUids
                    }
                    if (data.data.role == 3) {
                        if (data.data.roomType == vue.pageType) {
                            if ((vue.pageType == 'hydz' || vue.pageType == 'QS') && !data.data.isplaying) {
                                vue.prepare(data.data, api.pageParam.role);
                            } else {
                                vue.scenePlay(data.data.playData, vue.roleStatus);
                            }
                        } else {
                            var name = '';
                            if (data.data.roomType == 'qlcp') name = 'play_chess/qlcp';
                            if (data.data.roomType == 'hydz' || data.data.roomType == 'QS') name = 'play_chess/create_room';
                            if (data.data.roomType == 'AI') name = 'play_chess/ai_test';
                            vue.openPage(name);
                        }
                    } else { //下棋状态
                        if (data.data.roomType == vue.pageType) {
                            if (vue.pageType == 'QS' || vue.pageType == 'hydz') {
                                vue.prepare(data.data);
                            } else {
                                vue.scenePlay(data.data.playData);
                            }
                        } else {
                            var name = '';
                            if (data.data.roomType == 'qlcp') name = 'play_chess/qlcp';
                            if (data.data.roomType == 'hydz' || data.data.roomType == 'QS') name = 'play_chess/create_room';
                            if (data.data.roomType == 'AI') name = 'play_chess/ai_test';
                            vue.openPage(name);
                        }
                    }
                } else {
                    if (vue.roomID && vue.roomID != '') {
                        if (vue.fileloaded) {
                            vue.qlcp_lookon(vue.roomID, api.pageParam.role, null, vue.byCreator);
                        } else {
                            vue.iscontinue = true;
                        }
                    } else {
                        if (vue.pageType == 'QS' || vue.pageType == 'hydz') {
                            vue.activeRule.show = true;
                            vue.readyBegin.show = true;
                        } else if (vue.pageType == 'AI') {
                            if (vue.num && vue.num != '') {
                                mySendMessage(mysetting.routes.inGuanka, {
                                    num: vue.num
                                }, function (data) {
                                    if (data.errno && data.errno != 0) {
                                        vue.$dialog.alert({
                                            title: '提醒',
                                            message: data.message,
                                            confirmButtonColor: '#3388ff'
                                        }).then(function () {
                                            vue.closePage();
                                        })
                                    } else {
                                        vue.isPassNum = true;
                                    }
                                });
                            } else {
                                vue.rebackHall();
                            }
                        } else if (vue.pageType == 'qlcp') {
                            vue.rebackHall();
                        }
                    }
                }
            });
        },
        initValue: function () {
            //设置设置里的状态信息
            for (var i = 0; i < this.settingInfo.length; i++) {
                var temp = this.settingInfo[i];
                this.settingInfo[i].checked = this.self_setting[temp.type] == 1 ? true : false;
                if (this.settingInfo[i].type == 'sound') {
                    this.self_setting[temp.type] == 1 ? voicemode = 1 : voicemode = 0;
                } else if (this.settingInfo[i].type == 'message') {
                    this.self_setting[temp.type] == 1 ? acceptMessage = 1 : acceptMessage = 0;
                }
            }
        },
        changeSwitch: function (item) {
            if (item.type == 'sound') {
                onSound();
            }
            if (item.type == 'message') {
                acceptMessage == 1 ? acceptMessage = 0 : acceptMessage = 1
            }
            var _this = this;
            mySendMessage(mysetting.routes.updateSetting, {
                type: item.type,
                value: item.checked ? 1 : 0
            }, function (data) {
                if (data.errno != 0) {
                    _this.$toast(data.message);
                }
            })
        }, //设置里面的音效调整
        send_message: function (item, name) {
            if (name) {
                var params = name;
            } else {
                var params = 0;
            }
            var mess = item ? item : this.inputValue;
            this.popupMessage = 0;
            this.inputValue = '';
            if (mess != '') {
                userChat(mess, params);
            }
        }, //对弈中发消息，带参数是发模板消息，不带参数是自定义文字
        favor: function () {
            var _this = this;
            mySendMessage(mysetting.routes.collect, {}, function (data) {
                if (data.errno == 0) {
                    _this.favorChess = data.data.isCollect;
                    if (_this.favorChess) {
                        _this.$toast('已预约收藏棋谱');
                    } else {
                        _this.$toast('已取消预约');
                    }
                } else {
                    _this.$toast(data.message);
                }
            })
        }, //旁观里面的取消收藏棋谱,收藏和取消收藏统一以后端数据为准
        stopMessage: function (uid) {
            var _this = this;
            mySendMessage(mysetting.routes.forbidden, {
                forbiddenUid: uid
            }, function (data) {
                if (data.errno == 0) {
                    if (data.data.isForbidden) {
                        _this.forbiddenUid.push(uid);
                    } else {
                        for (var i = 0; i < _this.forbiddenUid.length; i++) {
                            if (_this.forbiddenUid[i] == uid) {
                                _this.forbiddenUid.splice(i, 1);
                            }
                        }
                    }
                } else {
                    _this.$toast(data.message);
                }
            });
        },//禁言
        onTime: function () {
            var _this = this;
            if (!!qlcp_timeer) {
                clearInterval(qlcp_timeer);
                qlcp_timeer = null;
            }
            if (!qlcp_timeer) {
                qlcp_timeer = setInterval(function () {
                    if (vue.role != 3) {
                        if (vue.chairId == _this.current_user) {
                            _this.player_times[1].steptime--;
                            _this.player_times[1].gametime--;
                            if (_this.player_times[1].steptime <= 10 && _this.player_times[1].steptime > 0) {
                                comm.soundplay('count' + _this.player_times[1].steptime, 'count');
                            }
                        } else {
                            _this.player_times[0].gametime--;
                            _this.player_times[0].steptime--;
                            if (_this.player_times[0].steptime <= 10 && _this.player_times[0].steptime > 0) {
                                comm.soundplay('count' + _this.player_times[0].steptime, 'count');
                            }
                        }
                    } else {
                        if (isVerticalReverse == 1) {
                            if (_this.current_user != 0) {
                                _this.player_times[1].steptime--;
                                _this.player_times[1].gametime--;
                                if (_this.player_times[1].steptime <= 10 && _this.player_times[1].steptime > 0) {
                                    comm.soundplay('count' + _this.player_times[1].steptime, 'count');
                                }
                            } else {
                                _this.player_times[0].steptime--;
                                _this.player_times[0].gametime--;
                                if (_this.player_times[0].steptime <= 10 && _this.player_times[0].steptime > 0) {
                                    comm.soundplay('count' + _this.player_times[0].steptime, 'count');
                                }
                            }
                        } else {
                            if (_this.current_user == 0) {
                                _this.player_times[1].steptime--;
                                _this.player_times[1].gametime--;
                                if (_this.player_times[1].steptime <= 10 && _this.player_times[1].steptime > 0) {
                                    comm.soundplay('count' + _this.player_times[1].steptime, 'count');
                                }
                            } else {
                                _this.player_times[0].steptime--;
                                _this.player_times[0].gametime--;
                                if (_this.player_times[0].steptime <= 10 && _this.player_times[0].steptime > 0) {
                                    comm.soundplay('count' + _this.player_times[0].steptime, 'count');
                                }
                            }
                        }
                    }
                }, 1000);
            }
        },
        cancelTime: function () {
            if (!!qlcp_timeer) {
                clearInterval(qlcp_timeer);
                qlcp_timeer = null
            }
        },
        exchange: function () {
            //正在走棋过程不能翻转
            if (vue.role != 3 || comm.isAnimating) {
                return;
            }
            isVerticalReverse ? (isVerticalReverse = 0, chessBottomLayer.removeChild(verticalReverseboard), chessBottomLayer.addChildAt(board, 0)) :
                (isVerticalReverse = 1, chessBottomLayer.removeChild(board), chessBottomLayer.addChildAt(verticalReverseboard, 0));
            vue.roleStatus=isVerticalReverse;
            // comm.map = arrReverse(comm.map);
            // comm.initChessBymap(comm.map);
            hidePane();
            hideLight();
            if (comm.nodes.length < movesIndex || movesIndex === comm.nodes.length-1){
            if (vue.move_step) {
                    //console.log(JSON.stringify(vue.move_step));
                vue.move_step = reverseStep(vue.move_step);
                showPane(vue.move_step[0], vue.move_step[1]);
                showLight(vue.move_step[2], vue.move_step[3]);
                }
            }else {
                if (comm.nodes[movesIndex]){
                   // console.log(JSON.stringify(comm.nodes));
                    let reverseStep1 = reverseStep(comm.nodes[movesIndex].step);
                    showPane(reverseStep1[0], reverseStep1[1]);
                    showLight(reverseStep1[2], reverseStep1[3]);
                }
            }
            var temp = this.exchangeAB(this.playersInfo);
            this.$set(this.playersInfo, 0, temp[0]);
            this.$set(this.playersInfo, 1, temp[1]);
            this.player_times = this.exchangeAB(this.player_times);
            this.player_status = this.exchangeAB(this.player_status);
            this.player_status[1].currentRate = this.player_times[1].steptime / this.player_status[1].total_time * 100;
            this.player_status[0].currentRate = this.player_times[0].steptime / this.player_status[0].total_time * 100;
            comm.reverseMoves();
            comm.map = arrReverse(comm.map);
            comm.cMap = arrReverse(comm.cMap);
            cleanChess();
            comm.init(comm.map, !0);
            chessAnalyseShape();
        },//旁观上下颠倒
        exchangeAB: function (data) {
            var temp = data[0];
            data[0] = data[1];
            data[1] = temp;
            return data;
        },//数组交换
        handleColor: function (index) {
            var step_time, total_time;
            if (index == 0) {
                step_time = this.player_times[0].steptime;
                total_time = this.player_status[0].total_time
            } else {
                step_time = this.player_times[1].steptime;
                total_time = this.player_status[1].total_time
            }
            if (step_time < 10) {
                return '#ff4444'
            } else if ((step_time / total_time) >= 0.66) {
                return '#47C843'
            } else if ((step_time / total_time) >= 0.33) {
                return 'rgb(230,128,60)'
            } else {
                return '#ff4444'
            }
        },
        init: function () {
            var loader = new createjs.LoadQueue(false);
            loader.on("fileload", this.handleFileLoad);
            loader.on("error", this.handleError);
            loader.on("complete", this.handleComplete);
            loader.loadFile({ src: "../../script/util/ZobristTable.js" });
            loader.loadFile({ src: "../../script/lib/echarts.min.js" });
            loader.loadFile({ src: "../../script/lib/easeljs.min.js", id: 'Easeljs' });
            loader.loadFile({ src: "../../script/lib/tweenjs.min.js" });
            loader.loadFile({ src: "../../script/lib/MovieClip.js" });
            // loader.loadFile({ src: "../../script/lib/soundjs.min.js" });
            loader.loadFile({ src: "../../script/Model.js" });
            loader.loadFile({ src: "../../script/Control_chess.js?version=610" });
            loader.loadFile({ src: "../../script/View.js" });
            loader.loadFile({ src: "../../script/Control.js" });
            loader.loadFile({ src: "../../script/Player.js" });
            loader.loadFile({ src: "../../script/Chess.js" });
            loader.loadFile({ src: "../../script/lib/gameRes.js" });
            loader.loadManifest([
                { src: "../../assets/images/board.png", id: "Board", loadTimeout: 20000 },
                { src: "../../assets/images/border1.png", id: "Border1", loadTimeout: 20000 },
                { src: "../../assets/images/border2.png", id: "Border2", loadTimeout: 20000 },
                { src: "../../assets/images/vertical1.png", id: "Vertical1", loadTimeout: 20000 },
                { src: "../../assets/images/vertical2.png", id: "Vertical2", loadTimeout: 20000 }
            ]);
        }, //初始化加载资源
        handleFileLoad: function (evt) {
            if (evt.item.type == "image") {
                images[evt.item.id] = evt.result;
            }
            if (evt.item.id == 'Easeljs') {
                chessList = new createjs.SpriteSheet(CHESS_SLIM);
                effectList = new createjs.SpriteSheet(F_ATLAS);
            }
        },
        handleError: function (evt) {
            this.$toast('play preload err');
        },
        initChart2: function () {
            var _this = this;
            if (_this.pageIndex == 1) {
                this.myChart2 = echarts.init(document.getElementById('analyse_map'));
            } else {
                this.myChart2 = echarts.init(document.getElementById('situation_map'));
            }
            option = {
                tooltip: {
                    trigger: 'axis',
                    padding: [0, 5],
                    borderWidth: 0,
                    backgroundColor: '#6B4A2B',
                    textStyle: {
                        color: '#ffffff'
                    },
                    axisPointer: {
                        animation: false,
                        type: 'line',
                        lineStyle: {
                            color: '#6B4A2B',
                            type: 'solid',
                            fontSize: 8,
                            width: 1
                        }
                    },
                    extraCssText: 'z-index: 2',
                    alwaysShowContent: true,
                    position: function (point, params, dom, rect, size) {
                        // 固定在顶部
                        var wid = size.viewSize[0] * 0.92 - size.contentSize[0];
                        if (point[0] > wid) {
                            return [point[0] - size.contentSize[0] - 5, 0];
                        } else {
                            return [point[0] + 5, 0];
                        }
                    },
                    formatter: function (params) {
                        var option = _this.myChart2.getOption();
                        var temp = 0;
                        var temp2 = '';
                        var temp_val = option.series[0].data[params[0].dataIndex];
                        if (temp_val > 0) {
                            temp = Math.round(10 * Math.pow(5, temp_val / 10000));
                            if (temp > 0 && temp <= 100) {
                                temp2 = '红略优';
                            } else if (temp > 100 && temp <= 300) {
                                temp2 = '红优';
                            } else if (temp > 300 && temp <= 600) {
                                temp2 = '红大优';
                            } else if (temp > 600 && temp <= 29000) {
                                temp2 = '红胜势';
                            } else if (temp > 29000 && temp <= 29999) {
                                temp2 = '红杀棋';
                            } else {
                                temp2 = '红胜';
                            }
                        } else if (temp_val == 0) {
                            temp = 0;
                            temp2 = '均势';
                        } else {
                            temp = Math.round(10 * Math.pow(5, (-temp_val) / 10000));
                            if (temp > 0 && temp <= 100) {
                                temp2 = '黑略优';
                            } else if (temp > 100 && temp <= 300) {
                                temp2 = '黑优';
                            } else if (temp > 300 && temp <= 600) {
                                temp2 = '黑大优';
                            } else if (temp > 600 && temp <= 29000) {
                                temp2 = '黑胜势';
                            } else if (temp > 29000 && temp <= 29999) {
                                temp2 = '黑杀棋';
                            } else {
                                temp2 = '黑胜';
                            }
                        }
                        return Math.ceil(params[0].dataIndex / 2) + '-' + temp2 + '(' + temp + ')';
                    },
                },
                grid: {
                    left: '2%',
                    right: '3%',
                    bottom: '2%',
                    top: '3%',
                    containLabel: true
                },
                xAxis: {
                    type: 'category',
                    data: _this.dataX,
                    boundaryGap: false,
                    axisTick: false,
                    splitLine: {
                        show: true,
                        interval: 9,
                        lineStyle: {
                            color: '#5A422B',
                            opacity: 0.2
                        }
                    },
                    axisLine: {
                        lineStyle: {
                            color: '#5A422B'
                        }
                    },
                    axisLabel: {
                        interval: function (index, value) {
                            if (vue.dataX.length <= 46) {
                                if (index % 2 == 0) {
                                    return true;
                                } else {
                                    return false;
                                }
                            } else if (vue.dataX.length <= 91) {
                                if (index % 4 == 0) {
                                    return true;
                                } else {
                                    return false;
                                }
                            } else if (vue.dataX.length <= 136) {
                                if (index % 6 == 0) {
                                    return true;
                                } else {
                                    return false;
                                }
                            } else if (vue.dataX.length <= 181) {
                                if (index % 8 == 0) {
                                    return true;
                                } else {
                                    return false;
                                }
                            } else if (vue.dataX.length <= 226) {
                                if (index % 10 == 0) {
                                    return true;
                                } else {
                                    return false;
                                }
                            } else {
                                if (index % 20 == 0) {
                                    return true;
                                } else {
                                    return false;
                                }
                            }
                        },
                        color: '#5A422B',
                        fontSize: 10,
                        margin: 3,
                        formatter: function (value) {
                            return Math.ceil(value / 2)
                        }
                    },
                },
                yAxis: {
                    type: 'value',
                    splitLine: {
                        lineStyle: {
                            color: '#5A422B',
                            opacity: 0.2
                        }
                    },
                    axisTick: false,
                    axisLine: {
                        lineStyle: {
                            color: '#5A422B'
                        }
                    },
                    axisLabel: {
                        color: '#5A422B',
                        margin: 3,
                        fontSize: 10,
                        formatter: function (value, index) {
                            var temp = Math.abs(value);
                            if (value > 0) {
                                temp = 10 * Math.round(Math.pow(5, value / 10000));
                            } else if (value == 0) {
                                temp = 0;
                            } else {
                                temp = '-' + 10 * Math.round(Math.pow(5, -value / 10000));
                            }
                            return temp;
                        }
                    }
                },
                series: [{
                    name: '等级分',
                    type: 'line',
                    data: _this.dataY,
                    lineStyle: {
                        color: '#6B4A2B',
                        width: 2
                    },
                    hoverAnimation: false,
                    itemStyle: {
                        color: '#6B4A2B',

                    },
                    symbolSize: 0,
                    emphasis: { // hover状态折线显示
                        scale: false,
                        lineStyle: {
                            color: '#6B4A2B',
                            width: 2
                        }
                    },
                    markLine: {
                        silent: true,
                        symbol: 'none',
                        lineStyle: {
                            type: 'solid',
                            color: '#9e8267'
                        },
                        data: [{
                            xAxis: 20,
                            label: {
                                show: false,
                            }
                        }],
                        animation: false,
                    },
                    markPoint: {
                        silent: true,
                        symbolSize: 0.1,
                        data: [{
                            xAxis: 20,
                            y: '10%',
                            label: {
                                textStyle: { color: '#fff' },
                                padding: [2, 4],
                                fontSize: 10,
                                fontFamily: 'DIN-Medium',
                                borderRadius: 2,
                                backgroundColor: 'rgba(90, 66, 43, .8)',
                                position: 'right',
                                distance: 2,
                                formatter: '10(中局)'
                            }
                        }],
                        animation: false,
                    }
                }],
            };
            _this.myChart2.setOption(option, true);
            if (this.pageIndex==3){
                _this.clickChart();
            }
        },//旁观局势图
        onClick: function () {
            var _this = this;
            if (!this.myChart2) {
                cleanChess();
                if (isVerticalReverse) {
                    comm.cMap=arrReverse(InitMap);
                    comm.init(arrReverse(InitMap));
                }else {
                    comm.cMap=InitMap;
                    comm.init(InitMap);
                }
                var m = comm.parseMovesEx(chessData);
                if (m[0]) {
                    comm.searchNodes(0);
                    if (vue.move_step) {
                        showPane(vue.move_step[0], vue.move_step[1]);
                        showLight(vue.move_step[2], vue.move_step[3]);
                    }
                }
                setTimeout(function () {
                    _this.initChart2();
                    _this.changeToolTip(0, vue.dataY.length - 1);
                }, 30);
            } else {
                setTimeout(function () {
                    _this.myChart2.resize();
                    _this.changeToolTip(0, _this.dataY.length - 1);
                }, 30)
            }
        },//旁观默认显示聊天，点击后显示局势图
        changeToolTip: function (seriesIndex, dataIndex) {
            var _this = this;
            setTimeout(function () {
                if (_this.myChart2) {
                    _this.myChart2.dispatchAction({
                        type: 'showTip',
                        seriesIndex: seriesIndex,
                        dataIndex: dataIndex
                    });
                }
            }, 1);
        },
        clickChart: function () { //点击折线图的任意位置
            var _this = this;
            if (this.myChart2) {
                this.myChart2.getZr().on('mousemove', function (params) { //点击操作
                    if (_this.mode == 1) {
                        _this.$toast('局势图加载中，请稍后');
                        return;
                    }
                    var op = _this.myChart2.getOption();
                    //console.log("op"+JSON.stringify(op));
                    var pointInPixel = [params.offsetX, params.offsetY];
                    if (_this.myChart2.containPixel('grid', pointInPixel)) {
                        var xIndex=movesIndex;
                        if (_this.myChart2.convertFromPixel({ seriesIndex: 0 }, pointInPixel)){
                            xIndex = _this.myChart2.convertFromPixel({ seriesIndex: 0 }, pointInPixel)[0]; //X轴序号
                        }
                        //获得图表中我们想要的数据
                        // if (params.target && params.target.parent && params.target.parent._seriesModel && params.target.parent._seriesModel.seriesIndex != _this.seriesIndex) {
                        //     onClickChart(xIndex, _this.branchList[params.target.parent._seriesModel.seriesIndex].ID[xIndex]);
                        // } else {
                        if (movesIndex == xIndex) return;
                       // console.log("isVerticalReverse"+isVerticalReverse);
                        onClickChart(xIndex,1);
                        _this.getGuideMove(xIndex);
                        //console.log("isVerticalReverse222"+isVerticalReverse);
                        // }
                    }
                });
            }
        },
        resizeS: function () {
            var _this = this;
            this.screenWidth = document.body.clientWidth > 768 ? 768 : document.body.clientWidth;
            this.screenHeight = document.body.clientHeight - this.fixBar - this.fixBottom;
            if (this.pageIndex == 0 || this.pageIndex == 1) {
                if (this.screenHeight - 130 > 83 / 72 * this.screenWidth) {
                    this.chessWidth = this.screenWidth;
                } else {
                    this.chessWidth = (this.screenHeight - 130) / 83 * 72;
                }
            } else if (this.pageIndex == 3) {
                if (this.screenHeight - 220 > 83 / 72 * this.screenWidth * 0.74) {
                    this.chessWidth = this.screenWidth * 0.74;
                } else {
                    this.chessWidth = (this.screenHeight - 220) / 83 * 72;
                }
            } else if (this.pageIndex == 2) {
                if ((this.screenHeight - 350) / 83 * 72 > this.screenWidth && this.screenWidth * 0.8 < (this.screenHeight - 350) / 83 * 72 * 0.8) {
                    this.chessWidth = this.screenWidth * 0.8;
                } else {
                    this.chessWidth = (this.screenHeight - 350) / 83 * 72 * 0.8;
                }
            } else if (this.pageIndex == 5) {
                if (this.screenHeight - 50 > 102 / 72 * this.screenWidth) {
                    this.chessWidth = this.screenWidth;
                } else {
                    this.chessWidth = (this.screenHeight - 50) / 102 * 72;
                }
            }
            if (this.myChart) {
                setTimeout(function () {
                    _this.myChart.resize();
                }, 30)
            }
            if (this.myChart2) {
                setTimeout(function () {
                    _this.myChart2.resize();
                }, 30)
            }
        }, //页面尺寸变化函数
        getGuideMove:function (index) {
            var a = {};
            --index;
            a.type = "practice";
            a.movesIndex = index ;
            a.robot_setting = { level: "17", caltime: "0", kaiju: "1|20,20" };
            a.params = { currentId: index };
            if (index > 0) {
                a.board = moves[index - 1].currentFen;
                if (index > 1) {
                    a.prev_board = moves[index - 2].currentFen;
                } else {
                    a.prev_board = comm.nodes[0].currentFen;
                }
                if (isVerticalReverse) {
                    var temp_step = reverseStep(moves[index - 1].step);
                } else {
                    var temp_step = moves[index - 1].step;
                }
                a.move_chess_data = comm.Step2FT(temp_step);
            } else {
                a.board = comm.nodes[0].currentFen;
                a.prev_board = null;
                a.move_chess_data = null;
            }
            console.log(JSON.stringify(a))
            mySendMessage(mysetting.routes.getBestMove, a, function (data) {
                console.log(JSON.stringify(data));
                if (data.errno != 0) {
                    toastDisplay(data.message);
                } else {

                }
            });
        } 
    },
    filters: {
        formatDate: function (time) {
            if (!time && time != 0) {
                return '';
            }
            var minter = parseInt(time / 60);
            var miao = time - minter * 60;
            minter = minter.toString().length == 1 ? 0 + "" + minter : minter;
            miao = miao.toString().length == 1 ? 0 + "" + miao : miao;
            return minter + ":" + miao;
        }
    }
}
var default_img = [
    { name: 'face-01', url: '../../assets/emoji/face-01.png' },
    { name: 'face-02', url: '../../assets/emoji/face-02.png' },
    { name: 'face-03', url: '../../assets/emoji/face-03.png' },
    { name: 'face-04', url: '../../assets/emoji/face-04.png' },
    { name: 'face-05', url: '../../assets/emoji/face-05.png' },
    { name: 'face-06', url: '../../assets/emoji/face-06.png' },
    { name: 'face-07', url: '../../assets/emoji/face-07.png' },
    { name: 'face-08', url: '../../assets/emoji/face-08.png' },
    { name: 'face-09', url: '../../assets/emoji/face-09.png' },
    { name: 'face-10', url: '../../assets/emoji/face-10.png' },
    { name: 'face-11', url: '../../assets/emoji/face-11.png' },
    { name: 'face-12', url: '../../assets/emoji/face-12.png' },
    { name: 'face-13', url: '../../assets/emoji/face-13.png' },
    { name: 'face-14', url: '../../assets/emoji/face-14.png' },
    { name: 'face-15', url: '../../assets/emoji/face-15.png' },
    { name: 'face-16', url: '../../assets/emoji/face-16.png' },
    { name: 'face-17', url: '../../assets/emoji/face-17.png' },
    { name: 'face-18', url: '../../assets/emoji/face-18.png' },
    { name: 'face-19', url: '../../assets/emoji/face-19.png' },
    { name: 'face-20', url: '../../assets/emoji/face-20.png' },
    { name: 'face-21', url: '../../assets/emoji/face-21.png' },
    { name: 'hand-01', url: '../../assets/emoji/hand-01.png' },
    { name: 'hand-02', url: '../../assets/emoji/hand-02.png' },
    { name: 'hand-03', url: '../../assets/emoji/hand-03.png' },
    { name: 'hand-04', url: '../../assets/emoji/hand-04.png' },
    { name: 'hand-05', url: '../../assets/emoji/hand-05.png' },
    { name: 'hand-06', url: '../../assets/emoji/hand-06.png' },
    { name: 'hand-07', url: '../../assets/emoji/hand-07.png' },
    { name: 'hand-08', url: '../../assets/emoji/hand-08.png' },
    { name: 'others-01', url: '../../assets/emoji/others-01.png' },
    { name: 'others-02', url: '../../assets/emoji/others-02.png' },
    { name: 'others-03', url: '../../assets/emoji/others-03.png' },
    { name: 'others-04', url: '../../assets/emoji/others-04.png' },
    { name: 'others-05', url: '../../assets/emoji/others-05.png' },
    { name: 'others-06', url: '../../assets/emoji/others-06.png' },
    { name: 'others-07', url: '../../assets/emoji/others-07.png' },
    { name: 'others-08', url: '../../assets/emoji/others-08.png' },
    { name: 'others-09', url: '../../assets/emoji/others-09.png' },
    { name: 'others-10', url: '../../assets/emoji/others-10.png' },
    { name: 'kitten-01', url: '../../assets/emoji/kitten-01.png' },
    { name: 'kitten-02', url: '../../assets/emoji/kitten-02.png' },
    { name: 'kitten-03', url: '../../assets/emoji/kitten-03.png' },
    { name: 'kitten-04', url: '../../assets/emoji/kitten-04.png' },
    { name: 'kitten-05', url: '../../assets/emoji/kitten-05.png' },
    { name: 'kitten-06', url: '../../assets/emoji/kitten-06.png' },
    { name: 'kitten-07', url: '../../assets/emoji/kitten-07.png' },
    { name: 'kitten-08', url: '../../assets/emoji/kitten-08.png' },
    { name: 'kitten-09', url: '../../assets/emoji/kitten-09.png' },
    { name: 'kitten-10', url: '../../assets/emoji/kitten-10.png' },
]